#!/usr/bin/perl

use Getopt::Std;
getopts('d:');

$filelist = '.filelist';
$dir_head = 'MG';

if( $opt_d ){
    $OutDir = $opt_d;
}else{
    print "\n";
    print "directory ? : ";
    chomp( $OutDir = <STDIN> );
}

# directory check
unless( -d $OutDir ){
    print "\n\n";
    print "No such directory!\n\n";
    exit;
}

if( $OutDir =~ /^\s*\.\// || $OutDir =~ /^\s*[^\.\/]+/ || $OutDir =~ /^\s*\.\s*$/ ){
    print "directory must be outside of this package!\n\n";
    exit;
}

$OutDir = $OutDir . '/' . $dir_head;
if( -e $OutDir ){
    print "$OutDir is already existed\n\n";
    exit;
}

print "\n\n";
print "making package...\n";

open( LIST, $filelist ) || die "cannot open filelist\n";
mkdir( $OutDir, 0755 );
while( <LIST> ){
    chomp;
    next if ( /^\.$/ );

    if( -d $_ ){
	$dir = $OutDir . '/' . $_;
	mkdir( $dir, 0755 );

    }elsif( -e $_ ){
	$file = $OutDir . '/' . $_;
	system( "cp -rdp $_ $file" );

    }else{
	print "$_ is not found.\n";
    }
}
