integer function FuncAreaStat( stacks, MaxStacks, mode, no )
  use RPN
  implicit none
  integer        , intent(IN)    :: MaxStacks
  type(RPN_STACK), intent(INOUT) :: stacks(MaxStacks)
  integer        , intent(IN)    :: mode
  integer        , intent(IN)    :: no

  integer :: i
  integer :: j
  integer :: k
  integer :: t
  integer :: iv
  integer :: ip
  integer :: ipc
  integer :: ipc_max
  integer :: ico

  integer :: ic
  integer :: ix
  integer :: jx
  integer :: ijx
  integer :: kx
  integer :: it

  real :: rid
  real :: rtmp
  real :: rtmp2

  integer, dimension(:,:), allocatable :: idx
  real   , dimension(:,:), allocatable :: table

  FuncAreaStat = RPN_FUNC_OPE_ERROR

  ic = stacks(1)%current

  if( no < 0 ) return
  if( ic < no+2 ) return
  if( mode == 3 ) then
     if( ic < no+3 ) return
     ico = 1
  else
     ico = 0
  end if

  ix = stacks(ic-ico-1)%ix
  jx = stacks(ic-ico-1)%jx
  kx = stacks(ic-ico-1)%kx
  it = stacks(ic-ico-1)%it

  if(    stacks(ic)%ix /= ix .or. &
       & stacks(ic)%jx /= jx .or. &
       & stacks(ic)%kx /=  1 .or. &
       & stacks(ic)%it /=  1 ) return

  do i = ic-ico-no, ic-ico-2
     if(    stacks(i)%ix /= ix .or.                    &
          & stacks(i)%jx /= jx .or.                    &
          & stacks(i)%kx /= kx .or.                    &
          & stacks(i)%it /= it      ) return
  end do

  ! memory allocate
  ijx = ix * jx
  allocate( table(ijx,6) )
  allocate(   idx(ix,jx) )

  iv      = ic-ico
  ipc_max = 0
  idx(1:ix,1:jx) = -1
  do j = 1, jx
     do i = 1, ix
        if( stacks(iv)%val(i,j,1,1) /= stacks(iv)%undef ) then
           do ip = 1, ipc_max
              if( abs( stacks(iv)%val(i,j,1,1) - table(ip,1) ) < 1.e-4 ) then
                 idx(i,j) = ip
              end if
           end do
           if( idx(i,j) < 0 ) then
              ipc_max          = ipc_max + 1
              table(ipc_max,1) = stacks(iv)%val(i,j,1,1)
              idx(i,j)         = ipc_max
           end if
        else
           idx(i,j) = 0
        end if
     end do
  end do

  ! area average  (mode=1)
  !      variance (mode=2)
  !      minimum  (mode=4)
  !      maximum  (mode=5)
  if( mode == 1 .or. mode == 2 .or. mode == 4 .or. mode == 5 ) then
     do iv = ic-no, ic-1
        do t = 1, it
           do k = 1, kx
              table(1:ijx,2:4) = 0.
              table(1:ijx,5)   =  1.e+35
              table(1:ijx,6)   = -1.e+35

              do j = 1, jx
                 do i = 1, ix
                    if( stacks(iv)%val(i,j,k,t) == stacks(iv)%undef ) cycle
                    if( idx(i,j) == 0 ) cycle

                    rtmp = stacks(iv)%val(i,j,k,t)

                    ipc = idx(i,j)

                    table(ipc,2) = table(ipc,2) + rtmp
                    table(ipc,3) = table(ipc,3) + rtmp * rtmp
                    table(ipc,4) = table(ipc,4) + 1.0

                    if( rtmp < table(ipc,5) ) table(ipc,5) = rtmp
                    if( rtmp > table(ipc,6) ) table(ipc,6) = rtmp

                 end do
              end do

              do ipc = 1, ipc_max
                 if( table(ipc,4) > 0. ) then
                    rtmp  = table(ipc,2) / table(ipc,4)
                    rtmp2 = table(ipc,3) / table(ipc,4)

                    table(ipc,2) = rtmp
                    table(ipc,3) = rtmp2 - rtmp * rtmp

                    if( table(ipc,3) < 0. ) table(ipc,3) = 0.

                 else
                    table(ipc,2) = stacks(iv)%undef
                    table(ipc,3) = stacks(iv)%undef
                 end if
              end do

              do j = 1, jx
                 do i = 1, ix
                    if( idx(i,j) /= 0 ) then
                       if( mode == 1 .or. mode == 2 ) then
                          stacks(iv)%val(i,j,k,t) = table(idx(i,j),mode+1)
                       else if( mode == 4 .or. mode == 5 ) then
                          if( abs(table(idx(i,j),mode+1)) < 1.e+30 ) then
                             stacks(iv)%val(i,j,k,t) = table(idx(i,j),mode+1)
                          else
                             stacks(iv)%val(i,j,k,t) = stacks(iv)%undef
                          end if
                       end if
                    else
                       stacks(iv)%val(i,j,k,t) = stacks(iv)%undef
                    end if
                 end do
              end do

           end do
        end do
     end do

     call RPN_ClearStacks( stacks, MaxStacks )

  ! area weighted average
  else if( mode == 3 ) then

     do iv = ic-no-1, ic-2
        do t = 1, it
           do k = 1, kx
              table(1:ijx,2:4) = 0.

              do j = 1, jx
                 do i = 1, ix
                    if( stacks(iv)%val(i,j,k,t) == stacks(iv)%undef ) cycle
                    if( stacks(ic)%val(i,j,1,1) == stacks(ic)%undef ) cycle
                    if( stacks(ic)%val(i,j,1,1) < 0. ) cycle
                    if( idx(i,j) == 0 ) cycle

                    rtmp = stacks(iv)%val(i,j,k,t)

                    ipc = idx(i,j)


                    table(ipc,2) = table(ipc,2) + rtmp * stacks(ic)%val(i,j,1,1)
                    table(ipc,4) = table(ipc,4) + stacks(ic)%val(i,j,1,1)

                 end do
              end do

              do ipc = 1, ipc_max
                 if( table(ipc,4) > 0. ) then
                    table(ipc,2) = table(ipc,2) / table(ipc,4)
                 else
                    table(ipc,2) = stacks(iv)%undef
                 end if
              end do

              do j = 1, jx
                 do i = 1, ix
                    if( idx(i,j) /= 0 ) then
                       stacks(iv)%val(i,j,k,t) = table(idx(i,j),2)
                    else
                       stacks(iv)%val(i,j,k,t) = stacks(iv)%undef
                    end if

                 end do
              end do

           end do
        end do
     end do

     call RPN_ClearStacks( stacks, MaxStacks )
     call RPN_ClearStacks( stacks, MaxStacks )
  end if

  deallocate( table )

  FuncAreaStat = RPN_NOERROR


  return
end function FuncAreaStat
