integer function FuncAverageGrid( stacks, MaxStacks, mode, mode2, no )
  use RPN
  implicit none
  integer        , intent(IN)    :: MaxStacks
  type(RPN_STACK), intent(INOUT) :: stacks(MaxStacks)
  integer        , intent(IN)    :: mode
  integer        , intent(IN)    :: mode2
  integer        , intent(IN)    :: no

  integer :: ic, iv, m, i1, i2, j1, j2, cnt
  integer :: i, j, k, t, ii, jj, ip, im, jp, jm
  integer :: ix, jx, kx, it, loop
  real    :: dis
  real    :: rtmp
  real    :: dx
  real    :: dy

  real, dimension(:,:), allocatable :: tmp

  FuncAverageGrid = RPN_FUNC_OPE_ERROR

  ic = stacks(1)%current
  m  = stacks(ic)%model

  if( no < 0 ) return
  if( ic < no+1 ) return

  ix = stacks(ic)%ix
  jx = stacks(ic)%jx
  kx = stacks(ic)%kx
  it = stacks(ic)%it

  ! 1-2-1 smoothing
  if( mode == 1 ) then

     allocate( tmp(ix,jx) )
     do iv = ic-no+1, ic
        if( stacks(iv)%ix /= ix .or. stacks(iv)%jx /= jx ) then
           ix = stacks(iv)%ix
           jx = stacks(iv)%jx
           if( allocated( tmp ) ) deallocate( tmp )
           allocate( tmp(ix,jx) )
        end if
        kx = stacks(iv)%kx
        it = stacks(iv)%it

        do loop = 1, mode2
           do t = 1, it
              do k = 1, kx

                 do j = 1, jx
                    do i = 2, ix-1
                       if(    stacks(iv)%val(i+1,j,k,t) /= stacks(iv)%undef .and. &
                            & stacks(iv)%val(i  ,j,k,t) /= stacks(iv)%undef .and. &
                            & stacks(iv)%val(i-1,j,k,t) /= stacks(iv)%undef ) then
                          tmp(i,j) = 0.25 *                                &
                               &          ( 2. * stacks(iv)%val(i  ,j,k,t) &
                               &               + stacks(iv)%val(i+1,j,k,t) &
                               &               + stacks(iv)%val(i-1,j,k,t) )
                       else
                          tmp(i,j) = stacks(iv)%val(i,j,k,t)
                       end if
                    end do
                    tmp(1 ,j) = stacks(iv)%val(1 ,j,k,t)
                    tmp(ix,j) = stacks(iv)%val(ix,j,k,t)
                 end do

                 do i = 1, ix
                    do j = 2, jx-1
                       if(    tmp(i,j+1) /= stacks(iv)%undef .and. &
                            & tmp(i,j  ) /= stacks(iv)%undef .and. &
                            & tmp(i,j-1) /= stacks(iv)%undef ) then
                          stacks(iv)%val(i,j,k,t) =                    &
                               & 0.25 * ( 2. * tmp(i,j)                &
                               &             + tmp(i,j+1) + tmp(i,j-1) )
                       else
                          stacks(iv)%val(i,j,k,t) = tmp(i,j)
                       end if
                    end do
                    stacks(iv)%val(i,1 ,k,t) = tmp(i,1 )
                    stacks(iv)%val(i,jx,k,t) = tmp(i,jx)
                 end do

              end do
           end do
        end do

     end do
     
  ! area averaging
  else if( mode == 2 ) then
     allocate( tmp(ix,jx) )
     do iv = ic-no+1, ic
        if( stacks(iv)%ix /= ix .or. stacks(iv)%jx /= jx ) then
           ix = stacks(iv)%ix
           jx = stacks(iv)%jx
           if( allocated( tmp ) ) deallocate( tmp )
           allocate( tmp(ix,jx) )
        end if
        kx = stacks(iv)%kx
        it = stacks(iv)%it

        do t = 1, it
           do k = 1, kx
              do j = 1, jx
                 jp = mode2 / 2
                 jm = mode2 / 2 - mod( mode2-1, 2 )

                 j1 = max( 1 , j-jm )
                 j2 = min( jx, j+jp )
                 do i = 1, ix
                    ip = mode2 / 2
                    im = mode2 / 2 - mod( mode2-1, 2 )

                    i1 = max( 1 , i-im )
                    i2 = min( ix, i+ip )
                    
                    cnt      = 0
                    tmp(i,j) = 0.
                    do jj = j1, j2
                       do ii = i1, i2
                          if( stacks(iv)%val(ii,jj,k,t) /= stacks(iv)%undef ) then
                             tmp(i,j) = tmp(i,j) + stacks(iv)%val(ii,jj,k,t)
                             cnt      = cnt + 1
                          end if
                       end do
                    end do

                    if( cnt > 0 ) then
                       tmp(i,j) = tmp(i,j) / cnt
                    else
                       tmp(i,j) = stacks(iv)%undef
                    end if

                 end do
              end do

              if( mod( mode2, 2 ) == 0 ) then
                 do j = 1, jx
                    j1 = max(  1, j-1 )
                    j2 = j
                    do i = 1, ix
                       i1 = max(  1, i-1 )
                       i2 = i

                       cnt  = 0
                       rtmp = 0.
                       if( tmp(i1,j1) /= stacks(iv)%undef ) then
                          rtmp = rtmp + tmp(i1,j1)
                          cnt  = cnt + 1
                       end if
                       if( tmp(i2,j1) /= stacks(iv)%undef ) then
                          rtmp = rtmp + tmp(i2,j1)
                          cnt  = cnt + 1
                       end if
                       if( tmp(i2,j2) /= stacks(iv)%undef ) then
                          rtmp = rtmp + tmp(i2,j2)
                          cnt  = cnt + 1
                       end if
                       if( tmp(i1,j2) /= stacks(iv)%undef ) then
                          rtmp = rtmp + tmp(i1,j2)
                          cnt  = cnt + 1
                       end if

                       if( cnt > 0 ) then
                          stacks(iv)%val(i,j,k,t) = rtmp / cnt
                       else
                          stacks(iv)%val(i,j,k,t) = stacks(iv)%undef
                       end if
                    end do
                 end do

              else
                 stacks(iv)%val(:,:,k,t) = tmp(:,:)
              end if

           end do
        end do

     end do

  ! circle area averaging ( grid based )
  else if( mode == 12 ) then
     allocate( tmp(ix,jx) )
     do iv = ic-no+1, ic
        if( stacks(iv)%ix /= ix .or. stacks(iv)%jx /= jx ) then
           ix = stacks(iv)%ix
           jx = stacks(iv)%jx
           if( allocated( tmp ) ) deallocate( tmp )
           allocate( tmp(ix,jx) )
        end if
        kx = stacks(iv)%kx
        it = stacks(iv)%it

        dis = real(mode2) / 2.0

        do t = 1, it
           do k = 1, kx
              do j = 1, jx
                 jp = mode2 / 2
                 jm = mode2 / 2 - mod( mode2-1, 2 )

                 j1 = max( 1 , j-jm )
                 j2 = min( jx, j+jp )
                 do i = 1, ix
                    ip = mode2 / 2
                    im = mode2 / 2 - mod( mode2-1, 2 )

                    i1 = max( 1 , i-im )
                    i2 = min( ix, i+ip )
                    
                    cnt      = 0
                    tmp(i,j) = 0.
                    do jj = j1, j2
                       do ii = i1, i2

                          if( stacks(iv)%val(ii,jj,k,t) /= stacks(iv)%undef ) then
                             dx = real( ii - i )
                             dy = real( jj - j )
                             rtmp = sqrt( dx*dx + dy*dy )
                             if( rtmp > dis ) cycle
                             tmp(i,j) = tmp(i,j) + stacks(iv)%val(ii,jj,k,t)
                             cnt      = cnt + 1
                          end if
                       end do
                    end do

                    if( cnt > 0 ) then
                       tmp(i,j) = tmp(i,j) / cnt
                    else
                       tmp(i,j) = stacks(iv)%undef
                    end if

                 end do
              end do

              if( mod( mode2, 2 ) == 0 ) then
                 do j = 1, jx
                    j1 = max(  1, j-1 )
                    j2 = j
                    do i = 1, ix
                       i1 = max(  1, i-1 )
                       i2 = i

                       cnt  = 0
                       rtmp = 0.
                       if( tmp(i1,j1) /= stacks(iv)%undef ) then
                          rtmp = rtmp + tmp(i1,j1)
                          cnt  = cnt + 1
                       end if
                       if( tmp(i2,j1) /= stacks(iv)%undef ) then
                          rtmp = rtmp + tmp(i2,j1)
                          cnt  = cnt + 1
                       end if
                       if( tmp(i2,j2) /= stacks(iv)%undef ) then
                          rtmp = rtmp + tmp(i2,j2)
                          cnt  = cnt + 1
                       end if
                       if( tmp(i1,j2) /= stacks(iv)%undef ) then
                          rtmp = rtmp + tmp(i1,j2)
                          cnt  = cnt + 1
                       end if

                       if( cnt > 0 ) then
                          stacks(iv)%val(i,j,k,t) = rtmp / cnt
                       else
                          stacks(iv)%val(i,j,k,t) = stacks(iv)%undef
                       end if
                    end do
                 end do

              else
                 stacks(iv)%val(:,:,k,t) = tmp(:,:)
              end if

           end do
        end do

     end do

  ! pick up maximum value
  else if( mode == 3 ) then
     allocate( tmp(ix,jx) )
     do iv = ic-no+1, ic
        if( stacks(iv)%ix /= ix .or. stacks(iv)%jx /= jx ) then
           ix = stacks(iv)%ix
           jx = stacks(iv)%jx
           if( allocated( tmp ) ) deallocate( tmp )
           allocate( tmp(ix,jx) )
        end if
        kx = stacks(iv)%kx
        it = stacks(iv)%it

        do t = 1, it
           do k = 1, kx
              do j = 1, jx
                 jp = mode2 / 2
                 jm = mode2 / 2 - mod( mode2-1, 2 )

                 j1 = max( 1 , j-jm )
                 j2 = min( jx, j+jp )
                 do i = 1, ix
                    ip = mode2 / 2
                    im = mode2 / 2 - mod( mode2-1, 2 )

                    i1 = max( 1 , i-im )
                    i2 = min( ix, i+ip )
                    
                    cnt      = 0
                    tmp(i,j) = stacks(iv)%undef
                    do jj = j1, j2
                       do ii = i1, i2
                          if( stacks(iv)%val(ii,jj,k,t) &
                               & /= stacks(iv)%undef ) then
                             if( cnt == 0 ) then
                                tmp(i,j) = stacks(iv)%val(ii,jj,k,t)
                             else if( stacks(iv)%val(ii,jj,k,t) > tmp(i,j) ) then
                                tmp(i,j) = stacks(iv)%val(ii,jj,k,t)
                             end if
                             cnt = cnt + 1
                          end if
                       end do
                    end do

                 end do
              end do

              stacks(iv)%val(:,:,k,t) = tmp(:,:)
           end do
        end do

     end do

  ! pick up minimum value
  else if( mode == 4 ) then
     allocate( tmp(ix,jx) )
     do iv = ic-no+1, ic
        if( stacks(iv)%ix /= ix .or. stacks(iv)%jx /= jx ) then
           ix = stacks(iv)%ix
           jx = stacks(iv)%jx
           if( allocated( tmp ) ) deallocate( tmp )
           allocate( tmp(ix,jx) )
        end if
        kx = stacks(iv)%kx
        it = stacks(iv)%it

        do t = 1, it
           do k = 1, kx
              do j = 1, jx
                 jp = mode2 / 2
                 jm = mode2 / 2 - mod( mode2-1, 2 )

                 j1 = max( 1 , j-jm )
                 j2 = min( jx, j+jp )
                 do i = 1, ix
                    ip = mode2 / 2
                    im = mode2 / 2 - mod( mode2-1, 2 )

                    i1 = max( 1 , i-im )
                    i2 = min( ix, i+ip )
                    
                    cnt      = 0
                    tmp(i,j) = stacks(iv)%undef
                    do jj = j1, j2
                       do ii = i1, i2
                          if( stacks(iv)%val(ii,jj,k,t) &
                               & /= stacks(iv)%undef ) then
                             if( cnt == 0 ) then
                                tmp(i,j) = stacks(iv)%val(ii,jj,k,t)
                             else if( stacks(iv)%val(ii,jj,k,t) < tmp(i,j) ) then
                                tmp(i,j) = stacks(iv)%val(ii,jj,k,t)
                             end if
                             cnt = cnt + 1
                          end if
                       end do
                    end do

                 end do
              end do

              stacks(iv)%val(:,:,k,t) = tmp(:,:)
           end do
        end do

     end do
  end if

  if( allocated( tmp ) ) deallocate( tmp )

  FuncAverageGrid = RPN_NOERROR

  return
end function FuncAverageGrid
