integer function FuncBpass( stacks, MaxStacks, low, high )
  use RPN
  implicit none
  integer        , intent(IN)    :: MaxStacks
  type(RPN_STACK), intent(INOUT) :: stacks(MaxStacks)
  real           , intent(IN)    :: low
  real           , intent(IN)    :: high

  integer :: i
  integer :: j
  integer :: k
  integer :: t
  integer :: ic
  integer :: ix
  integer :: jx
  integer :: kx
  integer :: it

  real :: r
  real :: dx
  real :: dy

  logical :: lpass
  logical :: hpass

  FuncBpass = RPN_FUNC_OPE_ERROR

  ic = stacks(1)%current
  if( ic < 3 ) return

  ix = stacks(ic)%ix
  jx = stacks(ic)%jx
  kx = stacks(ic)%kx
  it = stacks(ic)%it
  if(    stacks(ic-1)%ix /= ix .or.                                       &
       & stacks(ic-1)%jx /= jx .or.                                       &
       & stacks(ic-1)%kx /= kx .or.                                       &
       & stacks(ic-1)%it /= it ) return

  lpass = .true.
  hpass = .true.
  if( low  == RPN_Undefined ) lpass = .false.
  if( high == RPN_Undefined ) hpass = .false.

  do t = 1, it
     do k = 1, kx
        do j = 1, jx/2
           do i = 1, ix/2
              dx = real( i - 1 )
              dy = real( j - 1 )
              r  = sqrt( dx*dx + dy*dy )

              ! low-pass filter
              if( lpass .and. r > low ) then
                 stacks(ic)%val(i,j,k,t) = 0.0
                 stacks(ic-1)%val(i,j,k,t) = 0.0
                 stacks(ic)%val(i,jx-j+1,k,t) = 0.0
                 stacks(ic-1)%val(i,jx-j+1,k,t) = 0.0
                 stacks(ic)%val(ix-i+1,jx-j+1,k,t) = 0.0
                 stacks(ic-1)%val(ix-i+1,jx-j+1,k,t) = 0.0
                 stacks(ic)%val(ix-i+1,j,k,t) = 0.0
                 stacks(ic-1)%val(ix-i+1,j,k,t) = 0.0
              end if

              ! high-pass filter
              if( hpass .and. r < high ) then
                 stacks(ic)%val(i,j,k,t) = 0.0
                 stacks(ic-1)%val(i,j,k,t) = 0.0
                 stacks(ic)%val(i,jx-j+1,k,t) = 0.0
                 stacks(ic-1)%val(i,jx-j+1,k,t) = 0.0
                 stacks(ic)%val(ix-i+1,jx-j+1,k,t) = 0.0
                 stacks(ic-1)%val(ix-i+1,jx-j+1,k,t) = 0.0
                 stacks(ic)%val(ix-i+1,j,k,t) = 0.0
                 stacks(ic-1)%val(ix-i+1,j,k,t) = 0.0
              end if

           end do
        end do
     end do
  end do

  FuncBpass = RPN_NOERROR

  return
end function FuncBpass
