integer function FuncConvH3D( stacks, MaxStacks, FuncArg )
  use RPN
  use ModelInfo
  implicit none
  integer         , intent(IN)    :: MaxStacks
  type(RPN_STACK) , intent(INOUT) :: stacks(MaxStacks)
  character(len=*), intent(IN)    :: FuncArg

  integer :: v, m, clen, ic
  integer :: i, j, k, t
  integer :: ix, jx, kx, it
  real, dimension(:,:,:,:), allocatable :: val

  FuncConvH3D = RPN_FUNC_OPE_ERROR
  ic = stacks(1)%current

  if( FuncArg(1:1) == '' ) then
     m = stacks(ic)%model
     ix = MODEL(m)%ix
     jx = MODEL(m)%jx
     kx = MODEL(m)%kx
     it = stacks(ic)%it

  else
     clen = len_trim( FuncArg )
     OUT: do i = 1, MODEL(1)%TotalInfo
        do v = 1, MODEL(i)%TotalVariables
           if( FuncArg(1:clen)//' ' == MODEL(i)%Vinfo(v)%name(1:clen+1) ) then
              m = i
              ix = MODEL(m)%Vinfo(v)%ix
              jx = MODEL(m)%Vinfo(v)%jx
              kx = MODEL(m)%Vinfo(v)%kx
              it = MODEL(m)%Vinfo(v)%it
              exit OUT
           end if
        end do
     end do OUT
  end if

  allocate( val(ix,jx,kx,it) )

  do t = 1, it
     do k = 1, kx
        do j = 1, jx
           do i = 1, ix
              val(i,j,k,t) = stacks(ic)%val(i,j,1,t)
           end do
        end do
     end do
  end do

  stacks(ic)%kx   = kx
!  stacks(ic)%olev = MODLE(m)%olev
!  if( associated( stacks(ic)%olev ) ) nullify( stacks(ic)%olev )
  if( associated( stacks(ic)%olev ) ) deallocate( stacks(ic)%olev )
  allocate( stacks(ic)%olev(kx) )
  do k = 1, MODEL(m)%kx
     stacks(ic)%olev(k) = MODEL(m)%lev(k)
  end do

!  if( associated( stacks(ic)%val ) ) nullify( stacks(ic)%val )
  if( associated( stacks(ic)%val ) ) deallocate( stacks(ic)%val )
  allocate( stacks(ic)%val(ix,jx,kx,it) )
  do t = 1, it
     do k = 1, kx
        do j = 1, jx
           do i = 1, ix
              stacks(ic)%val(i,j,k,t) = val(i,j,k,t)
           end do
        end do
     end do
  end do
  
  FuncConvH3D = RPN_NOERROR

  deallocate( val )
  return
end function FuncConvH3D
