integer function FuncConvZ3D( stacks, MaxStacks, FuncArg )
  use RPN
  use ModelInfo
  implicit none
  integer         , intent(IN)    :: MaxStacks
  type(RPN_STACK) , intent(INOUT) :: stacks(MaxStacks)
  character(len=*), intent(IN)    :: FuncArg

  integer :: v, m, clen, Ctime
  integer :: i, j, k, t
  integer :: ix, jx, kx, it
  real, dimension(:,:,:,:), allocatable :: val

  FuncConvZ3D = RPN_FUNC_OPE_ERROR

  if( FuncArg(1:1) == '' ) then
     m = 1
     ix = MODEL(m)%ix
     jx = MODEL(m)%jx
     kx = MODEL(m)%kx
     it = MODEL(m)%it

  else
     clen = len_trim( FuncArg )
     OUT: do i = 1, MODEL(1)%TotalInfo
        do v = 1, MODEL(i)%TotalVariables
           if( FuncArg(1:clen)//' ' == MODEL(i)%Vinfo(v)%name(1:clen+1) ) then
              m = i
              ix = MODEL(m)%Vinfo(v)%ix
              jx = MODEL(m)%Vinfo(v)%jx
              kx = MODEL(m)%Vinfo(v)%kx
              it = MODEL(m)%Vinfo(v)%it
              exit OUT
           end if
        end do
     end do OUT
  end if

  allocate( val(ix,jx,kx,it) )

  do t = 1, it
     do k = 1, kx
        do j = 1, jx
           do i = 1, ix
              val(i,j,k,t) = MODEL(m)%lev(k)
           end do
        end do
     end do
  end do

  if( m == 1 ) then
     Ctime = Model_t
  else
     Ctime = -1
     if(    Model(m)%Tinfo(1)%cdate(1:1) == 's' .or. &
          & Model(m)%Tinfo(1)%cdate(1:1) == 'S' ) then
        Ctime = 1
     else
        do t = 1, it
           if( MODEL(1)%Tinfo(Model_t)%cdate == MODEL(m)%Tinfo(t)%cdate ) then
              Ctime = t
              exit
           end if
        end do
     end if
     if( Ctime < 0 ) return
  end if

  FuncConvZ3D = RPN_PushStack( stacks, MaxStacks,                     &
       &                   val, ix, jx, kx, it,                       &
       &                   MODEL(m)%Undef, model=m, olev=MODEL(m)%lev, &
       &                   cdate=MODEL(m)%Tinfo(Ctime)%cdate )

  deallocate( val )
  return
end function FuncConvZ3D
