integer function FuncCount( stacks, MaxStacks, mode, low, high, mode2, no )
  use RPN
  implicit none
  integer        , intent(IN)    :: MaxStacks
  type(RPN_STACK), intent(INOUT) :: stacks(MaxStacks)
  integer        , intent(IN)    :: mode
  real           , intent(IN)    :: low
  real           , intent(IN)    :: high
  integer        , intent(IN)    :: mode2
  integer        , intent(IN)    :: no

  integer :: ic, ico
  integer :: i, j, k, t, n, ix, jx, kx, it
  integer :: jp, jm, j1, j2, ii, jj, ip, im, i1, i2
  logical :: equal, inside, ref

  real, allocatable, dimension(:,:) :: tmp

  FuncCount = RPN_FUNC_OPE_ERROR

  ic = stacks(1)%current
  jp = mode2 / 2
  jm = mode2 / 2 - mod( mode2-1, 2 )
  ip = jp
  im = jm

  if( abs(mode) / 10 == 1 ) then
     equal = .false.
  else
     equal = .true.
  end if

  if( mode > 0 ) then
     inside = .true.
  else
     inside = .false.
  end if

  if( mod( abs( mode ), 10 ) == 1 ) then
     ref = .false.
  else
     ref = .true.
  end if

  if( ref .and. ic < 2+no ) return
  if( ic < 1+no ) return

  ix = stacks(ic)%ix
  jx = stacks(ic)%jx
  kx = stacks(ic)%kx
  it = stacks(ic)%it

  if( ref ) then
     do n = 1, no
        if(    ix /= stacks(ic-n)%ix .or. &
             & jx /= stacks(ic-n)%jx .or. &
             & kx /= stacks(ic-n)%kx .or. &
             & it /= stacks(ic-n)%it       ) return
     end do
  end if

  if( ref ) then
     ico = ic - 1
  else
     ico = ic
  end if

  allocate( tmp(ix,jx) )

  if( low == RPN_Undefined .and. high == RPN_Undefined ) then
     if( inside ) then
        do n = 0, no-1
           do t = 1, it
              do k = 1, kx

                 do j = 1, jx
                    j1 = max(  1, j-jm )
                    j2 = min( jx, j+jp )

                    do i = 1, ix
                       i1 = max(  1, i-im )
                       i2 = min( ix, i+ip )

                       tmp(i,j) = 0
                       do jj = j1, j2
                          do ii = i1, i2
                             if( stacks(ico-n)%val(ii,jj,k,t) /= &
                                  & stacks(ico-n)%undef ) then
                                tmp(i,j) = tmp(i,j) + 1
                             end if
                          end do
                       end do
                    end do

                 end do
                 stacks(ico-n)%val(:,:,k,t) = tmp(:,:)
              end do

           end do
        end do
     end if

  else if( low == RPN_Undefined ) then
     if( inside ) then
        if( equal ) then
           do n = 0, no-1
              do t = 1, it
                 do k = 1, kx

                    do j = 1, jx
                       j1 = max(  1, j-jm )
                       j2 = min( jx, j+jp )

                       do i = 1, ix
                          i1 = max(  1, i-im )
                          i2 = min( ix, i+ip )

                          tmp(i,j) = 0
                          do jj = j1, j2
                             do ii = i1, i2
                                if( stacks(ic)%val(ii,jj,k,t) /= &
                                     & stacks(ic)%undef .and. &
                                     & stacks(ic)%val(ii,jj,k,t) <= high ) then
                                   tmp(i,j) = tmp(i,j) + 1
                                end if
                             end do
                          end do

                       end do
                    end do
                    stacks(ico-n)%val(1:ix,1:jx,k,t) = tmp(1:ix,1:jx)
                 end do

              end do
           end do

        else
           do n = 0, no-1
              do t = 1, it
                 do k = 1, kx

                    do j = 1, jx
                       j1 = max(  1, j-jm )
                       j2 = min( jx, j+jp )
                       do i = 1, ix
                          i1 = max(  1, i-im )
                          i2 = min( ix, i+ip )

                          tmp(i,j) = 0
                          do jj = j1, j2
                             do ii = i1, i2
                                if( stacks(ic)%val(ii,jj,k,t) /= &
                                     & stacks(ic)%undef .and. &
                                     & stacks(ic)%val(ii,jj,k,t) < high ) then
                                   tmp(i,j) = tmp(i,j) + 1
                                end if
                             end do
                          end do

                       end do
                    end do
                    stacks(ico-n)%val(1:ix,1:jx,k,t) = tmp(1:ix,1:jx)
                 end do

              end do
           end do
        end if

     else
        if( equal ) then
           
           do n = 0, no-1
              do t = 1, it
                 do k = 1, kx
                    do j = 1, jx
                       j1 = max(  1, j-jm )
                       j2 = min( jx, j+jp )

                       do i = 1, ix
                          i1 = max(  1, i-im )
                          i2 = min( ix, i+ip )

                          tmp(i,j) = 0
                          do ii = i1, i2
                             do jj = j1, j2
                                if( stacks(ic)%val(ii,jj,k,t) /= &
                                     & stacks(ic)%undef .and. &
                                     & stacks(ic)%val(ii,jj,k,t) >= high ) then
                                   tmp(i,j) = tmp(i,j) + 1
                                end if
                             end do
                          end do
                       end do
                    end do
                    stacks(ico-n)%val(1:ix,1:jx,k,t) = tmp(1:ix,1:jx)
                 end do

              end do
           end do

        else
           do n = 0, no-1
              do t = 1, it
                 do k = 1, kx
                    do j = 1, jx
                       j1 = max(  1, j-jm )
                       j2 = min( jx, j+jp )

                       do i = 1, ix
                          i1 = max(  1, i-im )
                          i2 = min( ix, i+ip )
                          tmp(i,j) = 0

                          do jj = j1, j2
                             do ii = i1, i2
                                if( stacks(ic)%val(ii,jj,k,t) /= &
                                     & stacks(ic)%undef .and. &
                                     & stacks(ic)%val(ii,jj,k,t) > high ) then
                                   tmp(i,j) = tmp(i,j) + 1
                                end if
                             end do
                          end do

                       end do
                    end do
                    stacks(ico-n)%val(1:ix,1:jx,k,t) = tmp(1:ix,1:jx)
                 end do

              end do
           end do
        end if
     end if

  else if( high == RPN_Undefined ) then
     if( inside ) then
        if( equal ) then
           do n = 0, no-1
              do t = 1, it
                 do k = 1, kx
                    do j = 1, jx
                       j1 = max(  1, j-jm )
                       j2 = min( jx, j+jp )

                       do i = 1, ix
                          i1 = max(  1, i-im )
                          i2 = min( ix, i+ip )
                          tmp(i,j) = 0

                          do jj = j1, j2
                             do ii = i1, i2
                                if( stacks(ic)%val(ii,jj,k,t) /= &
                                     & stacks(ic)%undef .and. &
                                     & stacks(ic)%val(ii,jj,k,t) >= low ) then
                                   tmp(i,j) = tmp(i,j) + 1
                                end if
                             end do
                          end do

                       end do
                    end do
                    stacks(ico-n)%val(1:ix,1:jx,k,t) = tmp(1:ix,1:jx)
                 end do

              end do
           end do

        else
           do n = 0, no-1
              do t = 1, it
                 do k = 1, kx
                    do j = 1, jx
                       j1 = max(  1, j-jm )
                       j2 = min( jx, j+jp )

                       do i = 1, ix
                          i1 = max(  1, i-im )
                          i2 = min( ix, j+ip )
                          tmp(i,j) = 0

                          do jj = j1, j2
                             do ii = i1, i2
                                if( stacks(ic)%val(ii,jj,k,t) /= &
                                     & stacks(ic)%undef .and. &
                                     & stacks(ic)%val(ii,jj,k,t) > low ) then
                                   tmp(i,j) = tmp(i,j) + 1
                                end if
                             end do
                          end do

                       end do
                    end do
                    stacks(ico-n)%val(1:ix,1:jx,k,t) = tmp(1:ix,1:jx)
                 end do

              end do
           end do
        end if

     else
        if( equal ) then
           do n = 0, no-1
              do t = 1, it
                 do k = 1, kx
                    do j = 1, jx
                       j1 = max(  1, j-jm )
                       j2 = min( jx, j+jp )

                       do i = 1, ix
                          i1 = max(  1, i-im )
                          i2 = min( ix, i+ip )
                          tmp(i,j) = 0

                          do jj = j1, j2
                             do ii = i1, i2
                                if( stacks(ic)%val(ii,jj,k,t) /= &
                                     & stacks(ic)%undef .and. &
                                     & stacks(ic)%val(ii,jj,k,t) <= low ) then
                                   tmp(i,j) = tmp(i,j) + 1
                                end if
                             end do
                          end do

                       end do
                    end do
                    stacks(ico-n)%val(1:ix,1:jx,k,t) = tmp(1:ix,1:jx)
                 end do

              end do
           end do

        else
           do n = 0, no-1
              do t = 1, it
                 do k = 1, kx
                    do j = 1, jx
                       j1 = max(  1, j-jm )
                       j2 = min( jx, j+jp )

                       do i = 1, ix
                          i1 = max(  1, i-im )
                          i2 = min( ix, i+ip )
                          tmp(i,j) = 0

                          do jj = j1, j2
                             do ii = i1, i2
                                if( stacks(ic)%val(ii,jj,k,t) /= &
                                     & stacks(ic)%undef .and. &
                                     & stacks(ic)%val(ii,jj,k,t) < low ) then
                                   tmp(i,j) = tmp(i,j) + 1
                                end if
                             end do
                          end do

                       end do
                    end do
                    stacks(ico-n)%val(1:ix,1:jx,k,t) = tmp(1:ix,1:jx)
                 end do

              end do
           end do
        end if
     end if

  else
     if( inside ) then
        if( equal ) then
           do n = 0, no-1
              do t = 1, it
                 do k = 1, kx
                    do j = 1, jx
                       j1 = max(  1, j-jm )
                       j2 = min( jx, j+jp )
                       
                       do i = 1, ix
                          i1 = max(  1, i-im )
                          i2 = min( ix, i+ip )
                          tmp(i,j) = 0

                          do jj = j1, j2
                             do ii = i1, i2
                                if( stacks(ic)%val(ii,jj,k,t) /= &
                                     & stacks(ic)%undef .and. &
                                     & stacks(ic)%val(ii,jj,k,t) &
                                     & >= low           .and. &
                                     & stacks(ic)%val(ii,jj,k,t) &
                                     & <= high           ) then
                                   tmp(i,j) = tmp(i,j) + 1
                                end if
                             end do
                          end do

                       end do
                    end do
                    stacks(ico-n)%val(1:ix,1:jx,k,t) = tmp(1:ix,1:jx)
                 end do

              end do
           end do

        else
           do n = 0, no-1
              do t = 1, it
                 do k = 1, kx
                    do j = 1, jx
                       j1 = max(  1, j-jm )
                       j2 = min( jx, j+jp )

                       do i = 1, ix
                          i1 = max(  1, i-im )
                          i2 = min( ix, i+ip )
                          tmp(i,j) = 0

                          do jj = j1, j2
                             do ii = i1, i2
                                if( stacks(ic)%val(ii,jj,k,t) &
                                     & /= stacks(ic)%undef .and. &
                                     & stacks(ic)%val(ii,jj,k,t) &
                                     & > low            .and. &
                                     & stacks(ic)%val(ii,jj,k,t) &
                                     & < high           ) then
                                   tmp(i,j) = tmp(i,j) + 1
                                end if
                             end do
                          end do

                       end do
                    end do
                    stacks(ico-n)%val(1:ix,1:jx,k,t) = tmp(1:ix,1:jx)
                 end do

              end do
           end do
        end if

     else
        if( equal ) then
           do n = 0, no-1
              do t = 1, it
                 do k = 1, kx
                    do j = 1, jx
                       j1 = max(  1, j-jm )
                       j2 = min( jx, j+jp )

                       do i = 1, ix
                          i1 = max(  1, i-im )
                          i2 = min( ix, i+ip )
                          tmp(i,j) = 0

                          do jj = j1, j2
                             do ii = i1, i2
                                if( stacks(ic)%val(ii,jj,k,t) &
                                     & /= stacks(ic)%undef .and. &
                                     & ( stacks(ic)%val(ii,jj,k,t) &
                                     & <= low .or.          &
                                     &   stacks(ic)%val(ii,jj,k,t) &
                                     & >= high )       ) then
                                   tmp(i,j) = tmp(i,j) + 1
                                end if
                             end do
                          end do

                       end do
                    end do
                    stacks(ico-n)%val(1:ix,1:jx,k,t) = tmp(1:ix,1:jx)
                 end do

              end do
           end do

        else
           do n = 0, no-1
              do t = 1, it
                 do k = 1, kx
                    do j = 1, jx
                       j1 = max(  1, j-jm )
                       j2 = min( jx, j+jp )

                       do i = 1, ix
                          i1 = max(  1, i-im )
                          i2 = min( ix, i+ip )
                          tmp(i,j) = 0

                          do jj = j1, j2
                             do ii = i1, i2
                                if( stacks(ic)%val(ii,jj,k,t) &
                                     & /= stacks(ic)%undef .and. &
                                     & ( stacks(ic)%val(ii,jj,k,t) &
                                     & < low .or.           &
                                     &   stacks(ic)%val(ii,jj,k,t) &
                                     & > high )        ) then
                                   tmp(i,j) = tmp(i,j) + 1
                                end if
                             end do
                          end do

                       end do
                    end do
                    stacks(ico-n)%val(1:ix,1:jx,k,t) = tmp(1:ix,1:jx)
                 end do

              end do
           end do
        end if
     end if
  end if

  if( ref ) call RPN_ClearStacks( stacks, MaxStacks )
  FuncCount = RPN_NOERROR

  deallocate( tmp )
  return
end function FuncCount
