integer function FuncGetIsoSurface( stacks, MaxStacks, lev, no )
  use RPN
  implicit none
  integer        , intent(IN)    :: MaxStacks
  type(RPN_STACK), intent(INOUT) :: stacks(MaxStacks)
  real           , intent(IN)    :: lev
  integer        , intent(IN)    :: no

  integer :: ic, iv
  integer :: i, j, k, t
  integer :: ix, jx, kx, it
  integer :: kdn, kup

  real :: rate

  real, dimension(:,:,:), allocatable :: vtmp

  FuncGetIsoSurface = RPN_FUNC_OPE_ERROR

  ic = stacks(1)%current
  if( no < 0 ) return
  if( ic < no+1 ) return
  if( .not. associated( stacks(ic)%olev ) ) return

  ix = stacks(ic)%ix
  jx = stacks(ic)%jx
  kx = stacks(ic)%kx
  it = stacks(ic)%it

  do iv = ic-no+1, ic-1
     if(    stacks(iv)%ix /= ix .or. &
          & stacks(iv)%jx /= jx .or. &
          & stacks(iv)%kx /= kx .or. &
          & stacks(iv)%it /= it ) return
  end do

  allocate( vtmp(ix,jx,it) )

  do iv = ic-no+1, ic
     vtmp = stacks(iv)%undef

     kdn = -1
     kup = -1
     KLEV: do k = kx-1, 1, -1
        rate =   ( lev - stacks(iv)%olev(k  ) ) &
             & * ( lev - stacks(iv)%olev(k+1) )
        if( rate <= 0. ) then
           kdn  = k
           kup  = k + 1
           rate = ( lev - stacks(iv)%olev(k) ) &
                & / ( stacks(iv)%olev(k+1) &
                &   - stacks(iv)%olev(k  ) ) + real(k)
           exit KLEV
        end if
     end do KLEV

     if( kdn > 0. .and. kup > 0. ) then
        do t = 1, it
           do j = 1, jx
              do i = 1, ix
                 if( stacks(iv)%val(i,j,kdn,t) /= stacks(iv)%undef .and. &
                      & stacks(iv)%val(i,j,kup,t) /= stacks(iv)%undef ) then
                    vtmp(i,j,t) = &
                         & ( stacks(iv)%val(i,j,kup,t) * ( real(kdn)-rate )  &
                         & + stacks(iv)%val(i,j,kdn,t) * ( rate-real(kup) )) &
                         & / ( real( kdn ) - real( kup ) )
                 end if
              end do
           end do
        end do
     end if

     stacks(iv)%kx = 1
!     if( associated( stacks(iv)%val ) ) nullify( stacks(iv)%val )
     if( associated( stacks(iv)%val ) ) deallocate( stacks(iv)%val )
     allocate( stacks(iv)%val(ix,jx,1,it) )
  
     do t = 1, it
        do j = 1, jx
           do i = 1, ix
              stacks(iv)%val(i,j,1,t) = vtmp(i,j,t)
           end do
        end do
     end do
  end do

  deallocate( vtmp )

  FuncGetIsoSurface = RPN_NOERROR
  return
end function FuncGetIsoSurface
