integer function FuncGetIsoSurface0( stacks, MaxStacks, lev, no )
  use RPN
  implicit none
  integer        , intent(IN)    :: MaxStacks
  type(RPN_STACK), intent(INOUT) :: stacks(MaxStacks)
  integer        , intent(IN)    :: lev
  integer        , intent(IN)    :: no

  integer :: ic, iv
  integer :: i, j, k, t
  integer :: ix, jx, kx, it
  integer :: kdn, kup

  real :: rate

  real, dimension(:,:,:), allocatable :: vtmp

  FuncGetIsoSurface0 = RPN_FUNC_OPE_ERROR

  ic = stacks(1)%current
  if( no < 0 ) return
  if( ic < no+1 ) return
  if( .not. associated( stacks(ic)%olev ) ) return

  ix = stacks(ic)%ix
  jx = stacks(ic)%jx
  kx = stacks(ic)%kx
  it = stacks(ic)%it

  do iv = ic-no+1, ic-1
     if(    stacks(iv)%ix /= ix .or. &
          & stacks(iv)%jx /= jx .or. &
          & stacks(iv)%kx /= kx .or. &
          & stacks(iv)%it /= it ) return
  end do
  if( lev < 1 .or. lev > kx ) return

  allocate( vtmp(ix,jx,it) )

  do iv = ic-no+1, ic
     vtmp = stacks(iv)%undef

     do t = 1, it
        do j = 1, jx
           do i = 1, ix
              vtmp(i,j,t) = stacks(iv)%val(i,j,lev,t)
           end do
        end do
     end do

     stacks(iv)%kx = 1
!     if( associated( stacks(iv)%val ) ) nullify( stacks(iv)%val )
     if( associated( stacks(iv)%val ) ) deallocate( stacks(iv)%val )
     allocate( stacks(iv)%val(ix,jx,1,it) )
  
     do t = 1, it
        do j = 1, jx
           do i = 1, ix
              stacks(iv)%val(i,j,1,t) = vtmp(i,j,t)
           end do
        end do
     end do
  end do

  deallocate( vtmp )

  FuncGetIsoSurface0 = RPN_NOERROR
  return
end function FuncGetIsoSurface0
