integer function FuncGetIsoSurface3( stacks, MaxStacks, no )
  use RPN
  implicit none
  integer        , intent(IN)    :: MaxStacks
  type(RPN_STACK), intent(INOUT) :: stacks(MaxStacks)
  integer        , intent(IN)    :: no

  integer :: ic, iv
  integer :: i, j, k, k2, t
  integer :: ix, jx, kx, it
  integer :: kdn, kup

  real :: rate
  real :: lev

  real, dimension(:,:,:,:), allocatable :: vtmp

  FuncGetIsoSurface3 = RPN_FUNC_OPE_ERROR

  ic = stacks(1)%current
  if( no < 0 ) return
  if( ic < no+2 ) return
  if( .not. associated( stacks(ic-1)%olev ) ) return

  ix = stacks(ic-1)%ix
  jx = stacks(ic-1)%jx
  kx = stacks(ic-1)%kx
  it = stacks(ic-1)%it

  if( stacks(ic)%ix /= ix .or. stacks(ic)%jx /= jx ) return

  do iv = ic-no, ic-2
     if(    stacks(iv)%ix /= ix .or. &
          & stacks(iv)%jx /= jx .or. &
          & stacks(iv)%kx /= kx .or. &
          & stacks(iv)%it /= it ) return
  end do

  allocate( vtmp(ix,jx,1,it) )

  do iv = ic-no, ic-1
     vtmp = stacks(iv)%undef

     do t = 1, it
        do j = 1, jx
           do i = 1, ix
              lev = stacks(ic)%val(i,j,1,1)
              if( lev == stacks(ic)%undef ) cycle

              kdn = -1
              kup = -1
              KLEV: do k = kx-1, 1, -1
                 rate =   ( lev - stacks(iv)%olev(k  ) ) &
                      & * ( lev - stacks(iv)%olev(k+1) )
                 if( rate <= 0. ) then
                    kdn  = k
                    kup  = k + 1
                    rate = ( lev - stacks(iv)%olev(k) ) &
                         & / ( stacks(iv)%olev(k+1) &
                         &   - stacks(iv)%olev(k  ) ) + real(k)
                    exit KLEV
                 end if
              end do KLEV

              if( kdn > 0. .and. kup > 0. ) then
                 if( stacks(iv)%val(i,j,kdn,t) /= stacks(iv)%undef .and. &
                      & stacks(iv)%val(i,j,kup,t) /= stacks(iv)%undef ) then
                    vtmp(i,j,1,t) = &
                         & ( stacks(iv)%val(i,j,kup,t) * ( real(kdn)-rate )  &
                         & + stacks(iv)%val(i,j,kdn,t) * ( rate-real(kup) )) &
                         & / ( real( kdn ) - real( kup ) )
                 end if
              end if
           end do
        end do

     end do
     
     if( associated( stacks(iv)%val ) ) deallocate( stacks(iv)%val )
     allocate( stacks(iv)%val(ix,jx,1,it) )
     stacks(iv)%kx = 1
  
     do t = 1, it
        do j = 1, jx
           do i = 1, ix
              stacks(iv)%val(i,j,1,t) = vtmp(i,j,1,t)
           end do
        end do
     end do
  end do

  deallocate( vtmp )

  call RPN_ClearStacks( stacks, MaxStacks )
  FuncGetIsoSurface3 = RPN_NOERROR
  return
end function FuncGetIsoSurface3
