integer function FuncGetIsoSurface4( stacks, MaxStacks, no )
  use RPN
  implicit none
  integer        , intent(IN)    :: MaxStacks
  type(RPN_STACK), intent(INOUT) :: stacks(MaxStacks)
  integer        , intent(IN)    :: no

  integer :: ic, iv
  integer :: i, j, k, t
  integer :: ix, jx, kx, it
  integer :: kdn, kup

  real :: lev
  real :: rate

  real, dimension(:,:,:), allocatable :: vtmp

  FuncGetIsoSurface4 = RPN_FUNC_OPE_ERROR

  ic = stacks(1)%current
  if( no < 0 ) return
  if( ic < no+3 ) return

  ix = stacks(ic-2)%ix
  jx = stacks(ic-2)%jx
  kx = stacks(ic-2)%kx
  it = stacks(ic-2)%it

  if( stacks(ic)%ix /= ix .or. stacks(ic)%jx /= jx ) return

  do iv = ic-no-1,ic-3
     if(    stacks(iv)%ix /= ix .or. &
          & stacks(iv)%jx /= jx .or. &
          & stacks(iv)%kx /= kx .or. &
          & stacks(iv)%it /= it ) return
  end do

  allocate( vtmp(ix,jx,it) )

  do iv = ic-no-1, ic-2
     vtmp = stacks(iv)%undef
     do t = 1, it
        do j = 1, jx
           do i = 1, ix

              lev = stacks(ic)%val(i,j,1,1)
              if( lev == stacks(ic)%undef ) cycle

              kdn = -1
              kup = -1
              KLEV: do k = kx-1, 1, -1
                 if(    stacks(ic-1)%val(i,j,k  ,t) /= stacks(ic-1)%undef .and. &
                      & stacks(ic-1)%val(i,j,k+1,t) /= stacks(ic-1)%undef ) then
                    rate =   ( lev - stacks(ic-1)%val(i,j,k  ,t) ) &
                         & * ( lev - stacks(ic-1)%val(i,j,k+1,t) )
                    if( rate <= 0. ) then
                       kdn  = k
                       kup  = k + 1
                       rate = ( lev - stacks(ic-1)%val(i,j,k,t) ) &
                            & / ( stacks(ic-1)%val(i,j,k+1,t) &
                            &   - stacks(ic-1)%val(i,j,k  ,t) ) + real(k)
                       exit KLEV
                    end if
                 end if
              end do KLEV

              if( kdn > 0 .and. kup > 0 ) then
                 if( stacks(iv)%val(i,j,kdn,t) /= stacks(iv)%undef .and. &
                      & stacks(iv)%val(i,j,kup,t) /= stacks(iv)%undef ) then
                    vtmp(i,j,t) = &
                         & ( stacks(iv)%val(i,j,kup,t) * ( real(kdn)-rate )  &
                         & + stacks(iv)%val(i,j,kdn,t) * ( rate-real(kup) )) &
                         & / ( real( kdn ) - real( kup ) )
                 end if
              end if

           end do
        end do
     end do

     stacks(iv)%kx = 1
!     if( associated( stacks(iv)%val ) ) nullify( stacks(iv)%val )
     if( associated( stacks(iv)%val ) ) deallocate( stacks(iv)%val )
     allocate( stacks(iv)%val(ix,jx,1,it) )
  
     do t = 1, it
        do j = 1, jx
           do i = 1, ix
              stacks(iv)%val(i,j,1,t) = vtmp(i,j,t)
           end do
        end do
     end do
  end do

  call RPN_ClearStacks( stacks, MaxStacks )
  call RPN_ClearStacks( stacks, MaxStacks )
  deallocate( vtmp )

  FuncGetIsoSurface4 = RPN_NOERROR
  return
end function FuncGetIsoSurface4
