integer function FuncGridMean( stacks, Maxstacks, mode, sij, eij, no )
  use RPN
  use ModelInfo
  use GeoGraphic
  implicit none
  integer        , intent(IN)    :: MaxStacks
  type(RPN_STACK), intent(INOUT) :: stacks(MaxStacks)
  integer        , intent(IN)    :: mode
  real           , intent(IN)    :: sij
  real           , intent(IN)    :: eij
  integer        , intent(IN)    :: no

  integer :: i
  integer :: j
  integer :: k
  integer :: t
  integer :: iv
  integer :: ic
  integer :: m
  integer :: ix
  integer :: jx
  integer :: kx
  integer :: it
  integer :: is
  integer :: ie
  integer :: js
  integer :: je
  integer :: n
  integer :: itmp
  integer :: mode2
  integer :: i3d

  real :: ave
  real :: lon
  real :: lat
  
  real, dimension(:,:,:,:), allocatable :: tmp

  FuncGridMean = RPN_FUNC_OPE_ERROR

  ic = stacks(1)%current
  m  = stacks(ic)%model

  mode2 = abs( mode )
  if( mode2 == 0 ) return
  i3d   = mode / mode2

  if( no < 0 ) return
  if( ic < no + 1 ) return

  ix = stacks(ic)%ix
  jx = stacks(ic)%jx
  kx = stacks(ic)%kx
  it = stacks(ic)%it

  do iv = ic-no+1,ic-1
     if( stacks(iv)%ix /= ix .or.                                            &
          & stacks(iv)%jx /= jx .or.                                         &
          & stacks(iv)%kx /= kx .or.                                         &
          & stacks(iv)%it /= it ) return
  end do

  if( mode2 == 1 .or. mode2 == 11 ) then
     allocate( tmp(1,jx,kx,it) )

     if( mode2 == 1 ) then
        is = 1
        ie = ix
        is = max( is, int( sij + 0.5 ) )
        if( eij > 0 ) then
           ie = min( ie, int( eij + 0.5 ) )
        end if

        do iv = ic-no+1, ic
           tmp(1:1,1:jx,1:kx,1:it) = stacks(iv)%undef

           do t = 1, it
              do k = 1, kx
                 do j = 1, jx
                    ave = 0.0
                    n   = 0
                    do i = is, ie
                       if( stacks(iv)%val(i,j,k,t) == stacks(iv)%undef ) cycle
                       n = n + 1
                       ave = ave + stacks(iv)%val(i,j,k,t)
                    end do

                    if( n > 0 ) then
                       ave = ave / real( n )
                       tmp(1,j,k,t) = ave
                    end if

                 end do
              end do
           end do

           if( i3d > 0 ) then
              deallocate( stacks(iv)%val )
              allocate( stacks(iv)%val(1,jx,kx,it) )
              stacks(iv)%ix = 1
              stacks(iv)%val(1:1,1:jx,1:kx,1:it) = tmp(1:1,1:jx,1:kx,1:it)
           else
              do i = 1, ix
                 stacks(iv)%val(i,1:jx,1:kx,1:it) = tmp(1,1:jx,1:kx,1:it)
              end do
           end if
        end do

     else if( mode2 == 11 ) then
        do iv = ic-no+1, ic
           tmp(1:1,1:jx,1:kx,1:it) = stacks(iv)%undef
           do t = 1, it
              do k = 1, kx
                 do j = 1, jx
                    is = 1
                    ie = ix
                    if( MODEL(m)%cproj == 'LATLON' ) then
                       itmp = int( (sij - MODEL(m)%slon) / MODEL(m)%dx + 1.0 )
                       is   = max( is, itmp )
                       itmp = int( (eij - MODEL(m)%slon) / MODEL(m)%dx + 1.0 )
                       ie   = min( ie, itmp )
                    else
                       do i = 1, ix
                          call xy2ll( real(i),                               &
                               &      real(j),                               &
                               &      lon,                                   &
                               &      lat,                                   &
                               &      MODEL(m)%cproj,                        &
                               &      MODEL(m)%dx,                           &
                               &      MODEL(m)%dy,                           &
                               &      MODEL(m)%clon,                         &
                               &      MODEL(m)%clat,                         &
                               &      MODEL(m)%xc,                           &
                               &      MODEL(m)%yc,                           &
                               &      tlat1=MODEL(m)%tlat1,                  &
                               &      tlat2=MODEL(m)%tlat2,                  &
                               &      earth=MODEL(m)%er                      )
                          if( sij >= lon ) is = i
                          if( eij >= lon ) ie = i
                       end do
                    end if

                    ave = 0.0
                    n   = 0
                    do i = is, ie
                       if( stacks(iv)%val(i,j,k,t) == stacks(iv)%undef ) cycle
                       n = n + 1
                       ave = ave + stacks(iv)%val(i,j,k,t)
                    end do

                    if( n > 0 ) then
                       ave = ave / real( n )
                       tmp(1,j,k,t) = ave
                    end if

                 end do
              end do
           end do

           if( i3d > 0 ) then
              deallocate( stacks(iv)%val )
              allocate( stacks(iv)%val(1,jx,kx,it) )
              stacks(iv)%ix = 1
              stacks(iv)%val(1:1,1:jx,1:kx,1:it) = tmp(1:1,1:jx,1:kx,1:it)
           else
              do i = 1, ix
                 stacks(iv)%val(i,1:jx,1:kx,1:it) = tmp(1,1:jx,1:kx,1:it)
              end do
           end if
        end do
     end if

  else if( mode2 == 2 .or. mode2 == 12 ) then
     allocate( tmp(ix,1,kx,it) )

     if( mode2 == 2 ) then
        js = 1
        je = jx
        js = max( js, int( sij + 0.5 ) )
        if( eij > 0 ) then
           je = min( je, int( eij + 0.5 ) )
        end if

        do iv = ic-no+1, ic
           tmp(1:ix,1:1,1:kx,1:it) = stacks(iv)%undef

           do t = 1, it
              do k = 1, kx
                 do i = 1, ix
                    ave = 0.0
                    n   = 0
                    do j = js, je
                       if( stacks(iv)%val(i,j,k,t) == stacks(iv)%undef ) cycle
                       n = n + 1
                       ave = ave + stacks(iv)%val(i,j,k,t)
                    end do

                    if( n > 0 ) then
                       ave = ave / real( n )
                       tmp(i,1,k,t) = ave
                    end if

                 end do
              end do
           end do

           if( i3d > 0 ) then
              deallocate( stacks(iv)%val )
              allocate( stacks(iv)%val(ix,1,kx,it) )
              stacks(iv)%jx = 1
              stacks(iv)%val(1:ix,1:1,1:kx,1:it) = tmp(1:ix,1:1,1:kx,1:it)
           else
              do j = 1, jx
                 stacks(iv)%val(1:ix,j,1:kx,1:it) = tmp(1:ix,j,1:kx,1:it)
              end do
           end if
        end do

     else if( mode2 == 12 ) then
        do iv = ic-no+1, ic
           tmp(1:ix,1:1,1:kx,1:it) = stacks(iv)%undef
           do t = 1, it
              do k = 1, kx
                 do i = 1, ix
                    js = 1
                    je = jx
                    if( MODEL(m)%cproj == 'LATLON' ) then
                       itmp = int( (sij - MODEL(m)%slat) / MODEL(m)%dy + 1.0 )
                       js   = max( js, itmp )
                       itmp = int( (eij - MODEL(m)%slat) / MODEL(m)%dy + 1.0 )
                       je   = min( je, itmp )
                    else
                       do j = 1, jx
                          call xy2ll( real(i),                               &
                               &      real(j),                               &
                               &      lon,                                   &
                               &      lat,                                   &
                               &      MODEL(m)%cproj,                        &
                               &      MODEL(m)%dx,                           &
                               &      MODEL(m)%dy,                           &
                               &      MODEL(m)%clon,                         &
                               &      MODEL(m)%clat,                         &
                               &      MODEL(m)%xc,                           &
                               &      MODEL(m)%yc,                           &
                               &      tlat1=MODEL(m)%tlat1,                  &
                               &      tlat2=MODEL(m)%tlat2,                  &
                               &      earth=MODEL(m)%er                      )
                          if( sij >= lat ) js = i
                          if( eij >= lat ) je = i
                       end do
                    end if

                    ave = 0.0
                    n   = 0
                    if( js > je ) then
                       itmp = js
                       js   = je
                       je   = itmp
                    end if
                    do j = js, je
                       if( stacks(iv)%val(i,j,k,t) == stacks(iv)%undef ) cycle
                       n = n + 1
                       ave = ave + stacks(iv)%val(i,j,k,t)
                    end do

                    if( n > 0 ) then
                       ave = ave / real( n )
                       tmp(i,1,k,t) = ave
                    end if

                 end do
              end do
           end do

           if( i3d > 0 ) then
              deallocate( stacks(iv)%val )
              allocate( stacks(iv)%val(ix,1,kx,it) )
              stacks(iv)%jx = 1
              stacks(iv)%val(1:ix,1:1,1:kx,1:it) = tmp(1:ix,1:1,1:kx,1:it)
           else
              do j = 1, jx
                 stacks(iv)%val(1:ix,j,1:kx,1:it) = tmp(1:ix,1,1:kx,1:it)
              end do
           end if
        end do
     end if

  else
     return
  end if

  deallocate( tmp )

  FuncGridMean = RPN_NOERROR

  return
end function FuncGridMean
