integer function FuncHistogram( stacks, MaxStacks, mode, vmin, vmax, vinc )
  use RPN
  implicit none
  integer        , intent(IN)    :: MaxStacks
  type(RPN_STACK), intent(INOUT) :: stacks(MaxStacks)
  integer        , intent(IN)    :: mode
  real           , intent(IN)    :: vmin
  real           , intent(IN)    :: vmax
  real           , intent(IN)    :: vinc

  integer :: i
  integer :: j
  integer :: k

  integer :: ireg
  integer :: ic
  integer :: iv
  integer :: idx
  integer :: ir
  integer :: m

  integer :: ix
  integer :: jx
  integer :: ix_new

  real :: rtmp

  real, dimension(:,:,:,:), allocatable :: tmp

  FuncHistogram = RPN_FUNC_OPE_ERROR

  ic   = stacks(1)%current
  m    = stacks(ic)%model
  ireg = 1

  iv = ic
  ix = stacks(ic)%ix
  jx = stacks(ic)%jx

  if( ic < 2 ) return
  if( mode == 2 ) then
     if( ic < 3 ) return
     iv = ic - 1
     if( stacks(ic-1)%ix /= ix .or. stacks(ic-1)%jx /= jx ) return

     do j = 1, jx
        do i = 1, ix
           if( stacks(ic)%val(i,j,1,1) /= stacks(ic)%undef ) then
              if( int( stacks(ic)%val(i,j,1,1) ) > ireg ) then
                 ireg = int( stacks(ic)%val(i,j,1,1) )
              end if
           end if
        end do
     end do
  end if

  ix_new = ( vmax - vmin ) / vinc

  allocate( tmp(ix_new+5,3,ireg,1) )

  ! default
  tmp = 0.
  tmp(1,1,1:ireg,1) = 1.
  tmp(2,1,1:ireg,1) = 2.
  tmp(3,1,1:ireg,1) = stacks(iv)%undef
  tmp(4,1,1:ireg,1) = 4.
  do i = 5, ix_new+4
     rtmp = vmin + real( i - 5 ) * vinc
     tmp(i,1,1:ireg,1) = rtmp
  end do
  tmp(ix_new+5,1,1:ireg,1) = 5.

  if( mode == 1 ) then
     do j = 1, jx
        do i = 1, ix
           rtmp = stacks(iv)%val(i,j,1,1)
           if( rtmp == stacks(iv)%undef ) then
              tmp(3,3,1,1) = tmp(3,3,1,1) + 1.
              cycle
           end if

           ! average
           tmp(1,2,1,1) = tmp(1,2,1,1) + rtmp
           tmp(1,3,1,1) = tmp(1,3,1,1) + 1.

           ! square mean
           tmp(2,2,1,1) = tmp(2,2,1,1) + rtmp * rtmp
           tmp(2,3,1,1) = tmp(2,3,1,1) + 1.

           if( rtmp < vmin ) then
              tmp(4,2,1,1) = tmp(4,2,1,1) + rtmp
              tmp(4,3,1,1) = tmp(4,3,1,1) + 1.
           else if( rtmp > vmax ) then
              tmp(ix_new+5,2,1,1) = tmp(ix_new+5,2,1,1) + rtmp
              tmp(ix_new+5,3,1,1) = tmp(ix_new+5,3,1,1) + 1.
           else
              idx = ( rtmp - vmin ) / vinc + 5
              tmp(idx,2,1,1) = tmp(idx,2,1,1) + rtmp
              tmp(idx,3,1,1) = tmp(idx,3,1,1) + 1.
           end if
        end do
     end do
  else
     do j = 1, jx
        do i = 1, ix
           rtmp = stacks(iv)%val(i,j,1,1)
           if(    rtmp == stacks(iv)%undef .or. &
                & stacks(ic)%val(i,j,1,1) == stacks(ic)%undef ) then
              tmp(3,3,1,1) = tmp(3,3,1,1) + 1.
              cycle
           end if

           ! region
           ir = int( stacks(ic)%val(i,j,1,1) + 0.0001 )
           if( ir < 1 .or. ir > ireg ) cycle

           ! average
           tmp(1,2,ir,1) = tmp(1,2,ir,1) + rtmp
           tmp(1,3,ir,1) = tmp(1,3,ir,1) + 1.

           ! square mean
           tmp(2,2,ir,1) = tmp(2,2,ir,1) + rtmp * rtmp
           tmp(2,3,ir,1) = tmp(2,3,ir,1) + 1.

           if( rtmp < vmin ) then
              tmp(4,2,ir,1) = tmp(4,2,ir,1) + rtmp
              tmp(4,3,ir,1) = tmp(4,3,ir,1) + 1.
           else if( rtmp > vmax ) then
              tmp(ix_new+5,2,ir,1) = tmp(ix_new+5,2,ir,1) + rtmp
              tmp(ix_new+5,3,ir,1) = tmp(ix_new+5,3,ir,1) + 1.
           else
              idx = ( rtmp - vmin ) / vinc + 5
              tmp(idx,2,ir,1) = tmp(idx,2,ir,1) + rtmp
              tmp(idx,3,ir,1) = tmp(idx,3,ir,1) + 1.
           end if
        end do
     end do

     call RPN_ClearStacks( stacks, MaxStacks )
     ic = stacks(1)%current
  end if

  stacks(ic)%ix = ix_new + 5
  stacks(ic)%jx = 3
  stacks(ic)%kx = ireg
  stacks(ic)%it = 1
  if( associated( stacks(ic)%olev ) ) deallocate( stacks(ic)%olev )
  allocate( stacks(ic)%olev(ireg) )
  do i = 1, ireg
     stacks(ic)%olev(i) = real( i )
  end do
  deallocate( stacks(ic)%val )
  allocate( stacks(ic)%val(ix_new+5,3,ireg,1) )

  do k = 1, ireg
     do j = 1, 3
        do i = 1, ix_new+5
           stacks(ic)%val(i,j,k,1) = tmp(i,j,k,1)
        end do
     end do
  end do

  if( allocated( tmp ) ) deallocate( tmp )

  FuncHistogram = RPN_NOERROR

  return
end function FuncHistogram
