integer function FuncMask( stacks, MaxStacks, mode, low, high, value, no )
  use RPN
  implicit none
  integer        , intent(IN)    :: MaxStacks
  type(RPN_STACK), intent(INOUT) :: stacks(MaxStacks)
  integer        , intent(IN)    :: mode
  real           , intent(IN)    :: low
  real           , intent(IN)    :: high
  real           , intent(IN)    :: value
  integer        , intent(IN)    :: no

  integer :: ic, ico
  integer :: i, j, k, t, n, ix, jx, kx, it
  logical :: equal, inside, ref

  FuncMask = RPN_FUNC_OPE_ERROR

  ic = stacks(1)%current

  if( abs(mode) / 10 == 1 ) then
     equal = .false.
  else
     equal = .true.
  end if

  if( mode > 0 ) then
     inside = .true.
  else
     inside = .false.
  end if

  if( mod( abs( mode ), 10 ) == 1 ) then
     ref = .false.
  else
     ref = .true.
  end if

  if( ref .and. ic < 2+no ) return
  if( ic < 1+no ) return

  ix = stacks(ic)%ix
  jx = stacks(ic)%jx
  kx = stacks(ic)%kx
  it = stacks(ic)%it

  if( ref ) then
     do n = 1, no
        if(    ix /= stacks(ic-n)%ix .or. &
             & jx /= stacks(ic-n)%jx .or. &
             & kx /= stacks(ic-n)%kx .or. &
             & it /= stacks(ic-n)%it       ) return
     end do
  end if

  if( ref ) then
     ico = ic - 1
  else
     ico = ic
  end if

  if( low == RPN_Undefined .and. high == RPN_Undefined ) then
     if( inside ) then
        if( abs( mode ) / 10 < 3 ) then
           do t = 1, it
              do k = 1, kx
                 do j = 1, jx
                    do i = 1, ix
                       if( value /= RPN_Undefined ) then
                          do n = 0, no-1
                             stacks(ico-n)%val(i,j,k,t) = value
                          end do
                       else
                          do n = 0, no-1
                             stacks(ico-n)%val(i,j,k,t) = stacks(ico-n)%undef
                          end do
                       end if
                    end do
                 end do
              end do
           end do
        else
           do t = 1, it
              do k = 1, kx
                 do j = 1, jx
                    do i = 1, ix
                       do n = 0, no-1
                          if( stacks(ico-n)%val(i,j,k,t) == stacks(ico-n)%undef ) then
                             stacks(ico-n)%val(i,j,k,t) = value
                          end if
                       end do
                    end do
                 end do
              end do
           end do
        end if
     end if

  else if( low == RPN_Undefined ) then
     if( inside ) then
        if( equal ) then
           do t = 1, it
              do k = 1, kx
                 do j = 1, jx
                    do i = 1, ix
                       if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and. &
                            & stacks(ic)%val(i,j,k,t) <= high ) then
                          if( value /= RPN_Undefined ) then
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = value
                             end do
                          else
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = stacks(ico-n)%undef
                             end do
                          end if
                       end if
                    end do
                 end do
              end do
           end do
        else
           do t = 1, it
              do k = 1, kx
                 do j = 1, jx
                    do i = 1, ix
                       if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and. &
                            & stacks(ic)%val(i,j,k,t) < high ) then
                          if( value /= RPN_Undefined ) then
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = value
                             end do
                          else
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = stacks(ico-n)%undef
                             end do
                          end if
                       end if
                    end do
                 end do
              end do
           end do
        end if

     else
        if( equal ) then
           do t = 1, it
              do k = 1, kx
                 do j = 1, jx
                    do i = 1, ix
                       if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and. &
                            & stacks(ic)%val(i,j,k,t) >= high ) then
                          if( value /= RPN_Undefined ) then
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = value
                             end do
                          else
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = stacks(ico-n)%undef
                             end do
                          end if
                       end if
                    end do
                 end do
              end do
           end do
        else
           do t = 1, it
              do k = 1, kx
                 do j = 1, jx
                    do i = 1, ix
                       if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and. &
                            & stacks(ic)%val(i,j,k,t) > high ) then
                          if( value /= RPN_Undefined ) then
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = value
                             end do
                          else
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = stacks(ico-n)%undef
                             end do
                          end if
                       end if
                    end do
                 end do
              end do
           end do
        end if
     end if

  else if( high == RPN_Undefined ) then
     if( inside ) then
        if( equal ) then
           do t = 1, it
              do k = 1, kx
                 do j = 1, jx
                    do i = 1, ix
                       if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and. &
                            & stacks(ic)%val(i,j,k,t) >= low ) then
                          if( value /= RPN_Undefined ) then
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = value
                             end do
                          else
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = stacks(ico-n)%undef
                             end do
                          end if
                       end if
                    end do
                 end do
              end do
           end do
        else
           do t = 1, it
              do k = 1, kx
                 do j = 1, jx
                    do i = 1, ix
                       if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and. &
                            & stacks(ic)%val(i,j,k,t) > low ) then
                          if( value /= RPN_Undefined ) then
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = value
                             end do
                          else
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = stacks(ico-n)%undef
                             end do
                          end if
                       end if
                    end do
                 end do
              end do
           end do
        end if

     else
        if( equal ) then
           do t = 1, it
              do k = 1, kx
                 do j = 1, jx
                    do i = 1, ix
                       if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and. &
                            & stacks(ic)%val(i,j,k,t) <= low ) then
                          if( value /= RPN_Undefined ) then
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = value
                             end do
                          else
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = stacks(ico-n)%undef
                             end do
                          end if
                       end if
                    end do
                 end do
              end do
           end do
        else
           do t = 1, it
              do k = 1, kx
                 do j = 1, jx
                    do i = 1, ix
                       if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and. &
                            & stacks(ic)%val(i,j,k,t) < low ) then
                          if( value /= RPN_Undefined ) then
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = value
                             end do
                          else
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = stacks(ico-n)%undef
                             end do
                          end if
                       end if
                    end do
                 end do
              end do
           end do
        end if
     end if

  else
     if( inside ) then
        if( equal ) then
           do t = 1, it
              do k = 1, kx
                 do j = 1, jx
                    do i = 1, ix
                       if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and. &
                            & stacks(ic)%val(i,j,k,t) >= low           .and. &
                            & stacks(ic)%val(i,j,k,t) <= high           ) then
                          if( value /= RPN_Undefined ) then
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = value
                             end do
                          else
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = stacks(ico-n)%undef
                             end do
                          end if
                       end if
                    end do
                 end do
              end do
           end do
        else
           do t = 1, it
              do k = 1, kx
                 do j = 1, jx
                    do i = 1, ix
                       if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and. &
                            & stacks(ic)%val(i,j,k,t) > low            .and. &
                            & stacks(ic)%val(i,j,k,t) < high           ) then
                          if( value /= RPN_Undefined ) then
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = value
                             end do
                          else
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = stacks(ico-n)%undef
                             end do
                          end if
                       end if
                    end do
                 end do
              end do
           end do
        end if

     else
        if( equal ) then
           do t = 1, it
              do k = 1, kx
                 do j = 1, jx
                    do i = 1, ix
                       if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and. &
                            & ( stacks(ic)%val(i,j,k,t) <= low .or.          &
                            &   stacks(ic)%val(i,j,k,t) >= high )       ) then
                          if( value /= RPN_Undefined ) then
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = value
                             end do
                          else
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = stacks(ico-n)%undef
                             end do
                          end if
                       end if
                    end do
                 end do
              end do
           end do
        else
           do t = 1, it
              do k = 1, kx
                 do j = 1, jx
                    do i = 1, ix
                       if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and. &
                            & ( stacks(ic)%val(i,j,k,t) < low .or.           &
                            &   stacks(ic)%val(i,j,k,t) > high )        ) then
                          if( value /= RPN_Undefined ) then
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = value
                             end do
                          else
                             do n = 0, no-1
                                stacks(ico-n)%val(i,j,k,t) = stacks(ico-n)%undef
                             end do
                          end if
                       end if
                    end do
                 end do
              end do
           end do
        end if
     end if
  end if

  if( ref ) call RPN_ClearStacks( stacks, MaxStacks )
  FuncMask = RPN_NOERROR
  return
end function FuncMask
