integer function FuncOutput( stacks, MaxStacks, form, mode, mode2, no )
  use RPN
  use GeoGraphic
  use ModelInfo
  use namelist
  use GMT
  implicit none
  integer         , intent(IN)    :: MaxStacks
  type(RPN_STACK) , intent(INOUT) :: stacks(MaxStacks)
  character(len=*), intent(IN)    :: form
  character(len=*), intent(IN)    :: mode
  integer         , intent(IN)    :: mode2
  integer         , intent(IN)    :: no

  integer :: ic, ip, clen, clenk
  integer :: i, j, k, m, p, t, v, recsize, irec
  integer :: ix, jx, kx, it, olev_tmp
  integer :: cbyte
  integer :: itmp
  integer :: imax
  integer :: vundef
  real    :: n, IDW_rate, IDW_rate_tmp
  real    :: x, y, xo, yo, lon, lat, tmp
  real    :: d2r
  real    :: rgr
  real    :: rtmp
  real    :: lon2
  real    :: lat2
  real    :: rlon0
  real    :: rlat0
  real    :: rlon
  real    :: rlat
  real    :: pdeg
  real    :: dis
  real    :: dk1
  real    :: dk2
  logical :: skip
  integer :: status, iscan, jscan, iskip
  integer :: dxmax
  integer :: dymax
  
  character(len=256) :: FileName
  character(len=256) :: GRDName
  character(len=256) :: DF3HeadName
  character(len=256) :: DF3FileName

  real :: vave
  real :: vmin
  real :: vmax

  real(8) :: r8tmp1
  real(8) :: r8tmp2

  integer :: max_i
  integer :: max_j
  integer :: max_k
  integer :: max_t
  integer :: min_i
  integer :: min_j
  integer :: min_k
  integer :: min_t
  integer :: vn
  integer :: vna

  integer :: ifile = 0
  integer :: io1   = 41       

  character(len=256) :: FileWritten(1000)
  real(8) :: x_range(2), y_range(2), space(2)

  integer :: n10

  integer, dimension(10) :: x10
  integer, dimension(10) :: y10
  integer, dimension(10) :: z10
  real   , dimension(10) :: v10

  real, dimension(:,:), allocatable :: vout

  character(len=4) :: ctmp4
  character(len=1) :: ctmp1

  character(len=1), dimension(:,:), allocatable :: voutc1
  character(len=2), dimension(:,:), allocatable :: voutc2
  character(len=4), dimension(:,:), allocatable :: voutc4

  FuncOutput = RPN_FUNC_OPE_ERROR

  ic = stacks(1)%current
  m  = stacks(ic)%model
  FileName = ''
  GRDName  = ''
  n  = itparg1
  IDW_rate = MODEL(m)%dy / MODEL(m)%dx
  IDW_rate_tmp = IDW_rate
  olev_tmp     = olev
  n10 = 0
  x10(1:10) = 0
  y10(1:10) = 0
  z10(1:10) = 0
  v10(1:10) = RPN_Undefined

  d2r = 3.14159265 / 180.
  rgr = 2. * 3.14159265 * MODEL(m)%er

  if( ic < no+1 ) return
  if( no < 0 ) return

  clen = len_trim( OutFile )
  ip   = 1
  skip = .false.
  do i = 1, clen
     if( skip ) then
        skip = .false.
        cycle
     end if

     if(    i < clen .and. ( &
          & OutFile(i:i+1) == '%d' .or. &
          & OutFile(i:i+1) == '%D' ) ) then
        FileName(ip:ip+23) = stacks(ic)%cdate
        ip   = ip + 23
        skip = .true.
     else
        FileName(ip:ip) = OutFile(i:i)
     end if
     ip = ip + 1
  end do

  ix = stacks(ic)%ix
  jx = stacks(ic)%jx
  kx = stacks(ic)%kx
  it = stacks(ic)%it

  if( it > 1 ) then
!     if( ( form(1:3) /= 'V5D' .or. form(1:3) /= 'CDF' .or. form(1:3) /= 'GRD' ) ) return
     if( form(1:3) /= 'GRD' ) return
  end if
write(6,*) '***BREAK****', stacks(ic)%it

  if( olev_tmp < 1 ) olev_tmp  = 1
  if( olev_tmp > kx ) olev_tmp = 1

  if( no > 1 ) then
     if( form(1:3) == 'BIN' ) then
        do i = 1, no-1
           if(    stacks(ic-i)%ix /= ix .or. &
                & stacks(ic-i)%jx /= jx ) return
        end do
     else
        do i = 1, no-1
           if(    stacks(ic-i)%ix /= ix .or. &
                & stacks(ic-i)%jx /= jx .or. &
                & stacks(ic-i)%kx /= kx .or. &
                & stacks(ic-i)%it /= it      ) return
        end do
     end if
  end if

  ! GMT grid format (GRD)
  if( form(1:3) == 'GRD' ) then
     if( mode(1:3) == 'H2D' ) then
        if( mode2 == 2 .and. MODEL(m)%cproj == 'LATLON' ) then
           if( MODEL(m)%dx > 0. ) then
              x_range(1) = MODEL(m)%slon
              x_range(2) = MODEL(m)%slon + real(ix-1)*MODEL(m)%dx
              iscan      = 0
           else
              x_range(1) = MODEL(m)%slon + real(ix-1)*MODEL(m)%dx
              x_range(2) = MODEL(m)%slon
              iscan      = 1
           end if

           if( MODEL(m)%dy > 0. ) then
              y_range(1) = MODEL(m)%slat
              y_range(2) = MODEL(m)%slat + real(jx-1)*MODEL(m)%dy
              jscan      = 1
           else
              y_range(1) = MODEL(m)%slat + real(jx-1)*MODEL(m)%dy
              y_range(2) = MODEL(m)%slat
              jscan      = 0
           end if

           space(1)   = abs( MODEL(m)%dx )
           space(2)   = abs( MODEL(m)%dy )
        else
           x_range(1) = 1.
           x_range(2) = dble(ix)
           y_range(1) = 1.
           y_range(2) = dble(jx)
           space(1)   = 1.
           space(2)   = 1.
           iscan      = 0
           if( MODEL(m)%dy > 0. ) then
              jscan      = 1
           else
              jscan   = 0
           end if
        end if
     
        if( no > MaxKeyArray ) return
        do v = ic, ic-no+1, -1
           k       = ic - v + 1
           clenk   = len_trim( OutKey(k) ) - 1
           clen    = len_trim( FileName )
           ip      = 1
           skip    = .false.
           GRDName = ''
           do i = 1, clen
              if( skip ) then
                 skip = .false.
                 cycle
              end if

              if(    i < clen .and. ( &
                   & FileName(i:i+1) == '%k' .or. &
                   & FileName(i:i+1) == '%K' ) ) then
                 GRDName(ip:ip+clenk) = trim( OutKey(k) )
                 ip   = ip + clenk
                 skip = .true.
              else
                 GRDName(ip:ip) = FileName(i:i)
              end if
              ip = ip + 1
           end do

           call write_output_info( trim(GRDName),              &
                &                  stacks(v)%ix,               &
                &                  stacks(v)%jx,               &
                &                  stacks(v)%kx,               &
                &                  stacks(v)%it,               &
                &                  stacks(v)%val,              &
                &                  stacks(v)%undef,            &
                &                  1,                          &
                &                  stacks(v)%ix,               &
                &                  1,                          &
                &                  stacks(v)%jx,               &
                &                  olev_tmp,                   &
                &                  olev_tmp,                   &
                &                  1,                          &
                &                  1,                          &
                &                  vmax,                       &
                &                  max_i,                      &
                &                  max_j,                      &
                &                  max_k,                      &
                &                  max_t,                      &
                &                  vmin,                       &
                &                  min_i,                      &
                &                  min_j,                      &
                &                  min_k,                      &
                &                  min_t,                      &
                &                  vave,                       &
                &                  vn,                         &
                &                  vna                         )
           
           status = grd_create( trim(GRDName),                 &
                &               stacks(v)%val(:,:,olev_tmp,1), &
                &               x_range,                       &
                &               y_range,                       &
                &               space,                         &
                &               NaN=stacks(v)%undef,           &
                &               iscan=iscan,                   &
                &               jscan=jscan,                   &
                &               overwrite=.true.               )
        end do

     else
        x_range(1) = 1.0d0
        y_range(1) = 1.0d0
        space(1)   = 1.0d0
        space(2)   = 1.0d0
        iscan      = 0
        jscan      = 1
        if( mode(1:2) == 'XZ' ) then
           x_range(2) = dble(ix)
           y_range(2) = dble(kx)
           allocate( vout(ix,kx) )

           if( mode2 == 2 .and. MODEL(m)%cproj == 'LATLON' ) then
              if( MODEL(m)%dx > 0. ) then
                 x_range(1) = MODEL(m)%slon
                 x_range(2) = MODEL(m)%slon + real(ix-1)*MODEL(m)%dx
                 iscan      = 0
              else
                 x_range(1) = MODEL(m)%slon + real(ix-1)*MODEL(m)%dx
                 x_range(2) = MODEL(m)%slon
                 iscan      = 1
              end if
              space(1)   = abs( MODEL(m)%dx )
           end if

        else if( mode(1:2) == 'YZ' ) then
           x_range(2) = dble(jx)
           y_range(2) = dble(kx)
           allocate( vout(jx,kx) )

           if( mode2 == 2 .and. MODEL(m)%cproj == 'LATLON' ) then
              if( MODEL(m)%dy > 0. ) then
                 x_range(1) = MODEL(m)%slat
                 x_range(2) = MODEL(m)%slat + real(jx-1)*MODEL(m)%dy
                 iscan      = 1
              else
                 x_range(1) = MODEL(m)%slat + real(jx-1)*MODEL(m)%dy
                 x_range(2) = MODEL(m)%slat
                 iscan      = 0
              end if
              space(1)   = abs( MODEL(m)%dy )
           end if

        else if( mode(1:2) == 'XT' ) then
           x_range(2) = dble(ix)
           y_range(2) = dble(it)
           allocate( vout(ix,it) )

           if( mode2 == 2 .and. MODEL(m)%cproj == 'LATLON' ) then
              if( MODEL(m)%dx > 0. ) then
                 x_range(1) = MODEL(m)%slon
                 x_range(2) = MODEL(m)%slon + real(ix-1)*MODEL(m)%dx
                 iscan      = 0
              else
                 x_range(1) = MODEL(m)%slon + real(ix-1)*MODEL(m)%dx
                 x_range(2) = MODEL(m)%slon
                 iscan      = 1
              end if
              space(1)   = abs( MODEL(m)%dx )
           end if

        else
           return
        end if

        if( no > MaxKeyArray ) return
        do v = ic, ic-no+1, -1
           k       = ic - v + 1
           clenk   = len_trim( OutKey(k) ) - 1
           clen    = len_trim( FileName )
           ip      = 1
           skip    = .false.
           GRDName = ''
           do i = 1, clen
              if( skip ) then
                 skip = .false.
                 cycle
              end if

              if(    i < clen .and. ( &
                   & FileName(i:i+1) == '%k' .or. &
                   & FileName(i:i+1) == '%K' ) ) then
                 GRDName(ip:ip+clenk) = trim( OutKey(k) )
                 ip   = ip + clenk
                 skip = .true.
              else
                 GRDName(ip:ip) = FileName(i:i)
              end if
              ip = ip + 1
           end do

           if( mode2 == 2 .and. kx > 2 ) then
              status = 0
              dk1 = stacks(v)%olev(2) - stacks(v)%olev(1)
              do k = 2, kx-1
                 dk2 = stacks(v)%olev(k+1) - stacks(v)%olev(k)
                 if( abs( dk2 - dk1 ) > 1.e-3 ) then
                    status = -1
                    exit
                 end if
              end do
              if( status == 0 ) then
                 if( dk1 > 0. ) then
                    y_range(1) = stacks(v)%olev(1)
                    y_range(2) = stacks(v)%olev(kx)
                    jscan      = 1
                 else
                    y_range(1) = stacks(v)%olev(kx)
                    y_range(2) = stacks(v)%olev(1)
                    jscan      = 0
                 end if
                 space(2) = abs( dk1 )
              end if
           end if

           call write_output_info( trim(GRDName),              &
                &                  stacks(v)%ix,               &
                &                  stacks(v)%jx,               &
                &                  stacks(v)%kx,               &
                &                  stacks(v)%it,               &
                &                  stacks(v)%val,              &
                &                  stacks(v)%undef,            &
                &                  1,                          &
                &                  stacks(v)%ix,               &
                &                  1,                          &
                &                  stacks(v)%jx,               &
                &                  olev_tmp,                   &
                &                  olev_tmp,                   &
                &                  1,                          &
                &                  1,                          &
                &                  vmax,                       &
                &                  max_i,                      &
                &                  max_j,                      &
                &                  max_k,                      &
                &                  max_t,                      &
                &                  vmin,                       &
                &                  min_i,                      &
                &                  min_j,                      &
                &                  min_k,                      &
                &                  min_t,                      &
                &                  vave,                       &
                &                  vn,                         &
                &                  vna                         )

           if( mode(1:2) == 'XZ' ) then
              vout(1:ix,1:kx) = stacks(v)%val(1:ix,1,1:kx,1)
           else if( mode(1:2) == 'YZ' ) then
              vout(1:jx,1:kx) = stacks(v)%val(1,1:jx,1:kx,1)
           else if( mode(1:2) == 'XT' ) then
              vout(1:ix,1:it) = stacks(v)%val(1:ix,1,1,1:it)
           end if

           status = grd_create( trim(GRDName),                 &
                &               vout,                          &
                &               x_range,                       &
                &               y_range,                       &
                &               space,                         &
                &               NaN=stacks(v)%undef,           &
                &               iscan=iscan,                   &
                &               jscan=jscan,                   &
                &               overwrite=.true.               )
        end do

        if( allocated( vout ) ) deallocate( vout )

     end if

  ! Pov-Ray density file ( DF3 )
  else if( form(1:3) == 'DF3' ) then
     if( mode(1:1) == '1' ) then
        cbyte = 1
        allocate( voutc1(ix,jx) )
     else if( mode(1:1) == '2' ) then
        cbyte = 2
        allocate( voutc2(ix,jx) )
     else if( mode(1:1) == '4' ) then
        return
        cbyte = 4
        allocate( voutc4(ix,jx) )
     else
        return
     end if

     do v = ic, ic-no+1,-1
        k = ic - v + 1
        clenk = len_trim( OutKey(k) ) - 1
        clen  = len_trim( FileName )
        skip  = .false.

        do i = 1, 256
           DF3HeadName(i:i) = ' '
        end do
        ip    = 1

        do i = 1, clen
           if( skip ) then
              skip = .false.
              cycle
           end if

           if( i < clen .and. ( &
                & FileName(i:i+1) == '%k' .or. &
                & FileName(i:i+1) == '%K' ) ) then
              DF3HeadName(ip:ip+clenk) = trim( OutKey(k) )
              ip = ip + clenk
              skip = .true.
           else
              DF3HeadName(ip:ip) = FileName(i:i)
           end if
           ip = ip + 1
        end do
        clen = len_trim( DF3HeadName )
        DF3HeadName(clen+1:clen+4) = '_df3'

        do i = 1, clen
           DF3FileName(i:i) = ' '
        end do
        clen = len_trim( DF3HeadName )
        DF3FileName(1:clen-4) = DF3HeadName(1:clen-4)

        ! DF3 Header
        open( io1, file=trim(DF3HeadName), access='direct', &
             &     recl=2, IOSTAT=status )
        call Int4Char4( ctmp4, ix, DF3Swap )
        write( io1, rec=1, IOSTAT=status ) ctmp4(3:4)
        call Int4Char4( ctmp4, jx, DF3Swap )
        write( io1, rec=2, IOSTAT=status ) ctmp4(3:4)
        call Int4Char4( ctmp4, stacks(v)%kx, DF3Swap )
        write( io1, rec=3, IOSTAT=status ) ctmp4(3:4)
        close( io1 )

        ! file open
        recsize = cbyte * ix * jx
        open( io1, file=trim(DF3FileName), access='direct', &
             &     recl=recsize, IOSTAT=status )
        irec = 1
        
        if(    OutMinval(k) == stacks(v)%undef .or. &
             & OutMaxVal(k) == stacks(v)%undef ) then
           vmax = -1e+35
           vmin =  1e+35
           do k = 1, stacks(v)%kx
              do j = 1, jx
                 do i = 1, ix
                    if( stacks(v)%val(i,j,k,1) /= stacks(v)%undef ) then
                       if( stacks(v)%val(i,j,k,1) > vmax ) then
                          vmax = stacks(v)%val(i,j,k,1)
                       end if
                       if( stacks(v)%val(i,j,k,1) < vmin ) then
                          vmin = stacks(v)%val(i,j,k,1)
                       end if
                    end if
                 end do
              end do
           end do
        else
           vmax = OutMaxVal(k)
           vmin = OutMinVal(k)
        end if

        if( OutUndef(k) < 0 ) then
           vundef = 0
        else
           vundef = OutUndef(k)
        end if

        do k = 1, stacks(v)%kx
           imax = 0
           do j = 1, jx
              do i = 1, ix
                 if( stacks(v)%val(i,j,k,1) == stacks(v)%undef ) then
                    itmp = vundef
                 else if( cbyte == 1 ) then
                    itmp = int( 254. * ( stacks(v)%val(i,j,k,1) - vmin ) &
                         &          / ( vmax - vmin ) )
                    if( itmp > 254 ) itmp = 254
                    if( itmp <   0 ) itmp =   0
                 else if( cbyte == 2 ) then
                    itmp = int( 65534. * ( stacks(v)%val(i,j,k,1) - vmin ) &
                         &          / ( vmax - vmin ) )
                    if( itmp > 65534 ) itmp = 65534
                    if( itmp <     0 ) itmp =     0
                 end if
                 call Int4Char4( ctmp4, itmp, DF3Swap )
                 if( itmp > imax ) imax = itmp

                 if( cbyte == 1 ) then
                    voutc1(i,j)(1:1) = ctmp4(4:4)
                 else if( cbyte == 2 ) then
                    voutc2(i,j)(1:2) = ctmp4(3:4)
                 end if
              end do
           end do

           if( cbyte == 1 ) then
              write( io1, rec=irec, IOSTAT=status ) voutc1
           else if( cbyte == 2 ) then
              write( io1, rec=irec, IOSTAT=status ) voutc2
           end if

           irec = irec + 1
        end do

        close( io1 )
     end do

     if( cbyte == 1 ) then
        deallocate( voutc1 )
     else if( cbyte == 2 ) then
        deallocate( voutc2 )
     else if( cbyte == 4 ) then
        deallocate( voutc4 )
     end if

  ! 4 byte floating point number
  else if( form(1:4) == 'BIN4' ) then
     allocate( vout(ix,jx) )
     recsize = ix * jx * 1 * 1 * 4
     open( io1, file=trim(FileName), access='direct', recl=recsize, IOSTAT=status )
     if( status /= 0 ) return
     irec = 1
     do t = 1, it
        do v = ic, ic-no+1, -1
           do k = 1, stacks(v)%kx
              if( MODEL(m)%dy > 0 ) then
                 write(io1,rec=irec) stacks(v)%val(:,:,k,t)
              else
                 do j = 1, jx
                    vout(:,j) = stacks(v)%val(:,jx-j+1,k,t)
                 end do
                 write(io1,rec=irec,IOSTAT=status) vout
              end if
              irec = irec + 1
           end do
        end do
     end do
     close( io1 )
     deallocate( vout )

  ! Text format
  else if( form(1:4) == 'TEXT' ) then
     if( mode(1:3) == 'H2D' ) then
        open( io1, file=trim(FileName), IOSTAT=status )
        if( status /= 0 ) return
        if( mode2 == 1 .or. MODEL(m)%cproj == 'NOPROJ' ) then
           do j = 1, jx
              do i = 1, ix
                 iskip = 1
                 if( mode(4:4) /= 'C' .and. mode(4:4) /= 'U' ) then
                    iskip = 0

                 else if( mode(4:4) == 'C' ) then
                    do v = ic, ic-no+1, -1
                       if( stacks(v)%val(i,j,olev_tmp,1) /= &
                            & stacks(v)%undef ) then
                          iskip = 0
                          exit
                       end if
                    end do

                 else if( mode(4:4) == 'U' ) then
                    iskip = 0
                    do v = ic, ic-no+1, -1
                       if( stacks(v)%val(i,j,olev_tmp,1) == &
                            & stacks(v)%undef ) then
                          iskip = 1
                          exit
                       end if
                    end do
                 end if

                 if( iskip == 0 ) then
                    write(io1,'(2i10,$)') i, j
                    do v = ic, ic-no+1, -1
                       write(io1,'(e15.7,$)') stacks(v)%val(i,j,olev_tmp,1)
                    end do
                    write(io1,*)
                 end if

              end do
           end do
        else
           if( MODEL(m)%cproj == 'LATLON' ) then
              do j = 1, jx
                 do i = 1, ix
                    iskip = 1
                    if( mode(4:4) /= 'C' .and. mode(4:4) /= 'U' ) then
                       iskip = 0

                    else if( mode(4:4) == 'C' ) then
                       do v = ic, ic-no+1, -1
                          if( stacks(v)%val(i,j,olev_tmp,1) /= &
                               & stacks(v)%undef ) then
                             iskip = 0
                             exit
                          end if
                       end do

                    else if( mode(4:4) == 'U' ) then
                       iskip = 0
                       do v = ic, ic-no+1, -1
                          if( stacks(v)%val(i,j,olev_tmp,1) == &
                               & stacks(v)%undef ) then
                             iskip = 1
                             exit
                          end if
                       end do
                    end if

                    if( iskip == 1 ) cycle

                    lon = MODEL(m)%slon + real(i-1)*MODEL(m)%dx
                    lat = MODEL(m)%slat + real(j-1)*MODEL(m)%dy

                    write(io1,'(2e15.7,$)') lon, lat
                    do v = ic, ic-no+1, -1
                       write(io1,'(e15.7,$)') stacks(v)%val(i,j,olev_tmp,1)
                    end do
                    write(io1,*)
                 end do
              end do

           else if( MODEL(m)%cproj /= 'NOPROJ' ) then
              do j = 1, jx
                 do i = 1, ix
                    iskip = 1
                    if( mode(4:4) /= 'C' .and. mode(4:4) /= 'U' ) then
                       iskip = 0

                    else if( mode(4:4) == 'C' ) then
                       do v = ic, ic-no+1, -1
                          if( stacks(v)%val(i,j,olev_tmp,1) /= &
                               & stacks(v)%undef ) then
                             iskip = 0
                             exit
                          end if
                       end do

                    else if( mode(4:4) == 'U' ) then
                       iskip = 0
                       do v = ic, ic-no+1, -1
                          if( stacks(v)%val(i,j,olev_tmp,1) == &
                               & stacks(v)%undef ) then
                             iskip = 1
                             exit
                          end if
                       end do
                    end if

                    if( iskip == 1 ) cycle

                    call xy2ll( real(i),              &
                         &      real(j),              &
                         &      lon,                  &
                         &      lat,                  &
                         &      MODEL(m)%cproj,       &
                         &      MODEL(m)%dx,          &
                         &      MODEL(m)%dy,          &
                         &      MODEL(m)%clon,        &
                         &      MODEL(m)%clat,        &
                         &      MODEL(m)%xc,          &
                         &      MODEL(m)%yc,          &
                         &      tlat1=MODEL(m)%tlat1, &
                         &      tlat2=MODEL(m)%tlat2, &
                         &      earth=MODEL(m)%er     )

                    write(io1,'(2e15.7,$)') lon, lat
                    do v = ic, ic-no+1, -1
                       write(io1,'(e15.7,$)') stacks(v)%val(i,j,olev_tmp,1)
                    end do
                    write(io1,*)
                 end do
              end do
           end if
        end if
        close( io1 )

     else if( mode(1:3) == 'MIN' ) then
        open( io1, file=trim(FileName), IOSTAT=status )
        if( status /= 0 ) return
        do k = 1, kx
           do j = 1, jx
              do i = 1, ix
                 if( stacks(ic)%val(i,j,k,1) == stacks(ic)%undef ) cycle
                 n10 = min( n10+1, 10 )
                 if( x10(1) == 0 ) then
                    x10(1) = i
                    y10(1) = j
                    z10(1) = k
                    v10(1) = stacks(ic)%val(i,j,k,1)
                 else
                    do t = 1, n10
                       if( x10(t) == 0 ) then
                          x10(t) = i
                          y10(t) = j
                          z10(t) = k
                          v10(t) = stacks(ic)%val(i,j,k,1)
                       else if( stacks(ic)%val(i,j,k,1) < v10(t) ) then
                          call insert_data( i, j, k,                         &
                               &            stacks(ic)%val(i,j,k,1),         &
                               &            x10, y10, z10, v10, t )
                          exit
                       end if
                    end do
                 end if
              end do
           end do
        end do

        do t = 1, n10
           write(io1,'(3i10,$)') x10(t), y10(t), z10(t)
           write(io1,'(e15.7,$)') v10(t)
           do v = ic-1, ic-no+1, -1
              write(io1,'(e15.7,$)') stacks(v)%val(x10(t),y10(t),z10(t),1)
           end do
           write(io1,*)
        end do

     else if( mode(1:3) == 'MAX' ) then
        open( io1, file=trim(FileName), IOSTAT=status )
        if( status /= 0 ) return
        do k = 1, kx
           do j = 1, jx
              do i = 1, ix
                 if( stacks(ic)%val(i,j,k,1) == stacks(ic)%undef ) cycle
                 n10 = min( n10+1, 10 )
                 if( x10(1) == 0 ) then
                    x10(1) = i
                    y10(1) = j
                    z10(1) = k
                    v10(1) = stacks(ic)%val(i,j,k,1)
                 else
                    do t = 1, n10
                       if( x10(t) == 0 ) then
                          x10(t) = i
                          y10(t) = j
                          z10(t) = k
                          v10(t) = stacks(ic)%val(i,j,k,1)
                       else if( stacks(ic)%val(i,j,k,1) > v10(t) ) then
                          call insert_data( i, j, k,                         &
                               &            stacks(ic)%val(i,j,k,1),         &
                               &            x10, y10, z10, v10, t )
                          exit
                       end if
                    end do
                 end if
              end do
           end do
        end do

        do t = 1, n10
           write(io1,'(3i10,$)') x10(t), y10(t), z10(t)
           write(io1,'(e15.7,$)') v10(t)
           do v = ic-1, ic-no+1, -1
              write(io1,'(e15.7,$)') stacks(v)%val(x10(t),y10(t),z10(t),1)
           end do
           write(io1,*)
        end do

     else if( mode(1:3) == 'RAW' ) then
        open( io1, file=trim(FileName), IOSTAT=status )
        if( status /= 0 ) return

        do k = 1, kx
           do j = 1, jx
              do i = 1, ix
                 write(io1,'(3i10,$)') i, j, k

                 do v = ic, ic-no+1, -1
                    write(io1,'(e15.7,$)') stacks(v)%val(i,j,k,1)
                 end do
                 write(io1,*)

              end do
           end do
        end do

     else if( mode(1:2) == 'ZR' ) then
        open( io1, file=trim(FileName), IOSTAT=status )
        if( status /= 0 ) return

        do p = 1, MaxPoints
           if( abs( lonp(p) ) > 360. .or. abs( latp(p) ) > 360. ) exit

           if( MODEL(m)%cproj == 'LATLON' ) then
              x = ( lonp(p) - MODEL(m)%slon ) / MODEL(m)%dx + 1.
              y = ( latp(p) - MODEL(m)%slat ) / MODEL(m)%dy + 1.
              
              dymax = int( OutRadius / (rgr*360.*abs(MODEL(m)%dy)) + 0.5 )

           else if( MODEL(m)%cproj /= 'NOPROJ' ) then
              call ll2xy( lonp(p),              &
                   &      latp(p),              &
                   &      x,                    &
                   &      y,                    &
                   &      MODEL(m)%cproj,       &
                   &      MODEL(m)%dx,          &
                   &      MODEL(m)%dy,          &
                   &      MODEL(m)%clon,        &
                   &      MODEL(m)%clat,        &
                   &      MODEL(m)%xc,          &
                   &      MODEL(m)%yc,          &
                   &      tlat1=MODEL(m)%tlat1, &
                   &      tlat2=MODEL(m)%tlat2, &
                   &      earth=MODEL(m)%er     )
              dymax = int( OutRadius / MODEL(m)%dy + 0.5 )
              dxmax = int( OutRadius / MODEL(m)%dx + 0.5 )
           end if

           if( x >= 1 .and. x <= ix .and. y >= 1 .and. y <= jx ) then
              do j = int(y-0.5)-dymax, int(y+0.5)+dymax
                 if( j < 1 .or. j > jx ) cycle

                 if( MODEL(m)%cproj == 'LATLON' ) then
                    lon   = ( real(i-1)*MODEL(m)%dx + MODEL(m)%slon )
                    lat   = ( real(j-1)*MODEL(m)%dy + MODEL(m)%slat )
                    rlat  = lat * d2r 
                    rlon  = lon * d2r
                    rlat0 = latp(p) * d2r
                    rlon0 = lonp(p) * d2r
                    rtmp  = rgr * cos( rlat ) / 360. * abs( MODEL(m)%dy )
                    dxmax = int( OutRadius / rtmp + 0.5 )

                    do i = int(x-0.5)-dxmax, int(x+0.5)+dxmax
                       if( i < 1 .or. i > ix ) cycle
                       call Dis2GPoint( dis, latp(p), lonp(p), lat, lon )
                       if( dis > OutRadius ) cycle

                       r8tmp1 = cos( rlat )*sin( rlon - rlon0 )
                       r8tmp2 = sin( rlat )*cos( rlat0 )                    &
                            & - cos( rlat )*sin( rlat0 )*cos( rlon - rlon0 )
                       pdeg = atan2( r8tmp2, r8tmp1 ) / d2r

                       if( pdeg >= OutSdeg .and. pdeg <= OutEdeg ) then
                          if( abs(mode2) == 1 ) then
                             write(io1,'(3e15.7,$)') x, y, dis
                          else
                             write(io1,'(3e15.7,$)') lonp(p), latp(p), dis
                          end if

                          do v = ic, ic-no+1, -1
                             write(io1,'(e15.7,$)') stacks(v)%val(i,j,olev_tmp,1)
                          end do
                          write(io1,*)
                       end if

                    end do

                 else
                    do i = int(x-0.5)-dxmax, int(x+0.5)+dxmax
                       if( i < 1 .or. i > ix ) cycle
                       pdeg = atan2( real(j)-y,real(i)-x ) / d2r
                       if( OutSdeg >= 0. .and. pdeg < 0. ) pdeg = pdeg + 360.
                       
                       dis = sqrt( (real(i)-x)*(real(i)-x)                 &
                            &    + (real(j)-y)*(real(j)-y) ) * MODEL(m)%dx
                       if( dis > OutRadius ) cycle
                       if( pdeg >= OutSdeg .and. pdeg <= OutEdeg ) then
                          
                          if( abs(mode2) == 1 ) then
                             write(io1,'(3e15.7,$)') x, y, dis
                          else
                             write(io1,'(3e15.7,$)') lonp(p), latp(p), dis
                          end if

                          do v = ic, ic-no+1, -1
                             write(io1,'(e15.7,$)') stacks(v)%val(i,j,olev_tmp,1)
                          end do
                          write(io1,*)

                       end if
                    end do
                 end if
              end do

           end if

        end do

        do p = 1, MaxPoints
           if( xp(p) < 1. .or. yp(p) < 1. ) exit
           x = xp(p)
           y = yp(p)

           if( MODEL(m)%cproj == 'LATLON' ) then
              lon = MODEL(m)%slon + ( xp(p) - 1 ) * MODEL(m)%dx
              lat = MODEL(m)%slat + ( yp(p) - 1 ) * MODEL(m)%dy
              
              dymax = int( OutRadius / (rgr*360.*abs(MODEL(m)%dy)) + 0.5 )

           else if( MODEL(m)%cproj /= 'NOPROJ' ) then
              call xy2ll( xp(p),                &
                   &      yp(p),                &
                   &      lon,                  &
                   &      lat,                  &
                   &      MODEL(m)%cproj,       &
                   &      MODEL(m)%dx,          &
                   &      MODEL(m)%dy,          &
                   &      MODEL(m)%clon,        &
                   &      MODEL(m)%clat,        &
                   &      MODEL(m)%xc,          &
                   &      MODEL(m)%yc,          &
                   &      tlat1=MODEL(m)%tlat1, &
                   &      tlat2=MODEL(m)%tlat2, &
                   &      earth=MODEL(m)%er     )
              dymax = int( OutRadius / MODEL(m)%dy + 0.5 )
              dxmax = int( OutRadius / MODEL(m)%dx + 0.5 )
           end if

           if( x >= 1 .and. x <= ix .and. y >= 1 .and. y <= jx ) then
              do j = int(y-0.5)-dymax, int(y+0.5)+dymax
                 if( j < 1 .or. j > jx ) cycle

                 if( MODEL(m)%cproj == 'LATLON' ) then
                    lon2  = ( real(i-1)*MODEL(m)%dx + MODEL(m)%slon )
                    lat2  = ( real(j-1)*MODEL(m)%dy + MODEL(m)%slat )
                    rlat  = lat2 * d2r 
                    rlon  = lon2 * d2r
                    rlat0 = lat * d2r
                    rlon0 = lon * d2r
                    rtmp  = rgr * cos( rlat ) / 360. * abs( MODEL(m)%dy )
                    dxmax = int( OutRadius / rtmp + 0.5 )

                    do i = int(x-0.5)-dxmax, int(x+0.5)+dxmax
                       if( i < 1 .or. i > ix ) cycle
                       call Dis2GPoint( dis, lat, lon, lat2, lon2 )
                       if( dis > OutRadius ) cycle

                       r8tmp1 = cos( rlat )*sin( rlon - rlon0 )
                       r8tmp2 = sin( rlat )*cos( rlat0 )                    &
                            & - cos( rlat )*sin( rlat0 )*cos( rlon - rlon0 )
                       pdeg = atan2( r8tmp2, r8tmp1 ) / d2r

                       if( pdeg >= OutSdeg .and. pdeg <= OutEdeg ) then
                          if( abs(mode2) == 1 ) then
                             write(io1,'(3e15.7,$)') x, y, dis
                          else
                             write(io1,'(3e15.7,$)') lon, lat, dis
                          end if

                          do v = ic, ic-no+1, -1
                             write(io1,'(e15.7,$)') stacks(v)%val(i,j,olev_tmp,1)
                          end do
                          write(io1,*)
                       end if

                    end do

                 else
                    do i = int(x-0.5)-dxmax, int(x+0.5)+dxmax
                       if( i < 1 .or. i > ix ) cycle
                       pdeg = atan2( real(j)-y,real(i)-x ) / d2r
                       if( OutSdeg >= 0. .and. pdeg < 0. ) pdeg = pdeg + 360.
                       
                       dis = sqrt( (real(i)-x)*(real(i)-x)                 &
                            &    + (real(j)-y)*(real(j)-y) ) * MODEL(m)%dx
                       if( dis > OutRadius ) cycle
                       if( pdeg >= OutSdeg .and. pdeg <= OutEdeg ) then
                          
                          if( abs(mode2) == 1 ) then
                             write(io1,'(3e15.7,$)') x, y, dis
                          else
                             write(io1,'(3e15.7,$)') lon, lat, dis
                          end if

                          do v = ic, ic-no+1, -1
                             write(io1,'(e15.7,$)') stacks(v)%val(i,j,olev_tmp,1)
                          end do
                          write(io1,*)

                       end if
                    end do
                 end if
              end do

           end if

        end do

     else if( mode(1:3) == 'Z2D' ) then
        open( io1, file=trim(FileName), IOSTAT=status )
        if( status /= 0 ) return
        if( ix /= 1 ) then
           do k = 1, kx
              do i = 1, ix
                 if( mode2 == 1 ) then
                    write(io1,'(2i10,$)') i, k
                 else
                    write(io1,'(i10,e15.7,$)') i, stacks(ic)%olev(k)
                 end if
                 do v = ic, ic-no+1, -1
                    write(41,'(a1,e15.7,$)') ' ', stacks(v)%val(i,1,k,1)
                 end do
                 write(41,*)
              end do
           end do

        else
           do k = 1, kx
              do j = 1, jx
                 if( mode2 == 1 ) then
                    write(io1,'(2i10,$)') j, k
                 else
                    write(io1,'(i10,e15.7,$)') j, stacks(ic)%olev(k)
                 end if
                 do v = ic, ic-no+1, -1
                    write(41,'(a1,e15.7,$)') ' ', stacks(v)%val(1,j,k,1)
                 end do
                 write(41,*)
              end do
           end do
        end if
        close( io1 )

     else if( mode(1:3) == 'Z1D' ) then
        t = -1
        do i = 1, ifile
           if( FileName == FileWritten(i) ) then
              t = i
              exit
           end if
        end do
        if( t > 0 ) then
           open( io1, file=trim(FileName), IOSTAT=status, POSITION='append' )
        else
           open( io1, file=trim(FileName), IOSTAT=status )
           ifile = ifile + 1
           FileWritten(ifile) = FileName
        end if
        if( status /= 0 ) return

        do p = 1, MaxPoints
           if( abs( lonp(p) ) > 360. .or. abs( latp(p) ) > 360. ) exit

           if( MODEL(m)%cproj == 'LATLON' ) then
              x = ( lonp(p) - MODEL(m)%slon ) / MODEL(m)%dx + 1.
              y = ( latp(p) - MODEL(m)%slat ) / MODEL(m)%dy + 1.

           else if( MODEL(m)%cproj /= 'NOPROJ' ) then
              call ll2xy( lonp(p),              &
                   &      latp(p),              &
                   &      x,                    &
                   &      y,                    &
                   &      MODEL(m)%cproj,       &
                   &      MODEL(m)%dx,          &
                   &      MODEL(m)%dy,          &
                   &      MODEL(m)%clon,        &
                   &      MODEL(m)%clat,        &
                   &      MODEL(m)%xc,          &
                   &      MODEL(m)%yc,          &
                   &      tlat1=MODEL(m)%tlat1, &
                   &      tlat2=MODEL(m)%tlat2, &
                   &      earth=MODEL(m)%er     )
           end if

           if( x >= 1. .and. x <= ix .and. y >= 1 .and. y <= jx ) then
              xo = x
              yo = y
              do k = 1, kx
                 write(io1,'(a28,$)') stacks(ic)%cdate
                 if( kx > 1 ) write(io1,'(e15.7,$)') stacks(ic)%olev(k)

                 do v = ic, ic-no+1, -1
                    tmp = IDW( xo, yo, n, v, IDW_rate_tmp )
                    if( v == ic ) then
                       if( mode2 == 1 ) then
                          write(io1,'(2e15.7,$)') xo, yo
                       else if( mode2 == -1 ) then
                          write(io1,'(2e15.7,$)') xo, yo, x, y
                       else
                          write(io1,'(2e15.7,$)') lonp(p), latp(p)
                       end if
                    end if
                    write(io1,'(e15.7,$)') tmp
                 end do
                 write(io1,*)
              end do
           end if
        end do

        do p = 1, MaxPoints
           if( xp(p) < 1. .or. yp(p) < 1. ) exit

           if( MODEL(m)%cproj == 'LATLON' ) then
              lon = MODEL(m)%slon + ( xp(p) - 1 ) * MODEL(m)%dx
              lat = MODEL(m)%slat + ( yp(p) - 1 ) * MODEL(m)%dy

           else if( MODEL(m)%cproj /= 'NOPROJ' ) then
              call xy2ll( xp(p),                &
                   &      yp(p),                &
                   &      lon,                  &
                   &      lat,                  &
                   &      MODEL(m)%cproj,       &
                   &      MODEL(m)%dx,          &
                   &      MODEL(m)%dy,          &
                   &      MODEL(m)%clon,        &
                   &      MODEL(m)%clat,        &
                   &      MODEL(m)%xc,          &
                   &      MODEL(m)%yc,          &
                   &      tlat1=MODEL(m)%tlat1, &
                   &      tlat2=MODEL(m)%tlat2, &
                   &      earth=MODEL(m)%er     )
           end if
           
           x = xp(p)
           y = yp(p)
           if( x >= 1. .and. x <= ix .and. y >= 1 .and. y <= jx ) then
              do k = 1, kx
                 write(io1,'(a28,$)') stacks(ic)%cdate
                 if( kx > 1 ) write(io1,'(e15.7,$)') stacks(ic)%olev(k)
                 xo = x
                 yo = y
                 

                 do v = ic, ic-no+1, -1
                    tmp = IDW( xo, yo, n, v, IDW_rate_tmp )
                    if( v == ic ) then
                       if( mode2 == 1 ) then
                          write(io1,'(2e15.7,$)') xo, yo
                       else if( mode2 == -1 ) then
                          write(io1,'(4e15.7,$)') xo, yo, x, y
                       else
                          write(io1,'(2e15.7,$)') lon, lat
                       end if
                    end if
                    write(io1,'(e15.7,$)') tmp
                 end do
                 write(io1,*)
              end do
           end if
        end do

        close( io1 )
     end if
  else
     return
  end if

  write(6,*) '***DEBUG*** ', m, ic, stacks(ic)%cdate
  
  FuncOutput = RPN_NOERROR
  return
contains
  include "func_inner_idw.f90"

  subroutine insert_data( i, j, k, val, x10, y10, z10, v10, t )
    integer               , intent(IN)    :: i
    integer               , intent(IN)    :: j
    integer               , intent(IN)    :: k
    real                  , intent(IN)    :: val
    integer, dimension(10), intent(INOUT) :: x10
    integer, dimension(10), intent(INOUT) :: y10
    integer, dimension(10), intent(INOUT) :: z10
    real   , dimension(10), intent(INOUT) :: v10
    integer               , intent(IN)    :: t

    integer :: n
    integer :: ns

    do n = t, 10
       if( x10(n) > 0 ) ns = n
    end do

    do n = ns, t+1, -1
       x10(n) = x10(n-1)
       y10(n) = y10(n-1)
       z10(n) = z10(n-1)
       v10(n) = v10(n-1)
    end do

    x10(t) = i
    y10(t) = j
    z10(t) = k
    v10(t) = val

    return
  end subroutine insert_data

  subroutine write_output_info( fname,                      &
       &                        ix,                         &
       &                        jx,                         &
       &                        kx,                         & 
       &                        it,                         &
       &                        val,                        &
       &                        undef,                      &
       &                        is,                         &
       &                        ie,                         &
       &                        js,                         &
       &                        je,                         &
       &                        ks,                         &
       &                        ke,                         &
       &                        ts,                         &
       &                        te,                         &
       &                        vmax,                       &
       &                        max_i,                      &
       &                        max_j,                      &
       &                        max_k,                      &
       &                        max_t,                      &
       &                        vmin,                       &
       &                        min_i,                      &
       &                        min_j,                      &
       &                        min_k,                      &
       &                        min_t,                      &
       &                        vave,                       &
       &                        vn,                         &
       &                        vna                         )
    character(len=*)               , intent(IN)  :: fname
    integer                        , intent(IN)  :: ix
    integer                        , intent(IN)  :: jx
    integer                        , intent(IN)  :: kx
    integer                        , intent(IN)  :: it
    real   , dimension(ix,jx,kx,it), intent(IN)  :: val
    real                           , intent(IN)  :: undef
    integer                        , intent(IN)  :: is
    integer                        , intent(IN)  :: ie
    integer                        , intent(IN)  :: js
    integer                        , intent(IN)  :: je
    integer                        , intent(IN)  :: ks
    integer                        , intent(IN)  :: ke
    integer                        , intent(IN)  :: ts
    integer                        , intent(IN)  :: te
    real                           , intent(OUT) :: vmax
    integer                        , intent(OUT) :: max_i
    integer                        , intent(OUT) :: max_j
    integer                        , intent(OUT) :: max_k
    integer                        , intent(OUT) :: max_t
    real                           , intent(OUT) :: vmin
    integer                        , intent(OUT) :: min_i
    integer                        , intent(OUT) :: min_j
    integer                        , intent(OUT) :: min_k
    integer                        , intent(OUT) :: min_t
    real                           , intent(OUT) :: vave
    integer                        , intent(OUT) :: vn
    integer                        , intent(OUT) :: vna

    integer :: i
    integer :: j
    integer :: k
    integer :: t

    ! initialize
    vmax  = -1e+35
    vmin  =  1e+35
    vave  =  0.
    max_i = -1
    max_j = -1
    max_k = -1
    max_t = -1
    min_i = -1
    min_j = -1
    min_k = -1
    min_t = -1
    vn    = 0
    vna   = 0

    do t = ts, te
       do k = ks, ke
          do j = js, je
             do i = is, ie
                vn = vn + 1
                if( val(i,j,k,t) == undef ) cycle
                vna  = vna + 1
                vave = vave + val(i,j,k,t)
                if( vmax < val(i,j,k,t) ) then
                   vmax  = val(i,j,k,t)
                   max_i = i
                   max_j = j
                   max_k = k
                   max_t = t
                end if
                if( vmin > val(i,j,k,t) ) then
                   vmin  = val(i,j,k,t)
                   min_i = i
                   min_j = j
                   min_k = k
                   min_t = t
                end if
             end do
          end do
       end do
    end do

    if( vna > 0 ) then
       vave = vave / vna
    else
       vave = undef
    end if

    write(ios,'(a74,$)') fname
    write(ios,'(4i5,$)') ix, jx, kx, it
    write(ios,'(e15.7,4i5,$)') vmax, max_i, max_j, max_k, max_t
    write(ios,'(e15.7,4i5,$)') vmin, min_i, min_j, min_k, min_t
    write(ios,'(e15.7,2i10)') vave, vn, vna

    return
  end subroutine write_output_info

  subroutine Int4Char4( cval, ival, ByteSwap )
    character(len=4), intent(OUT) :: cval
    integer         , intent(IN)  :: ival
    logical         , intent(IN)  :: ByteSwap

    character(len=1) :: ctmp1

    cval = transfer( ival, cval )
    if( ByteSwap ) then
       ctmp1(1:1) = cval(1:1)
       cval(1:1)  = cval(4:4)
       cval(4:4)  = ctmp1(1:1)
       ctmp1(1:1) = cval(2:2)
       cval(2:2)  = cval(3:3)
       cval(3:3)  = ctmp1(1:1)
    end if

  end subroutine Int4Char4
end function FuncOutput
