integer function FuncVint2( stacks, MaxStacks, low, high, mode, no )
  use RPN
  implicit none
  integer        , intent(IN)    :: MaxStacks
  type(RPN_STACK), intent(INOUT) :: stacks(MaxStacks)
  real           , intent(INOUT) :: low
  real           , intent(INOUT) :: high
  integer        , intent(IN)    :: mode
  integer        , intent(IN)    :: no

  integer :: ic, i, j, k, t, iv
  integer :: ix, jx, kx, it
  integer :: kdn, kup
  real :: delta
  real :: rlow, rhigh, tmp, r1d, r2d, r1u, r2u

  real, dimension(:,:,:), allocatable :: vint
  real, dimension(:,:,:), allocatable :: ks, ke
  logical :: pls

  FuncVint2 = RPN_FUNC_OPE_ERROR

  ic = stacks(1)%current

  if( no < 0 ) return
  if( ic < no+2 ) return
  if( stacks(ic)%kx == 1 ) then
     FuncVint2 = RPN_NOERROR
     return
  end if

  if( .not. associated( stacks(ic)%olev ) ) then
     FuncVint2 = RPN_NOT_OUT_LEVELS
     return
  end if

  ix = stacks(ic)%ix
  jx = stacks(ic)%jx
  kx = stacks(ic)%kx
  it = stacks(ic)%it

  ! dimension check
  do i = 2, no+1
     if(    stacks(ic-i+1)%ix /= ix .or. &
          & stacks(ic-i+1)%jx /= jx .or. &
          & stacks(ic-i+1)%kx /= kx .or. &
          & stacks(ic-i+1)%it /= it    ) return
  end do

  allocate( vint(ix,jx,it) )
  allocate(   ks(ix,jx,it) )
  allocate(   ke(ix,jx,it) )
  ks = 1.
  ke = real( kx )
  ke = 1.
  
  do t = 1, it
     do j = 1, jx
        do i = 1, ix
           do k = 1, kx-1
              if( low /= RPN_Undefined ) then
                 rlow =   ( low - stacks(ic)%val(i,j,k,t)   ) &
                      & * ( low - stacks(ic)%val(i,j,k+1,t) )
                 if( rlow <= 0 ) then
                    ks(i,j,t) = ( low - stacks(ic)%val(i,j,k,t) ) &
                         & / ( stacks(ic)%val(i,j,k+1,t)          &
                         &   - stacks(ic)%val(i,j,k,t) ) + k
                    ke(i,j,t) = ks(i,j,t)
                 end if
              end if

              if( high /= RPN_Undefined ) then
                 rhigh =  ( high - stacks(ic)%val(i,j,k,t)   ) &
                      & * ( high - stacks(ic)%val(i,j,k+1,t) )
                 if( rhigh <= 0 ) then
                    ke(i,j,t) = ( high - stacks(ic)%val(i,j,k,t) ) &
                         & / ( stacks(ic)%val(i,j,k+1,t)           &
                         &   - stacks(ic)%val(i,j,k,t) ) + k
                 end if
              else
                 ke(i,j,t) = real(kx)
              end if
           end do
        end do
     end do
  end do

  do iv = ic-no,ic-1
     vint = 0.

     do t = 1, it
        do j = 1, jx
           do i = 1, ix
              if( abs( ke(i,j,t) - ks(i,j,t) ) < 1e-4 ) cycle

              ! bottom
              kdn = int( ks(i,j,t) ) + 1
              r1d = ks(i,j,t) - real( int( ks(i,j,t) ) )
              r2d = real(kdn) - ks(i,j,t)
              if(    stacks(iv)%val(i,j,kdn  ,t) /= stacks(iv)%undef .and. &
                   & stacks(iv)%val(i,j,kdn-1,t) /= stacks(iv)%undef ) then
                 if( low /= RPN_Undefined ) then
                    delta = stacks(ic)%val(i,j,kdn,t) - low
                 else
                    kdn   = 2
                    delta = stacks(ic)%val(i,j,kdn,t) - stacks(ic)%val(i,j,1,t)
                 end if
                 tmp =    r1d * stacks(iv)%val(i,j,kdn  ,t) &
                      & + r2d * stacks(iv)%val(i,j,kdn-1,t)
                 vint(i,j,t) = vint(i,j,t) &
                      & + 0.5 * ( tmp + stacks(iv)%val(i,j,kdn,t) ) * delta
              end if

              ! top
              kup = int( ke(i,j,t) )
              kup = min( kx-1, kup )
              r1u = ke(i,j,t) - real( kup )
              r2u = real( kup+1 ) - ke(i,j,t)
              if(    stacks(iv)%val(i,j,kup+1,t) /= stacks(iv)%undef .and. &
                   & stacks(iv)%val(i,j,kup  ,t) /= stacks(iv)%undef ) then
                 if( high /= RPN_Undefined ) then
                    delta = high - stacks(ic)%val(i,j,kup,t)
                 else
                    kup = kx-1
                    delta =  stacks(ic)%val(i,j,kup+1,t) &
                         & - stacks(ic)%val(i,j,kup,t)
                 end if
                 tmp =    r1u * stacks(iv)%val(i,j,kup+1,t) &
                      & + r2u * stacks(iv)%val(i,j,kup  ,t)
                 vint(i,j,t) = vint(i,j,t) &
                      & + 0.5 * ( tmp + stacks(iv)%val(i,j,kup,t) ) * delta
              end if

              ! middle
              do k = kdn, kup-1
                 if(    stacks(iv)%val(i,j,k  ,t) /= stacks(iv)%undef .and. &
                      & stacks(iv)%val(i,j,k+1,t) /= stacks(iv)%undef ) then
                    if( stacks(ic)%val(i,j,k+1,t) == stacks(ic)%undef .or. &
                         & stacks(ic)%val(i,j,k,t) == stacks(ic)%undef ) cycle
                    delta = stacks(ic)%val(i,j,k+1,t) - stacks(ic)%val(i,j,k,t)
                    vint(i,j,t) = vint(i,j,t) &
                         & + 0.5 * ( stacks(iv)%val(i,j,k  ,t)           &
                         &         + stacks(iv)%val(i,j,k+1,t) ) * delta
                 end if
              end do

           end do
        end do
     end do

     stacks(iv)%kx = 1
!     if( associated( stacks(iv)%val ) ) nullify( stacks(iv)%val )
     if( associated( stacks(iv)%val ) ) deallocate( stacks(iv)%val )
     allocate( stacks(iv)%val(ix,jx,1,it) )

     do t = 1, it
        do j = 1, jx
           do i = 1, ix
              stacks(iv)%val(i,j,1,t) = vint(i,j,t)
           end do
        end do
     end do

  end do

  deallocate( vint )
  deallocate( ks   )
  deallocate( ke   )

  call RPN_ClearStacks( stacks, MaxStacks )
  FuncVint2 = RPN_NOERROR
  return
end function FuncVint2
