!
! [THETAV] [WSPD] [TKE] FUNC(GUST,1)
!
!    or
!
! [THETAV] [WSPD] [TKE] [Z] FUNC(GUST,2)
!
!
integer function FuncWindGust( stacks, MaxStacks, mode )
  use RPN
  use ModelInfo
  use namelist
  use constant
  implicit none
  integer        , intent(IN)    :: MaxStacks
  type(RPN_STACK), intent(INOUT) :: stacks(MaxStacks)
  integer        , intent(IN)    :: mode

  integer :: ix, jx, kx, it
  integer :: ic
  integer :: ip
  integer :: i, j, k, t
  integer :: k1

  logical :: debug

  real :: dz
  real :: tke_top
  real :: g_est
  real :: g_min
  real :: g_max
  real :: itke
  real :: ibuo
  real :: rtke
  real :: vflux
  real :: a
  real :: dth
  real :: ath
  real :: atke

  real, dimension(:,:,:,:), allocatable :: gust
  real, dimension(:,:,:,:), allocatable :: gust_min
  real, dimension(:,:,:,:), allocatable :: gust_max
  real, dimension(:,:,:,:), allocatable :: pbl

  debug = .false.
  a = 2.5 / 11.


  FuncWindGust = RPN_FUNC_OPE_ERROR

  ic = stacks(1)%current

  if( mode < 1 .or. mode > 2 ) return
  if( mode == 1 .and. ic < 4 ) return
  if( mode == 2 .and. ic < 5 ) return

  ix = stacks(ic)%ix
  jx = stacks(ic)%jx
  kx = stacks(ic)%kx
  it = 1

  do ip = ic - mode - 1, ic - 1
     if(    stacks(ip)%ix /= ix .or. &
          & stacks(ip)%jx /= jx .or. &
          & stacks(ip)%kx /= kx .or. &
          & stacks(ip)%it /= it      ) return
  end do

  ! memory allocation
  allocate(      pbl(ix,jx,1,it) )
  allocate(     gust(ix,jx,1,it) )
  allocate( gust_min(ix,jx,1,it) )
  allocate( gust_max(ix,jx,1,it) )

  if( mode == 1 ) then
     ! initialize
     pbl      = stacks(ic-2)%undef
     gust     = stacks(ic-2)%undef
     gust_min = stacks(ic-2)%undef
     gust_max = stacks(ic-2)%undef

     do t = 1, it
        do j = 1, jx-1
           do i = 1, ix-1

              k1 = -1
              do k = 1, kx-1
                 if(    stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and. &
                      & stacks(ic-1)%val(i,j,k,t) /= stacks(ic-1)%undef .and. &
                      & stacks(ic-2)%val(i,j,k,t) /= stacks(ic-2)%undef ) then
                    k1      = k
                    tke_top = 0.01 * stacks(ic)%val(i,j,k,t)
                    g_est   = stacks(ic-1)%val(i,j,k,t)
                    g_min   = stacks(ic-1)%val(i,j,k,t)
                    g_max   = stacks(ic-1)%val(i,j,k,t)
                    exit
                 end if
              end do
              if( k1 < 0 ) cycle
              if( abs( tke_top - stacks(ic-1)%val(i,j,k,t) ) < 1e-4 ) then
                 pbl(i,j,1,t) = stacks(ic)%olev(k1)
                 gust(i,j,1,t) = stacks(ic-1)%val(i,j,k1,t)
                 gust_min(i,j,1,t) = stacks(ic-1)%val(i,j,k1,t)
                 gust_max(i,j,1,t) = stacks(ic-1)%val(i,j,k1,t)
                 cycle
              end if

              itke = 0.
              ibuo = 0.
              do k = k1+1, kx
                 if( stacks(ic)%val(i,j,k,t) == stacks(ic)%undef .or. &
                      & stacks(ic-1)%val(i,j,k,t) == stacks(ic-1)%undef .or. &
                      & stacks(ic-2)%val(i,j,k,t) == stacks(ic-2)%undef ) exit
                 if( stacks(ic)%val(i,j,k,t) < tke_top ) then
                    pbl(i,j,1,t) = stacks(ic)%olev(k-1)
                    exit
                 end if

                 dth  = stacks(ic-2)%val(i,j,k,t) - stacks(ic-2)%val(i,j,k-1,t)
                 ath  = stacks(ic-2)%val(i,j,k,t) + stacks(ic-2)%val(i,j,k-1,t)
                 dz   = stacks(ic)%olev(k) - stacks(ic)%olev(k-1)
                 atke = stacks(ic)%val(i,j,k,t) + stacks(ic)%val(i,j,k-1,t)

                 itke = itke + 0.5 * atke * dz
                 rtke = itke / ( stacks(ic)%olev(k) - stacks(ic)%olev(k1) )
                 ibuo = ibuo + 0.5 * gr * dth / ath * dz

                 if(    rtke >= ibuo .and. &
                      & stacks(ic-1)%val(i,j,k,t) > g_est ) then
                    g_est = stacks(ic-1)%val(i,j,k,t)
                 end if

                 if( a * itke >= ibuo .and. &
                      & stacks(ic-1)%val(i,j,k,t) > g_min ) then
                    g_min = stacks(ic-1)%val(i,j,k,t)
                 end if

                 if( stacks(ic-1)%val(i,j,k,t) > g_max ) then
                    g_max = stacks(ic-1)%val(i,j,k,t)
                 end if

              end do

              gust(i,j,1,t)     = g_est
              gust_min(i,j,1,t) = g_min
              gust_max(i,j,1,t) = g_max

           end do
        end do
     end do

  else if( mode == 2 ) then
     ! initialize
     pbl      = stacks(ic-3)%undef
     gust     = stacks(ic-3)%undef
     gust_min = stacks(ic-3)%undef
     gust_max = stacks(ic-3)%undef

     do t = 1, it
        do j = 1, jx-1
           do i = 1, ix-1

              k1 = -1
              do k = 1, kx-1
                 if(    stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and. &
                      & stacks(ic-1)%val(i,j,k,t) /= stacks(ic-1)%undef .and. &
                      & stacks(ic-2)%val(i,j,k,t) /= stacks(ic-2)%undef .and. &
                      & stacks(ic-3)%val(i,j,k,t) /= stacks(ic-3)%undef ) then
                    k1      = k
                    tke_top = 0.01 * stacks(ic-1)%val(i,j,k,t)
                    g_est   = stacks(ic-2)%val(i,j,k,t)
                    g_min   = stacks(ic-2)%val(i,j,k,t)
                    g_max   = stacks(ic-2)%val(i,j,k,t)
                    exit
                 end if
              end do
              if( k1 < 0 ) cycle
              if( abs( tke_top - stacks(ic-1)%val(i,j,k,t) ) < 1e-4 ) then
                 pbl(i,j,1,t) = stacks(ic)%val(i,j,k1,t)
                 gust(i,j,1,t) = stacks(ic-2)%val(i,j,k1,t)
                 gust_min(i,j,1,t) = stacks(ic-2)%val(i,j,k1,t)
                 gust_max(i,j,1,t) = stacks(ic-2)%val(i,j,k1,t)
                 cycle
              end if

              itke = 0.
              ibuo = 0.
              do k = k1+1, kx
                 if( stacks(ic)%val(i,j,k,t) == stacks(ic)%undef .or. &
                      & stacks(ic-1)%val(i,j,k,t) == stacks(ic-1)%undef .or. &
                      & stacks(ic-2)%val(i,j,k,t) == stacks(ic-2)%undef .or. &
                      & stacks(ic-3)%val(i,j,k,t) == stacks(ic-3)%undef ) exit
                 if( stacks(ic-1)%val(i,j,k,t) < tke_top ) then
                    pbl(i,j,1,t) = stacks(ic)%val(i,j,k-1,t)
                    exit
                 end if

                 dth  = stacks(ic-3)%val(i,j,k,t) - stacks(ic-3)%val(i,j,k-1,t)
                 ath  = stacks(ic-3)%val(i,j,k,t) + stacks(ic-3)%val(i,j,k-1,t)
                 dz   = stacks(ic)%val(i,j,k,t)   - stacks(ic)%val(i,j,k-1,t)
                 atke = stacks(ic-1)%val(i,j,k,t) + stacks(ic-1)%val(i,j,k-1,t)

                 itke = itke + 0.5 * atke * dz
                 rtke = itke / ( stacks(ic)%val(i,j,k,t)  &
                      &        - stacks(ic)%val(i,j,k1,t) )
                 ibuo = ibuo + 0.5 * gr * dth / ath * dz

                 if(    rtke >= ibuo .and. &
                      & stacks(ic-2)%val(i,j,k,t) > g_est ) then
                    g_est = stacks(ic-2)%val(i,j,k,t)
                 end if

                 if( a * stacks(ic-1)%val(i,j,k,t) >= ibuo .and. &
                      & stacks(ic-2)%val(i,j,k,t) > g_min ) then
                    g_min = stacks(ic-2)%val(i,j,k,t)
                 end if

                 if( stacks(ic-2)%val(i,j,k,t) > g_max ) then
                    g_max = stacks(ic-2)%val(i,j,k,t)
                 end if

              end do

              gust(i,j,1,t)     = g_est
              gust_min(i,j,1,t) = g_min
              gust_max(i,j,1,t) = g_max

           end do
        end do
     end do

  end if

  if( mode == 2 ) call RPN_ClearStacks( stacks, MaxStacks )
  call RPN_ClearStacks( stacks, MaxStacks )
  call RPN_ClearStacks( stacks, MaxStacks )

  ic = stacks(1)%current
  stacks(ic)%kx = 4
  deallocate( stacks(ic)%val )
  if( associated( stacks(ic)%olev ) ) deallocate( stacks(ic)%olev )
  allocate( stacks(ic)%val(ix,jx,4,t) )
  allocate( stacks(ic)%olev(4) )

  stacks(ic)%olev(1) = 1.
  stacks(ic)%olev(2) = 2.
  stacks(ic)%olev(3) = 3.
  stacks(ic)%olev(4) = 4.

  do t = 1, it
     do j = 1, jx
        do i = 1, ix
!           if( pbl(i,j,1,t) /= stacks(ic)%undef ) then
              stacks(ic)%val(i,j,1,t) = gust(i,j,1,t)
              stacks(ic)%val(i,j,2,t) = gust_min(i,j,1,t)
              stacks(ic)%val(i,j,3,t) = gust_max(i,j,1,t)
              stacks(ic)%val(i,j,4,t) = pbl(i,j,1,t)
!           else
!              stacks(ic)%val(i,j,1:4,t) = stacks(ic)%undef
!           end if
        end do
     end do
  end do

  deallocate( gust )
  deallocate( gust_min )
  deallocate( gust_max )
  deallocate( pbl )

  FuncWindGust = RPN_NOERROR
  return
end function FuncWindGust
