  integer function MM5_SearchVar_V2( io, M5, vid, t, xtime )
    integer      , intent(IN)    :: io
    type(MM5Data), intent(INOUT) :: M5
    integer      , intent(IN)    :: vid
    integer      , intent(IN)    :: t
    real         , intent(IN)    :: xtime

    integer :: t1, t2, i, itmp

    if( t > 0 ) then
       if( t > M5%it ) then
          MM5_SearchVar_V2 = MM5_out_of_t_range
          return
       end if
       MM5_SearchVar_V2 = MM5_SkipTime_V2( io, M5, M5%cur_t, t - M5%cur_t )
       M5%cur_t         = t
       M5%cur_xtime     = M5%tinfo(t)%xtime
    else
       if( xtime < M5%tvalid_min .and. xtime > M5%tvalid_max ) then
          MM5_SearchVar_V2 = MM5_out_of_t_range
          return
       end if
       t1 = M5%cur_t
       t2 = -1
       do i = 1, M5%it
          if( abs( M5%tinfo(i)%xtime - xtime ) < 0.001 ) then
             t2 = i
             exit
          end if
       end do
       if( t2 < 0 ) then
          MM5_SearchVar_V2 = MM5_no_such_xtime
          return
       end if

       MM5_SearchVar_V2 = MM5_SkipTime_V2( io, M5, t1, t2 - t1 )
       M5%cur_t         = t2
       M5%cur_xtime     = M5%tinfo(t2)%xtime
    end if

    do i = 1, vid
       read( io ) itmp
    end do
    MM5_SearchVar_V2 = MM5_no_error

    return
  end function MM5_SearchVar_V2

  integer function MM5_SkipTime_V2( io, M5, t, skip )
    integer      , intent(IN)    :: io
    type(MM5Data), intent(INOUT) :: M5
    integer      , intent(IN)    :: t, skip

    integer :: i, total, itmp, status

    if( skip > 0 ) then          ! forward skip
       do i = 1, ( M5%nv + 1 ) * skip
          read( io, IOSTAT=status ) itmp
          if( status /= 0 ) then
             MM5_SkipTime_V2 = MM5_read_error
             return
          end if
       end do

    else if( skip < 0 ) then     ! backward skip
       do i = 1, ( M5%nv + 1 ) * abs( skip )
          backspace io
       end do
    end if

    MM5_SkipTime_V2 = MM5_no_error

    return
  end function MM5_SkipTime_V2
