  integer function MM5_GetInfo( io, M5 )
    integer      , intent(IN)    :: io
    type(MM5Data), intent(INOUT) :: M5

    rewind( io )

    if( M5%version == 2 ) then
       status = MM5_GetInfo_V2( io, M5 )
    else if( M5%version == 3 ) then
       status = MM5_GetInfo_V3( io, M5 )
    else
       if( debug ) write(6,*) 'Unit ', io, ' is not MM5 data?'
       MM5_GetInfo = MM5_invalid_format
       return
    end if

    if( status == MM5_now_under_construction ) then
       if( debug ) write(6,*) 'Sorry, now undercontruction (in MM5_GetInfo).'
       return
    else if( status /= MM5_no_error ) then
       if( debug ) write(6,*) 'Some errors occured in MM5_GetInfo.'
       return
    else
       MM5_GetInfo = MM5_no_error
    end if

    rewind( io )
    return
  end function MM5_GetInfo
