  integer function MM5_GetInfo_V3( io, M5 )
    integer      , intent(IN)    :: io
    type(MM5Data), intent(INOUT) :: M5

    integer :: flag, i, j, k, itmp
    real    :: rtmp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    integer           :: ndim
    integer           :: start_index(4), end_index(4)
    real              :: xtime
    character(len=4)  :: staggering, ordering
    character(len=24) :: current_date
    character(len=9)  :: name
    character(len=25) :: unit
    character(len=46) :: description
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    rewind( io )
    MM5_GetInfo_V3 = MM5_no_error

!    if( allocated( M5%v3big ) ) then
!       MM5_GetInfo_V3 = MM5_already_associated_v3head
!       return
!    end if

!    ! allocate V3 big header
!    allocate( M5%v3big )

    do
       read( io, IOSTAT=status ) flag
       if( status /= 0 ) exit
       if( flag /= 0 .and. flag /= 1 .and. flag /= 2 ) exit

       if( flag == 0 ) then
          read( io, IOSTAT=status ) &
               & M5%v3big%bhi, M5%v3big%bhr, M5%v3big%bhic, M5%v3big%bhrc
          if( status /= 0 ) exit

          M5%id = M5%v3big%bhi( 1,1)
          M5%ix = M5%v3big%bhi(16,1)
          M5%jx = M5%v3big%bhi(17,1)
          M5%ds = M5%v3big%bhr( 9,1)
          if( M5%id > 1 ) then
             M5%ptop = M5%v3big%bhr(2,2)
             if( M5%id > 5 ) then
                M5%ps0 = M5%v3big%bhr(2,5)
                M5%ts0 = M5%v3big%bhr(3,5)
                M5%tlp = M5%v3big%bhr(4,5)
             end if
          end if
          if( M5%id < 5 ) then
             if( M5%v3big%bhi(15,1) == 0 .and. M5%v3big%bhi(8,1) == 1 ) then
                M5%ix = M5%v3big%bhi( 9,1)
                M5%jx = M5%v3big%bhi(10,1)
             end if
          end if

          if( associated( M5%level ) ) then
             MM5_GetInfo_V3 = MM5_already_associated_level
             return
          end if

          if( M5%id == 2 .or. M5%id == 3 .or. M5%id == 5 .or. M5%id == 6 .or. &
               M5%id == 7 .or. M5%id == 8 .or. M5%id == 11 ) then
             M5%kx = M5%v3big%bhi(12,M5%id)
             allocate( M5%level( M5%kx ) )
          else
             M5%kx = 1
             allocate( M5%level( 1 ) )
          end if


       else if( flag == 1 ) then   ! data description
          read( io, IOSTAT=status ) ndim, start_index, end_index, xtime, &
               & staggering, ordering, current_date, name, unit, description
          if( status /= 0 ) exit

          M5%tvalid_max = xtime
             
          if( M5%it == 0 ) then
             M5%tvalid_min = xtime
             if( ( M5%id == 2 .or. M5%id == 3 .or. M5%id == 8 ) .and. &
                  & name(1:8) == 'PRESSURE' ) then
                read( io, IOSTAT=status ) M5%level

             else if( ( M5%id == 5 .or. M5%id == 11 ) .and. &
                  & name(1:6) == 'SIGMAH' ) then
                read( io, IOSTAT=status ) M5%level

             else
                read( io, IOSTAT=status ) rtmp
             end if

          else
             read( io, IOSTAT=status ) rtmp
          end if
          if( status /= 0 ) exit
          if( M5%it == 0 ) M5%nv = M5%nv + 1
          if( M5%it == 0 .and. debug ) write(6,'(i3,a10,8i5)') ndim, name

       else if( flag == 2 ) then ! data last
          M5%it = M5%it + 1
       end if

    end do
    
    select case ( M5%id )
    case ( 1 )
       M5%cid = 'TERRAIN   '
    case ( 2 )
       M5%cid = 'DATAGRID  '
    case ( 3 )
       M5%cid = 'RAWINS    '
    case ( 5 )
       M5%cid = 'MMINPUT   '
    case ( 11 )
       M5%cid = 'MMOUTPUT  '
    case ( 8 )
       M5%cid = 'INTERPB   '
    case default
       M5%cid = 'MISC      '
    end select

    rewind( io )

    i = 0
    j = 1
    k = 0

    ! memory allocation
    if( associated( M5%tinfo ) ) then
       MM5_GetInfo_V3 = MM5_already_associated_tinfo
       return
    else
       allocate( M5%tinfo(M5%it) )
    end if

    if( associated( M5%vinfo ) ) then
       MM5_GetInfo_V3 = MM5_already_associated_varinfo
       return
    else
       allocate( M5%vinfo( M5%nv ) )
    end if

    do
       read( io, IOSTAT=status ) flag
       if( status /= 0 ) exit
       if( flag /= 0 .and. flag /= 1 .and. flag /= 2 ) exit
       if( flag == 0 ) then
          read( io ) itmp
          i = i + 2
          M5%tinfo(j)%nv = 0

       else if( flag == 1 ) then
          read( io, IOSTAT=status ) ndim, start_index, end_index, xtime, &
               & staggering, ordering, current_date, name, unit, description
          read( io, IOSTAT=status ) itmp
          M5%tinfo(j)%nv = M5%tinfo(j)%nv + 1
          i = i + 3
          k = k + 1

          if( j == 1 ) then
             M5%vinfo(k)%name = name
             M5%vinfo(k)%ndim = ndim
             M5%vinfo(k)%ix   = end_index(1) - start_index(1) + 1
             M5%vinfo(k)%jx   = end_index(2) - start_index(2) + 1
             if( ndim == 3 ) then
                M5%vinfo(k)%kx = end_index(3) - start_index(3) + 1
             else
                M5%vinfo(k)%kx = -1
             end if
             M5%vinfo(k)%staggering = staggering
             M5%vinfo(k)%ordering   = ordering
          end if

       else if( flag == 2 ) then
          i = i + 1
          M5%tinfo(j)%skip  = i
          M5%tinfo(j)%xtime = xtime
          M5%tinfo(j)%date  = current_date
          i = 0
          j = j + 1
       end if
    end do

    M5%cur_t       = 1
    M5%cur_xtime   = 0.
    MM5_GetInfo_V3 = MM5_no_error

    rewind( io )
    return
  end function MM5_GetInfo_V3
