  type MM5_Variables
     character(len=9) :: name
     integer          :: ndim, ix, jx, kx
     logical          :: coupled
     logical          :: dot
     character(len=4) :: staggering, ordering
  end type MM5_Variables

  type MM5_Times
     integer           :: nv
     integer           :: skip
     real              :: xtime
     character(len=24) :: date
  end type MM5_Times

  ! Version 1 and 2 header
  type MM5_V2HEAD
     integer           :: mif(1000,20)
     real              :: mrf(1000,20)
     character(len=80) :: mifc(1000,20), mrfc(1000,20)
  end type MM5_V2HEAD

  ! Version 3 header
  type MM5_V3BIG
     integer           :: bhi(50,20)
     real              :: bhr(20,20)
     character(len=80) :: bhic(50,20), bhrc(20,20)
  end type MM5_V3BIG

  type MM5Data
     integer           :: version, id, nv, ix, jx, kx, it
     integer           :: cur_t
     real              :: cur_xtime, tvalid_min, tvalid_max
     real              :: ds
     real              :: ptop, ps0, ts0, tlp
     character(len=10) :: cid
     real               , dimension(:), pointer :: level
     type(MM5_Times)    , dimension(:), pointer :: tinfo
     type(mm5_V2HEAD)                           :: v2head
     type(MM5_Variables),dimension(:), pointer  :: vinfo
     type(MM5_V3BIG)                            :: v3big
  end type MM5Data
