module GMT
  implicit none
  private

  interface grd_create
     module procedure grd_create_float
     module procedure grd_create_int
  end interface

  public :: grd_create

contains

  integer function grd_create_float( grdfile,                           &
       &                             var,                               &
       &                             x_range,                           &
       &                             y_range,                           &
       &                             spacing,                           &
       &                             node_offset,                       &
       &                             overwrite,                         &
       &                             NaN,                               &
       &                             iscan,                             &
       &                             jscan                              )

    character(len=*)                 , intent(IN) :: grdfile
    real(4), dimension(:,:)          , intent(IN) :: var
    real(8)                          , intent(IN) :: x_range(2)
    real(8)                          , intent(IN) :: y_range(2)
    real(8)                          , intent(IN) :: spacing(2)
    integer(4)             , optional, intent(IN) :: node_offset
    logical                , optional, intent(IN) :: overwrite
    real(4)                , optional, intent(IN) :: NaN    
    integer(4)             , optional, intent(IN) :: iscan
    integer(4)             , optional, intent(IN) :: jscan

    grd_create_float = -1

    return
  end function grd_create_float

  integer function grd_create_int( grdfile,                              &
       &                           var,                                  &
       &                           x_range,                              &
       &                           y_range,                              &
       &                           spacing,                              &
       &                           node_offset,                          &
       &                           overwrite,                            &
       &                           NaN,                                  &
       &                           iscan,                                &
       &                           jscan                                 )
    character(len=*)          , intent(IN) :: grdfile
    integer(4), dimension(:,:), intent(IN) :: var
    real(8)                   , intent(IN) :: x_range(2)
    real(8)                   , intent(IN) :: y_range(2)
    real(8)                   , intent(IN) :: spacing(2)
    integer(4), optional      , intent(IN) :: node_offset
    logical   , optional      , intent(IN) :: overwrite
    integer(4), optional      , intent(IN) :: iscan
    integer(4), optional      , intent(IN) :: jscan
    real(4)   , optional      , intent(IN) :: NaN

    grd_create_int = -1

    return
  end function grd_create_int

end module GMT
