! little endian <=> big endian
module Endian
  implicit none
  private

  interface ByteSwap
     module procedure ByteSwapInt2
     module procedure ByteSwapInt4
     module procedure ByteSwapReal4
     module procedure ByteSwapReal8
  end interface

  public ::ByteSwap

contains
  ! 2-byte integer
  subroutine ByteSwapInt2( val )
    integer(2), intent(INOUT) :: val
    character(len=2) :: cval
    character(len=1) :: ctmp

    cval = transfer( val, cval )
    call ByteSwapChar( cval )
    val  = transfer( cval, val )
    return
  end subroutine ByteSwapInt2

  ! 4-byte integer
  subroutine ByteSwapInt4( val )
    integer(4), intent(INOUT) :: val
    character(len=4) :: cval
    character(len=1) :: ctmp

    cval = transfer( val, cval )
    call ByteSwapChar( cval )
    val  = transfer( cval, val )
    return
  end subroutine ByteSwapInt4

  ! real
  subroutine ByteSwapReal4( val )
    real(4), intent(INOUT) :: val
    character(len=4) :: cval
    character(len=1) :: ctmp

    cval = transfer( val, cval )
    call ByteSwapChar( cval )
    val  = transfer( cval, val )
    return
  end subroutine ByteSwapReal4

  ! double presision
  subroutine ByteSwapReal8( val )
    real(8), intent(INOUT) :: val
    character(len=4) :: cval
    character(len=1) :: ctmp

    cval = transfer( val, cval )
    call ByteSwapChar( cval )
    val  = transfer( cval, val )
    return
  end subroutine ByteSwapReal8

  ! main subroutine of byte swap
  subroutine ByteSwapChar( cval )
    character(len=*), intent(INOUT) :: cval
    integer          :: i, j, ix, csize
    character(len=1) :: ctmp

    csize = len( cval )
    ix = csize / 2
    do i = 1, ix
       j = csize - i + 1
       ctmp = cval(i:i)
       cval(i:i) = cval(j:j)
       cval(j:j) = ctmp
    end do
    return
  end subroutine ByteSwapChar
end module Endian
