  subroutine ReadModelInfoBinary( IO, m, ierr )
    integer    , intent(IN)    :: IO, m
    integer    , intent(OUT)   :: ierr

    integer :: status, ip, nstr, DataType
    integer :: it, ifiles, ift, ifc, tsep, ct, itmp
    integer :: i, j, k, t
    real    :: tmp, z1st, zinc
    real    :: latr, lonr, xr, yr
    character(len=1028) :: buf
    character(len=20)  :: ctitle
    character(len=100) :: cvalue

    ierr = MI_BINARY_INFO_ERROR

    ! TotalDates
    ip     = 0
    buf    = c128
    ctitle = c20
    cvalue = c100
    read( IO, '(a)', IOSTAT=status ) buf
    if( status /= 0 ) return
    DataType = InquireStringType( buf, ip )
    status   = InquireCharacter( buf, ip, nstr, ctitle )
    if( ctitle(1:10) /= 'TotalDates' ) return
    DataType = InquireStringType( buf, ip )
    if( DataType /= TypeNumber ) return
    status = InquireNumber( buf, ip, tmp )
    it = int( tmp )
    if( m == 1 ) then
       Model_it = it
    end if
    MODEL(m)%it = it
    allocate( MODEL(m)%Tinfo(it), STAT=status )
    if( status /= 0 ) return

    MODEL(m)%cproj = 'NOPROJ'
    MODEL(m)%cone  = 1.

    do i = 1, it
       read( IO, '(a)', IOSTAT=status ) buf
       if( status /= 0 ) return
       MODEL(m)%Tinfo(i)%cdate = buf(1:24)
       MODEL(m)%Tinfo(i)%File  = ''
    end do

    ! xsep & ysep
    ip = 0
    buf = ''
    ctitle = ''
    read( IO, '(a)', IOSTAT=status ) buf
    if( status /= 0 ) return
    if( buf(1:1) == '/' ) then
       read( IO, '(a)', IOSTAT=status ) buf
       if( status /= 0 ) return
    end if
    DataType = InquireStringType( buf, ip )
    status   = InquireCharacter( buf, ip, nstr, ctitle )
    call ToUpper( ctitle )
    if( ctitle(1:4) == 'XSEP' ) then
       DataType = InquireStringType( buf, ip )
       status   = InquireNumber( buf, ip, MODEL(m)%xsep )

       ip       = 0
       buf      = ''
       ctitle   = ''
       read( IO, '(a)', IOSTAT=status ) buf
       if( status /= 0 ) return
       DataType = InquireStringType( buf, ip )
       status   = InquireCharacter( buf, ip, nstr, ctitle )
       call ToUpper( ctitle )
    else
       MODEL(m)%xsep = 1
    end if

    if( ctitle(1:4) == 'YSEP' ) then
       DataType = InquireStringType( buf, ip )
       status   = InquireNumber( buf, ip, MODEL(m)%ysep )

       ip       = 0
       buf      = ''
       ctitle   = ''
       read( IO, '(a)', IOSTAT=status ) buf
       if( status /= 0 ) return
       DataType = InquireStringType( buf, ip )
       status   = InquireCharacter( buf, ip, nstr, ctitle )
       call ToUpper( ctitle )
    else
       MODEL(m)%ysep = 1
    end if

    ! memory allocation
    tsep = MODEL(m)%xsep * MODEL(m)%ysep
    do i = 1, it
       allocate( MODEL(m)%Tinfo(i)%Files(tsep) )
       MODEL(m)%Tinfo(i)%Files = ''
    end do
    allocate( MODEL(m)%isep(0:MODEL(m)%xsep) )
    allocate( MODEL(m)%jsep(0:MODEL(m)%ysep) )
    MODEL(m)%isep(0) = 0
    MODEL(m)%jsep(0) = 0

    ! TotalFiles
    if( ctitle(1:10) /= 'TOTALFILES' ) return
    DataType = InquireStringType( buf, ip )
    if( DataType /= TypeNumber ) return
    status = InquireNumber( buf, ip, ifiles )

    ct = 0
    do i = 1, ifiles
       ip     = 0
       buf    = c128
       cvalue = c100
       read( IO, '(a)', IOSTAT=status ) buf
       if( status /= 0 ) return

       DataType = InquireStringType( buf, ip )
       if( DataType /= TypeNumber ) return
       status = InquireNumber( buf, ip, ift )

       DataType = InquireStringType( buf, ip )
       status   = InquireCharacter( buf, ip, nstr, cvalue )

       do j = 1, ift
          DataType = InquireStringType( buf, ip )
          if( DataType /= TypeNumber ) return
          status = InquireNumber( buf, ip, ifc )

          if( ifc > it ) return

          if( MODEL(m)%xsep == 1 .and. MODEL(m)%ysep == 1 ) then
             if( ifc > 0 ) then
                MODEL(m)%Tinfo(ifc)%ipos = j
                MODEL(m)%Tinfo(ifc)%File = trim( cvalue )
                ct = ifc
             else
                do t = j, ift
                   ifc = ct + 1
                   MODEL(m)%Tinfo(ifc)%ipos = t
                   MODEL(m)%Tinfo(ifc)%File = trim( cvalue )
                   ct = ifc
                end do
                exit
             end if
          else
             if( ifc < 1 ) return
             MODEL(m)%Tinfo(ifc)%ipos = j

             if( MODEL(m)%Tinfo(ifc)%File == '' ) then
                MODEL(m)%Tinfo(ifc)%File     = trim( cvalue )
                MODEL(m)%Tinfo(ifc)%Files(1) = trim( cvalue )
             else
                do t = 2, tsep
                   if( MODEL(m)%Tinfo(ifc)%Files(t) == '' ) then
                      MODEL(m)%Tinfo(ifc)%Files(t) = trim( cvalue )
                      exit
                   end if
                end do
             end if
          end if
       end do
    end do

    ! other data
    do
       ip     = 0
       buf    = c128
       ctitle = c20
       cvalue = c100

       read( IO, '(a)', IOSTAT=status ) buf
       if( status /= 0 ) exit
       if( buf(1:1) == '/' ) cycle

       DataType = InquireStringType( buf, ip )
       if( DataType /= TypeChar ) cycle
       status = InquireCharacter( buf, ip, nstr, ctitle )
       if( ctitle(1:1) == '#' ) cycle
       DataType = InquireStringType( buf, ip )

       call ToUpper( ctitle )
       if( ctitle(1:10) == 'ENDIANTYPE' ) then
          status = InquireCharacter( buf, ip, nstr, MODEL(m)%Endian )

       else if( ctitle(1:8) == 'BYTESIZE' ) then
          status = InquireNumber( buf, ip, MODEL(m)%ByteSize )

       else if( ctitle(1:6) == 'VSLICE' ) then
          status = InquireCharacter( buf, ip, nstr, cvalue )
          call ToUpper( cvalue )
          if( cvalue(1:5) == 'FALSE' ) then
             MODEL(m)%Vslice = .false.
          else
             MODEL(m)%Vslice = .true.
          end if

       else if( ctitle(1:6) == 'SIGNED' ) then
          status = InquireCharacter( buf, ip, nstr, cvalue )
          call ToUpper( cvalue )
          if( cvalue(1:5) == 'FALSE' ) then
             MODEL(m)%Signed = .false.
          else
             MODEL(m)%Signed = .true.
          end if

       else if( ctitle(1:9) == 'UNDEFINED' ) then
!          call ToUpper( buf )
          if( MODEL(m)%ByteSize == 1 ) then
             status = InquireNumber( buf, ip, itmp )
             if( MODEL(m)%Signed ) then
                MODEL(m)%Undef1i = itmp
             else
                if( itmp >= 128 ) then
                   MODEL(m)%Undef1i = itmp - 256
                end if
             end if
             MODEL(m)%Undef = MI_Undefined
          else if( MODEL(m)%ByteSize == 2 ) then
             status = InquireNumber( buf, ip, MODEL(m)%Undef2i )
             MODEL(m)%Undef = MI_Undefined
          else
             status = InquireNumber( buf, ip, MODEL(m)%Undef )
          end if

       else if( ctitle(1:9) == 'GRIDSIZEX' ) then
          status = InquireNumber( buf, ip, MODEL(m)%ix )
          if( m == 1 ) Model_ix = MODEL(m)%ix

          if( MODEL(m)%xsep == 1 ) then
             MODEL(m)%isep(1) = MODEL(m)%ix
          else
             do i = 1, MODEL(m)%xsep
                DataType = InquireStringType( buf, ip )
                status = InquireNumber( buf, ip, MODEL(m)%isep(i) )
                if( status /= STRING_NOERROR ) return
             end do
          end if

       else if( ctitle(1:9) == 'GRIDSIZEY' ) then
          status = InquireNumber( buf, ip, MODEL(m)%jx )
          if( m == 1 ) Model_jx = MODEL(m)%jx

          if( MODEL(m)%ysep == 1 ) then
             MODEL(m)%jsep(1) = MODEL(m)%jx
          else
             do i = 1, MODEL(m)%ysep
                DataType = InquireStringType( buf, ip )
                status = InquireNumber( buf, ip, MODEL(m)%jsep(i) )
                if( status /= STRING_NOERROR ) return
             end do
          end if

       else if( ctitle(1:9) == 'GRIDSIZEZ' ) then
          status = InquireNumber( buf, ip, MODEL(m)%kx )
          if( m == 1 ) Model_kx = MODEL(m)%kx
          allocate( MODEL(m)%lev( MODEL(m)%kx ) )

       else if( ctitle(1:6) == 'DELTAX' ) then
          status = InquireNumber( buf, ip, MODEL(m)%dx )

       else if( ctitle(1:6) == 'DELTAY' ) then
          status = InquireNumber( buf, ip, MODEL(m)%dy )

       else if( ctitle(1:6) == 'DELTAT' ) then
          status = InquireNumber( buf, ip, MODEL(m)%dt )

       else if( ctitle(1:5) == 'HUNIT' ) then
          status = InquireCharacter( buf, ip, nstr, MODEL(m)%hunit )

       else if( ctitle(1:5) == 'VUNIT' ) then
          status = InquireCharacter( buf, ip, nstr, MODEL(m)%vunit )

       else if( ctitle(1:5) == 'MPROJ' ) then
          status = InquireNumber( buf, ip, MODEL(m)%mproj )
          select case( MODEL(m)%mproj )
          case ( 0 )
             MODEL(m)%cproj = 'LATLON'
          case ( 1 )
             MODEL(m)%cproj = 'MERCAT'
          case ( 2 )
             MODEL(m)%cproj = 'LAMCON'
          case ( 3 )
             MODEL(m)%cproj = 'PSTEREO'
          case default
             MODEL(m)%cproj = 'NOPROJ'
          end select

       else if( ctitle(1:8) == 'TRUELAT1' ) then
          status = InquireNumber( buf, ip, MODEL(m)%tlat1 )

       else if( ctitle(1:8) == 'TRUELAT2' ) then
          status = InquireNumber( buf, ip, MODEL(m)%tlat2 )

       else if( ctitle(1:7) == 'TRUELON' ) then
          status = InquireNumber( buf, ip, MODEL(m)%tlon )

       else if( ctitle(1:6) == 'REFLAT' ) then
          status = InquireNumber( buf, ip, latr )

       else if( ctitle(1:6) == 'REFLON' ) then
          status = InquireNumber( buf, ip, lonr )

       else if( ctitle(1:4) == 'REFX' ) then
          status = InquireNumber( buf, ip, xr )

       else if( ctitle(1:4) == 'REFY' ) then
          status = InquireNumber( buf, ip, yr )

       else if( ctitle(1:11) == 'EARTHRADIUS' ) then
          status = InquireNumber( buf, ip, MODEL(m)%er )

       else if( ctitle(1:5) == 'LEVEL' ) then
          zinc = 0.
          if( DataType == TypeNumber ) then
             status = InquireNumber( buf, ip, z1st )
             DataType = InquireStringType( buf, ip )
             if( DataType == TypeNumber ) then
                status = InquireNUmber( buf, ip, zinc )
                do i = 1, MODEL(m)%kx
                   MODEL(m)%lev(i) = z1st + real( i - 1 ) * zinc
                end do
             end if
             if( zinc /= 0. ) cycle
          end if

          k = 0
          do
             ip     = 0
             buf    = c128
             ctitle = c20
             cvalue = c100
             read( IO, '(a)', IOSTAT=status ) buf
             if( status /= 0 ) return
             if( buf(1:1) == '/' ) then
                if( k == MODEL(m)%kx ) then
                   exit
                else
                   return
                end if
             end if

             do
                DataType = InquireStringType( buf, ip )
                if( DataType == TypeNumber ) then
                   k = k + 1
                   status = InquireNumber( buf, ip, MODEL(m)%lev(k) )
                else if( DataType == TypeChar ) then
                   cycle
                else
                   exit
                end if
             end do
          end do

       else if( ctitle(1:14) == 'TOTALVARIABLES' ) then
          status = InquireNumber( buf, ip, MODEL(m)%TotalVariables )

          allocate( MODEL(m)%Vinfo(MODEL(m)%TotalVariables), STAT=status )
          if( status /= 0 ) return

          if( .not. MODEL(m)%Vslice )                            &
               &  MODEL(m)%ByteSize = MODEL(m)%ByteSize          &
               &                    * MODEL(m)%ix * MODEL(m)%jx

          do i = 1, MODEL(m)%TotalVariables
             ip     = 0
             buf    = c128
             ctitle = c20
             cvalue = c100
             read( IO, '(a)', IOSTAT=status ) buf
             if( status /= 0 ) return

             ! variable name
             DataType = InquireStringType( buf, ip )
             status = InquireCharacter( buf, ip, nstr, MODEL(m)%Vinfo(i)%name )

             ! dimensions
             MODEL(m)%Vinfo(i)%scale_factor = 1.
             MODEL(m)%Vinfo(i)%add_offset   = 0.
             do j = 1, 6
                DataType = InquireStringType( buf, ip )
                if( DataType /= TypeNumber ) then
                   if( j < 5 ) then
                      return
                   else
                      exit
                   end if
                end if
                status = InquireNumber( buf, ip, tmp )
                if( j == 1 ) then
                   MODEL(m)%Vinfo(i)%ix = int( tmp )
                else if( j == 2 ) then
                   MODEL(m)%Vinfo(i)%jx = int( tmp )
                else if( j == 3 ) then
                   MODEL(m)%Vinfo(i)%kx = int( tmp )
                else if( j == 4 ) then
                   MODEL(m)%Vinfo(i)%it = int( tmp )
                else if( j == 5 ) then
                   MODEL(m)%Vinfo(i)%scale_factor = tmp
                else if( j == 6 ) then
                   MODEL(m)%Vinfo(i)%add_offset = tmp
                end if
             end do

             if( i == 1 ) then
                MODEL(m)%Vinfo(i)%rec  = 1
                MODEL(m)%trec          = 1
             end if

             if( i /= MODEL(m)%TotalVariables ) then
                if( MODEL(m)%Vslice ) then
                   MODEL(m)%Vinfo(i+1)%rec = MODEL(m)%Vinfo(i)%rec &
                        &                  + MODEL(m)%Vinfo(i)%ix  &
                        &                  * MODEL(m)%Vinfo(i)%jx  &
                        &                  * MODEL(m)%Vinfo(i)%kx  &
                        &                  * MODEL(m)%Vinfo(i)%it
                else
                   MODEL(m)%Vinfo(i+1)%rec = MODEL(m)%Vinfo(i)%rec &
                        &                  + MODEL(m)%Vinfo(i)%kx  &
                        &                  * MODEL(m)%Vinfo(i)%it
                end if
             end if

             if( i == MODEL(m)%TotalVariables ) then
                if( i /= 1 ) then
                   if( MODEL(m)%Vslice ) then
                      MODEL(m)%trec = MODEL(m)%Vinfo(i)%rec
!                      MODEL(m)%trec = MODEL(m)%Vinfo(i)%rec &
!                           &        + MODEL(m)%Vinfo(i)%ix  &
!                           &        * MODEL(m)%Vinfo(i)%jx  &
!                           &        * MODEL(m)%Vinfo(i)%kx  &
!                           &        * MODEL(m)%Vinfo(i)%it
                   else
                      MODEL(m)%trec = MODEL(m)%Vinfo(i)%rec
!                           &        + MODEL(m)%Vinfo(i)%kx  &
!                           &        * MODEL(m)%Vinfo(i)%it
                   end if
                end if
             end if
             ! description

             ! unit
          end do

       end if
    end do

    if( MODEL(m)%cproj == 'LATLON' ) then
       MODEL(m)%slon = lonr - ( xr - 1 ) * MODEL(m)%dx
       MODEL(m)%slat = latr - ( yr - 1 ) * MODEL(m)%dy
    else if( MODEL(m)%cproj /= 'NOPROJ' ) then
       call ll2xy( lonr,           &
            &      latr,           &
            &      MODEL(m)%xc,    &
            &      MODEL(m)%yc,    &
            &      MODEL(m)%cproj, &
            &      MODEL(m)%dx,    &
            &      MODEL(m)%dy,    &
            &      MODEL(m)%tlon,  &
            &      latr,           &
            &      0.,             &
            &      0.,             &
            &      tlat1=MODEL(m)%tlat1, &
            &      tlat2=MODEL(m)%tlat2, &
            &      earth=MODEL(m)%er )

       MODEL(m)%xc   = xr - MODEL(m)%xc
       MODEL(m)%yc   = yr - MODEL(m)%yc
       MODEL(m)%clon = MODEL(m)%tlon
       MODEL(m)%clat = latr

       if( MODEL(m)%cproj == 'LAMCON' ) then
          MODEL(m)%cone = ( log(cos(MODEL(m)%tlat1*d2r))                  &
               &          - log(cos(MODEL(m)%tlat2*d2r)) )                &
               &        / ( log(tan(0.25*pi-0.5*d2r*abs(MODEL(m)%tlat1))) &
               &          - log(tan(0.25*pi-0.5*d2r*abs(MODEL(m)%tlat2))) )
       end if
    end if

    ierr = MI_NOERROR
    return
  end subroutine ReadModelInfoBinary
