  subroutine ReadModelInfoGRIB1( IO, m, ierr )
    integer, intent(IN)  :: IO, m
    integer, intent(OUT) :: ierr

    integer :: status, ip, nstr, DataType
    integer :: ifiles, mIO
    integer :: i, j, k, t, ct

    character(len=128) :: buf
    character(len=20)  :: ctitle
    character(len=100) :: cvalue

    character(len=128) :: Mfile(MaxInFiles)
   
    logical       :: InitialOnly

    ! defaults
    ierr        = MI_GRIB1_INFO_ERROR
    mIO         = DIO
    InitialOnly = .true.

    ! TotalFiles
    ip     = 0
    buf    = ''
    ctitle = ''
    read( IO, '(a)', IOSTAT=status ) buf
    if( status /= 0 ) return
    DataType = InquireStringType( buf, ip )
    status   = InquireCharacter( buf, ip, nstr, ctitle )
    call ToUpper( ctitle )

    MODEL(m)%it = 0
       
    if( ctitle(1:10) /= 'TOTALFILES' ) return
    DataType = InquireStringType( buf, ip )
    if( DataType /= TypeNumber ) return
    status = InquireNumber( buf, ip, ifiles )

    ! defaults
    MODEL(m)%TotalVariables = 0
    MODEL(m)%DataType       = 'GRIB1 '
    MODEL(m)%vunit          = 'hPa '
    MODEL(m)%hunit          = 'degree '
    MODEL(m)%Undef          = -1.e+35

    ! check total dates and vertical levels
    ct = 0
    do i = 1, ifiles
       ip     = 0
       buf    = ''
       cvalue = ''
       read( IO, '(a)', IOSTAT=status ) buf
       if( status /= 0 ) return
       Mfile(i) = buf

    end do

    ! other data
    do 
       ip     = 0
       buf    = ''
       ctitle = ''
       cvalue = ''

       read( IO, '(a)', IOSTAT=status ) buf
       if( status /= 0 ) exit
       if( buf(1:1) == '/' ) cycle

       DataType = InquireStringType( buf, ip )
       if( DataType /= TypeChar ) cycle
       status = InquireCharacter( buf, ip, nstr, ctitle )
       if( ctitle(1:1) == '#' ) cycle
       DataType = InquireStringType( buf, ip )

       call ToUpper( ctitle )
       if( ctitle(1:10) == 'ENDIANTYPE' ) then
          status = InquireCharacter( buf, ip, nstr, MODEL(m)%Endian )

       else if( ctitle(1:8) == 'BYTESIZE' ) then
          status = InquireNumber( buf, ip, MODEL(m)%ByteSize )

       else if( ctitle(1:6) == 'DELTAT' ) then
          status = InquireNumber( buf, ip, MODEL(m)%dt )

       end if

    end do

    ierr = MI_NOERROR
    return
  end subroutine ReadModelInfoGRIB1
