subroutine PrintAvailable( const, MaxConstants, &
     &                     eqns , MaxEquations  )
  use ModelInfo
  use RPN
  implicit none
  integer        , intent(IN) :: MaxConstants
  integer        , intent(IN) :: MaxEquations
  type(RPN_CONST), intent(IN) :: const(MaxConstants)
  type(RPN_EQN)  , intent(IN) :: eqns(MaxEquations)

  character(len=79) :: hr
  integer :: i, j

  hr =      '========================================' &
       & // '======================================='

  write(6,*)
  write(6,*) 'CONSTANTS', const(1)%current
  write(6,*) hr
  do i = 2, const(1)%current
     write(6,*) const(i)%name(1:10), const(i)%val, const(i)%unit(1:20)
  end do
  write(6,*) hr

  write(6,*)
  write(6,*) 'EQUATIONS', eqns(1)%current
  write(6,*) hr
  do i = 2, eqns(1)%current
     write(6,*) eqns(i)%name(1:10), eqns(i)%def(1:50), eqns(i)%unit(1:10)
  end do

  do i = 1, MODEL(1)%TotalInfo
     write(6,*)
     write(6,*) 'MODEL (', i, ')'
     write(6,*) hr
     write(6,*) 'GRID(DX,DY,DT): ', MODEL(i)%dx, MODEL(i)%dy, MODEL(i)%dt
     write(6,*) 'TIME:', MODEL(i)%it
     do j = 1, MODEL(i)%it
        write(6,*) MODEL(i)%Tinfo(j)%cdate
     end do

     write(6,*)
     write(6,*) 'VARIABLES:', MODEL(i)%TotalVariables
     do j = 1, MODEL(i)%TotalVariables
        write(6,*) MODEL(i)%Vinfo(j)%name(1:10), &
             &     MODEL(i)%Vinfo(j)%ix,         &
             &     MODEL(i)%Vinfo(j)%jx,         &
             &     MODEL(i)%Vinfo(j)%kx,         &
             &     MODEL(i)%Vinfo(j)%it
     end do

     write(6,*)
     write(6,*) 'LEVELS:', MODEL(i)%kx
     if( associated( MODEL(i)%lev ) ) then
        do j = 1, MODEL(i)%kx
           write(6,*) j, MODEL(i)%lev(j)
        end do
     end if
  end do
  write(6,*) hr
  return
end subroutine PrintAvailable
