! contains with readfromdata.f90
  subroutine ReadBinaryData( status, odr )
    integer, intent(INOUT) :: status
    integer, intent(IN)    :: odr

    integer :: im, imf, iv, itmp
    integer :: ix, jx, kx, it, io
    integer :: i, j, k, t, td, irec, tsep
    integer :: i1, i2, j1, j2, x1, x2, y1, y2
    integer :: recl, bsize, nByte

!    TOTAL: do im = 1, MODEL(1)%TotalInfo
    TOTAL: do imf = 1, MaxDefineFiles
       im = order(imf,odr)
       if( im > MODEL(1)%TotalInfo ) cycle

       if( .not. MODEL(im)%Vslice ) then
          nByte = MODEL(im)%ByteSize / MODEL(im)%ix / MODEL(im)%jx
       else
          nByte = MODEL(im)%ByteSize
       end if
       do iv = 1, MODEL(im)%TotalVariables
          if( VarName(1:clen+1) == Model(im)%Vinfo(iv)%name(1:clen+1) ) then
             ix = MODEL(im)%Vinfo(iv)%ix
             jx = MODEL(im)%Vinfo(iv)%jx
             kx = MODEL(im)%Vinfo(iv)%kx
             it = MODEL(im)%Vinfo(iv)%it

             if( MODEL(im)%Tinfo(1)%cdate(1:1) == 's' ) then
                Ctime = 1
                Cdate = 'YYYY-MM-DD_hh:mm:ss.ssss'

             else
                Ctime = - Ctime
                do t = 1, MODEL(im)%it
                   if( MODEL(im)%Tinfo(t)%cdate == Cdate ) then
                      Ctime = t
                      exit
                   end if
                end do
                if( Ctime < 0 ) then
                   Ctime = - Ctime
                   exit TOTAL
                end if
             end if

             if( RPN_debug ) write(6,*) '***READ: ', Ctime, Cdate, trim(MODEL(im)%Tinfo(Ctime)%File)

             allocate(  vtmp(ix,jx,kx,it) )
             allocate( i1tmp(ix,jx,kx,it) )
             allocate( i2tmp(ix,jx,kx,it) )
             vtmp = MODEL(im)%undef
             IO   = DIO + im - 1

             tsep = MODEL(im)%xsep * MODEL(im)%ysep
             do td = 1, tsep
                if( tsep == 1 ) then
                   open(  IO,                                         &
                        & file=trim( MODEL(im)%Tinfo(Ctime)%File ),   &
                        & access='direct',                            &
                        & recl=MODEL(im)%ByteSize,                    &
                        & IOSTAT=status                               )
                else
                   i2 = mod( td, MODEL(im)%xsep )
                   if( i2 == 0 ) i2 = MODEL(im)%xsep
                   if( i2 > MODEL(im)%xsep ) i2 = MODEL(im)%xsep
!                   j2 = ( td - 1 ) / MODEL(im)%ysep + 1
                   j2 = ( td - i2 ) / MODEL(im)%xsep + 1
                   if( j2 > MODEL(im)%ysep ) j2 = MODEL(im)%ysep
                   
                   if( MODEL(im)%Tinfo(Ctime)%Files(td)(1:4) == 'NULL' ) then
                      cycle
                   end if

                   recl  = MODEL(im)%isep(i2)*MODEL(im)%jsep(j2)
                   recl  = ( MODEL(im)%isep(i2) - MODEL(im)%isep(i2-1) )    &
                        &  * ( MODEL(im)%jsep(j2) - MODEL(im)%jsep(j2-1) )
                   bsize = MODEL(im)%ByteSize                        &
                        & / MODEL(im)%Vinfo(iv)%ix / MODEL(im)%Vinfo(iv)%jx &
                        & * recl
                   open(  IO,                                            &
                        & file=trim( MODEL(im)%Tinfo(Ctime)%Files(td) ), &
                        & access='direct',                               &
                        & recl=bsize,                                    &
                        & IOSTAT=status                                  )
                end if
                if( status /= 0 ) return

                if( tsep == 1 ) then
                   irec = MODEL(im)%Vinfo(iv)%rec               &
                        & + ( MODEL(im)%Tinfo(Ctime)%ipos - 1 ) &
                        & * MODEL(im)%trec
                else
                   irec = MODEL(im)%Vinfo(iv)%rec &
                        & + ( MODEL(im)%Tinfo(Ctime)%ipos - 1 ) &
                        & * MODEL(im)%trec / MODEL(im)%ix / MODEL(im)%jx * recl
                end if

                if( MODEL(im)%Vslice ) then
                   if( tsep /= 1 ) return
                   do t = 1, it
                      do k = 1, kx
                         do j = 1, jx
                            do i = 1, ix
                               if( nByte == 4 ) then
                                  read( IO, rec=irec, IOSTAT=status ) vtmp(i,j,k,t)
                               else if( nByte == 2 ) then
                                  read( IO, rec=irec, IOSTAT=status ) i2tmp(i,j,k,t)
                               else if( nByte == 1 ) then
                                  read( IO, rec=irec, IOSTAT=status ) i1tmp(i,j,k,t)
                               end if
                               if( status /= 0 ) return
                               irec = irec + 1
                            end do
                         end do
                      end do
                   end do

                else
                   i2 = mod( td, MODEL(im)%xsep )
                   if( i2 == 0 ) i2 = MODEL(im)%xsep
                   if( i2 > MODEL(im)%xsep ) i2 = MODEL(im)%xsep
                   i1 = i2 - 1
!                   j2 = ( td + 1 - i2 ) / MODEL(im)%xsep + 1
                   j2 = ( td - i2 ) / MODEL(im)%xsep + 1
                   if( j2 > MODEL(im)%ysep ) j2 = MODEL(im)%ysep
                   j1 = j2 - 1

                   x1 = MODEL(im)%isep(i1) + 1
                   x2 = MODEL(im)%isep(i2)
                   y1 = MODEL(im)%jsep(j1) + 1
                   y2 = MODEL(im)%jsep(j2)
                   do t = 1, it
                      do k = 1, kx
                         if( nByte == 4 ) then
                            read( IO, rec=irec, IOSTAT=status ) vtmp(x1:x2,y1:y2,k,t)
                         else if( nByte == 2 ) then
                            read( IO, rec=irec, IOSTAT=status ) i2tmp(x1:x2,y1:y2,k,t)
                         else if( nByte == 1 ) then
                            read( IO, rec=irec, IOSTAT=status ) i1tmp(x1:x2,y1:y2,k,t)
                         end if
                         if( status /= 0 ) return
                         irec = irec + 1
                      end do
                   end do
                end if
                close( IO )
             end do
             
             if( MODEL(im)%Endian(1:4) == 'SWAP' ) then
                do t = 1, it
                   do k = 1, kx
                      do j = 1, jx
                         do i = 1, ix
                            if( nByte == 4 ) then
                               call ByteSwap( vtmp(i,j,k,t) )
                            else if( nByte == 2 ) then
                               call ByteSwap( i2tmp(i,j,k,t) )
                            end if
                         end do
                      end do
                   end do
                end do
             end if

             if( nByte == 2 ) then
                do t = 1, it
                   do k = 1, kx
                      do j = 1, jx
                         do i = 1, ix
                            if( i2tmp(i,j,k,t) /= MODEL(im)%Undef2i ) then
                               vtmp(i,j,k,t) = MODEL(im)%Vinfo(iv)%scale_factor &
                                    & * real( i2tmp(i,j,k,t) ) + MODEL(im)%Vinfo(iv)%add_offset
                            else
                               vtmp(i,j,k,t) = MODEL(im)%Undef
                            end if
                         end do
                      end do
                   end do
                end do

             else if( nByte == 1 ) then
                do t = 1, it
                   do k = 1, kx
                      do j = 1, jx
                         do i = 1, ix
                            if( i1tmp(i,j,k,t) /= MODEL(im)%Undef1i ) then
                               itmp = i1tmp(i,j,k,t)
                               if( .not. MODEL(im)%Signed ) then
                                  if( itmp < 0 ) itmp = 256 + itmp
                               end if
                               vtmp(i,j,k,t) = MODEL(im)%Vinfo(iv)%scale_factor * real( itmp ) + MODEL(im)%Vinfo(iv)%add_offset
                            else
                               vtmp(i,j,k,t) = MODEL(im)%Undef
                            end if
                         end do
                      end do
                   end do
                end do
             end if

             status = RPN_PushStack( stacks,             &
                  &                  MaxStacks,          &
                  &                  vtmp,               &
                  &                  ix,                 &
                  &                  jx,                 &
                  &                  kx,                 &
                  &                  it,                 &
                  &                  MODEL(im)%Undef,    &
                  &                  model=im,           &
                  &                  omodel=im,          &
                  &                  olev=MODEL(im)%lev, &
                  &                  cdate=Cdate         )
              
             DataRead = .true.

             deallocate(  vtmp )
             deallocate( i1tmp )
             deallocate( i2tmp )
             exit TOTAL
!             close( IO )
          end if
       end do
    end do TOTAL

    if( .not. DataRead ) then
       if( NoData == 0 .or. NoData == 1 ) then
          ix = MODEL(modelno)%Vinfo(iv)%ix
          jx = MODEL(modelno)%Vinfo(iv)%jx
          kx = MODEL(modelno)%Vinfo(iv)%kx
          it = MODEL(modelno)%Vinfo(iv)%it
          allocate( vtmp(ix,jx,kx,it) )

          if( NoData == 0 ) then
             vtmp = 0.
          else if( NoData == 1 ) then
             vtmp = RPN_Undefined
          end if
           
          status = RPN_PushStack( stacks,                  &
               &                  MaxStacks,               &
               &                  vtmp,                    &
               &                  ix,                      &
               &                  jx,                      &
               &                  kx,                      &
               &                  it,                      &
               &                  RPN_Undefined,           &
               &                  model=modelno,           &
               &                  omodel=modelno,          &
               &                  olev=MODEL(modelno)%lev, &
               &                  cdate=Cdate              )
          deallocate( vtmp )

       else
          status = RPN_NO_READ_DATA
       end if
    end if

    return
  end subroutine ReadBinaryData
