integer function RPN_CDIV( stacks, MaxStacks )
  integer                              , intent(IN)    :: MaxStacks
  type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

  integer :: ic
  integer :: ix
  integer :: jx
  integer :: kx
  integer :: it
  integer :: i
  integer :: j
  integer :: k
  integer :: t

  real :: rpart
  real :: cpart

  complex :: ctmp
  complex :: ctmp2
  complex :: ctmp3

  ic = stacks(1)%current

  RPN_CDIV = RPN_STACK_ERROR
  if( ic < 5 ) return
  RPN_CDIV = RPN_OPE_ERROR

  ix = stacks(ic)%ix
  jx = stacks(ic)%jx
  kx = stacks(ic)%kx
  it = stacks(ic)%it

  do i = ic-3, ic-1
     if(    stacks(i)%ix /= ix .or.                                         &
          & stacks(i)%jx /= jx .or.                                         &
          & stacks(i)%kx /= kx .or.                                         &
          & stacks(i)%it /= it ) return
  end do

  do t = 1, it
     do k = 1, kx
        do j = 1, jx
           do i = 1, ix
              if( stacks(ic-3)%val(i,j,k,t) /= stacks(ic-3)%undef ) then
                 rpart = stacks(ic-3)%val(i,j,k,t)
              else
                 stacks(ic-3)%val(i,j,k,t) = stacks(ic-3)%undef
                 stacks(ic-2)%val(i,j,k,t) = stacks(ic-2)%undef
                 cycle
              end if
              if( stacks(ic-2)%val(i,j,k,t) /= stacks(ic-2)%undef ) then
                 cpart = stacks(ic-2)%val(i,j,k,t)
              else
                 stacks(ic-3)%val(i,j,k,t) = stacks(ic-3)%undef
                 stacks(ic-2)%val(i,j,k,t) = stacks(ic-2)%undef
                 cycle
              end if
              ctmp = cmplx( rpart, cpart )

              if( stacks(ic-1)%val(i,j,k,t) /= stacks(ic-1)%undef ) then
                 rpart = stacks(ic-1)%val(i,j,k,t)
              else
                 stacks(ic-3)%val(i,j,k,t) = stacks(ic-3)%undef
                 stacks(ic-2)%val(i,j,k,t) = stacks(ic-2)%undef
                 cycle
              end if
              if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef ) then
                 cpart = stacks(ic)%val(i,j,k,t)
              else
                 stacks(ic-3)%val(i,j,k,t) = stacks(ic-3)%undef
                 stacks(ic-2)%val(i,j,k,t) = stacks(ic-2)%undef
                 cycle
              end if

              ctmp2 = cmplx( rpart, cpart )

              if( abs( ctmp2 ) > 0.0 ) then
                 ctmp3 = ctmp / ctmp2
              else
                 stacks(ic-3)%val(i,j,k,t) = stacks(ic-3)%undef
                 stacks(ic-2)%val(i,j,k,t) = stacks(ic-2)%undef
              end if

              stacks(ic-3)%val(i,j,k,t) = real( ctmp3 )
              stacks(ic-2)%val(i,j,k,t) = aimag( ctmp3 )
           end do
        end do
     end do
  end do

   call RPN_ClearStacks( stacks, MaxStacks )
   call RPN_ClearStacks( stacks, MaxStacks )

  RPN_CDIV = RPN_NOERROR

  return
end function RPN_CDIV
