  integer function RPN_COMPBIG( stacks, MaxStacks )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

    integer :: i, j, k, t, ic
    integer :: ix, jx, kx, it

    ic = stacks(1)%current
    ix = stacks(ic-1)%ix
    jx = stacks(ic-1)%jx
    kx = stacks(ic-1)%kx
    it = stacks(ic-1)%it

    RPN_COMPBIG = RPN_STACK_ERROR
    if( ic < 3 ) return
    if(    ix /= stacks(ic)%ix .or. &
         & jx /= stacks(ic)%jx .or. &
         & kx /= stacks(ic)%kx .or. &
         & it /= stacks(ic)%it      ) return
    RPN_COMPBIG = RPN_OPE_ERROR

    do t = 1, it
       do k = 1, kx
          do j = 1, jx
             do i = 1, ix
                if( stacks(ic-1)%val(i,j,k,t) /= stacks(ic-1)%undef ) then
                   if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and. &
                        & stacks(ic)%val(i,j,k,t) > stacks(ic-1)%val(i,j,k,t) ) then
                      stacks(ic-1)%val(i,j,k,t) = stacks(ic)%val(i,j,k,t)
                   end if
                else
                   if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef ) then
                      stacks(ic-1)%val(i,j,k,t) = stacks(ic)%val(i,j,k,t)
                   end if
                end if
             end do
          end do
       end do
    end do

    call ClearStacks( stacks, MaxStacks )
    RPN_COMPBIG = RPN_NOERROR
    return
  end function RPN_COMPBIG

