integer function RPN_CONJG( stacks, MaxStacks )
  integer                              , intent(IN)    :: MaxStacks
  type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

  integer :: ic
  integer :: ix
  integer :: jx
  integer :: kx
  integer :: it
  integer :: i
  integer :: j
  integer :: k
  integer :: t

  real :: rpart
  real :: cpart

  complex :: ctmp
  complex :: ctmp2

  ic = stacks(1)%current

  RPN_CONJG = RPN_STACK_ERROR
  if( ic < 3 ) return
  RPN_CONJG = RPN_OPE_ERROR

  ix = stacks(ic)%ix
  jx = stacks(ic)%jx
  kx = stacks(ic)%kx
  it = stacks(ic)%it

  if(    stacks(ic-1)%ix /= ix .or.                                         &
       & stacks(ic-1)%jx /= jx .or.                                         &
       & stacks(ic-1)%kx /= kx .or.                                         &
       & stacks(ic-1)%it /= it ) return

  do t = 1, it
     do k = 1, kx
        do j = 1, jx
           do i = 1, ix
              if( stacks(ic-1)%val(i,j,k,t) /= stacks(ic-1)%undef ) then
                 rpart = stacks(ic-1)%val(i,j,k,t)
              else
                 stacks(ic)%val(i,j,k,t) = stacks(ic)%undef
                 cycle
              end if
              if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef ) then
                 cpart = stacks(ic)%val(i,j,k,t)
              else
                 stacks(ic-1)%val(i,j,k,t) = stacks(ic-1)%undef
                 cycle
              end if

              ctmp = cmplx( rpart, cpart )
              ctmp2 = conjg( ctmp )

              stacks(ic-1)%val(i,j,k,t) = real( ctmp2 )
              stacks(ic)%val(i,j,k,t)   = aimag( ctmp2 )
           end do
        end do
     end do
  end do

  RPN_CONJG = RPN_NOERROR

  return
end function RPN_CONJG
