integer function RPN_CPOW( stacks, MaxStacks )
  integer                              , intent(IN)    :: MaxStacks
  type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

  integer :: ic
  integer :: ix
  integer :: jx
  integer :: kx
  integer :: it
  integer :: ixp
  integer :: jxp
  integer :: kxp
  integer :: itp
  integer :: i
  integer :: j
  integer :: k
  integer :: t

  real :: rpart
  real :: cpart

  complex :: cpow
  complex :: ctmp
  complex :: ctmp2

  ic = stacks(1)%current

  RPN_CPOW = RPN_STACK_ERROR
  if( ic < 5 ) return
  RPN_CPOW = RPN_OPE_ERROR

  ix = stacks(ic-2)%ix
  jx = stacks(ic-2)%jx
  kx = stacks(ic-2)%kx
  it = stacks(ic-2)%it

  if(    stacks(ic-3)%ix /= ix .or.                                         &
       & stacks(ic-3)%jx /= jx .or.                                         &
       & stacks(ic-3)%kx /= kx .or.                                         &
       & stacks(ic-3)%it /= it ) return

  ixp = stacks(ic-1)%ix
  jxp = stacks(ic-1)%jx
  kxp = stacks(ic-1)%kx
  itp = stacks(ic-1)%it

  if(    stacks(ic)%ix /= ixp .or.                                         &
       & stacks(ic)%jx /= jxp .or.                                         &
       & stacks(ic)%kx /= kxp .or.                                         &
       & stacks(ic)%it /= itp ) return

  if( stacks(ic)%dim == 0 ) then
     if( stacks(ic)%val(1,1,1,1) /= stacks(ic)%undef .and.                               &
          & stacks(ic-1)%val(1,1,1,1) /= stacks(ic-1)%undef ) then

        if( stacks(ic-3)%val(1,1,1,1) /= stacks(ic-3)%undef ) then
           rpart = stacks(ic-3)%val(1,1,1,1)
        else
           stacks(ic-2)%val(1,1,1,1) = stacks(ic-2)%undef
           return
        end if
        if( stacks(ic-2)%val(1,1,1,1) /= stacks(ic-2)%undef ) then
           cpart = stacks(ic-2)%val(1,1,1,1)
        else
           stacks(ic-3)%val(1,1,1,1) = stacks(ic-3)%undef
           return
        end if

        ctmp = cmplx( rpart, cpart )
        cpow = cmplx( stacks(ic-1)%val(1,1,1,1), stacks(ic)%val(1,1,1,1) )
        ctmp2 = ctmp**cpow

        stacks(ic-3)%val(1,1,1,1) = real( ctmp2 )
        stacks(ic-2)%val(1,1,1,1) = aimag( ctmp2 )

     else
        stacks(ic-2)%val = stacks(ic-2)%undef
        stacks(ic-3)%val = stacks(ic-3)%undef
     end if

  else
     do t = 1, it
        do k = 1, kx
           do j = 1, jx
              do i = 1, ix
                 if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and.                    &
                      & stacks(ic-1)%val(i,j,k,t) /= stacks(ic)%undef ) then
                    cpow = cmplx( stacks(ic-1)%val(i,j,k,t), stacks(ic)%val(i,j,k,t) )
                 else
                    stacks(ic-2)%val(i,j,k,t) = stacks(ic-2)%undef
                    stacks(ic-3)%val(i,j,k,t) = stacks(ic-3)%undef
                 end if

                 if( stacks(ic-3)%val(i,j,k,t) /= stacks(ic-3)%undef ) then
                    rpart = stacks(ic-3)%val(i,j,k,t)
                 else
                    stacks(ic-2)%val(i,j,k,t) = stacks(ic-2)%undef
                    cycle
                 end if
                 if( stacks(ic-2)%val(i,j,k,t) /= stacks(ic-2)%undef ) then
                    cpart = stacks(ic-2)%val(i,j,k,t)
                 else
                    stacks(ic-3)%val(i,j,k,t) = stacks(ic-3)%undef
                    cycle
                 end if

                 ctmp = cmplx( rpart, cpart )
                 ctmp2 = ctmp**cpow

                 stacks(ic-3)%val(i,j,k,t) = real( ctmp2 )
                 stacks(ic-2)%val(i,j,k,t) = aimag( ctmp2 )
              end do
           end do
        end do
     end do

  end if

  call ClearStacks( stacks, MaxStacks )
  call ClearStacks( stacks, MaxStacks )

  RPN_CPOW = RPN_NOERROR

  return
end function RPN_CPOW
