  integer function RPN_DDLAT( stacks, MaxStacks )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

    integer :: ic
    integer :: i, j, k, t

    integer :: jx, m
    real    :: dy2
    real    :: rer
    real    :: d2r

    real, dimension(:), allocatable :: tmp

    d2r = 0.01745329252   ! 3.14159265 / 180.

    ic      = stacks(1)%current
    jx      = stacks(ic)%jx
    RPN_DDLAT = RPN_STACK_ERROR
    if( ic < 2 ) return

    RPN_DDLAT = RPN_INVALID_DATA
    if( stacks(ic)%model == RPN_NO_MODEL_DATA ) return
    if( stacks(ic)%jx < 3 ) return

    m   = stacks(ic)%model
    dy2 = MODEL(m)%dy * 2. * d2r
    if( abs( MODEL(m)%er ) < 1.e-3 ) then
       rer = 1. / 6.37e+6
    else
       rer = 1. / MODEL(m)%er
    end if

    allocate( tmp(stacks(ic)%jx) )

    RPN_DDLAT = RPN_OPE_ERROR
    do t = 1, stacks(ic)%it
       do k = 1, stacks(ic)%kx
          do i = 1, stacks(ic)%ix

             tmp = stacks(ic)%undef
             do j = 2, jx-1
                if(    stacks(ic)%val(i,j-1,k,t) /= stacks(ic)%undef .and. &
                     & stacks(ic)%val(i,j  ,k,t) /= stacks(ic)%undef .and. &
                     & stacks(ic)%val(i,j+1,k,t) /= stacks(ic)%undef ) then
                   tmp(j) = &
                        & (   stacks(ic)%val(i,j+1,k,t)   &
                        &   - stacks(ic)%val(i,j-1,k,t) ) &
                        & / dy2 * rer
                end if
             end do
             if(    tmp(2) /= stacks(ic)%undef .and. &
                  & tmp(3) /= stacks(ic)%undef ) then
                tmp(1) = 2. * tmp(2) - tmp(3)
             end if
             if(    tmp(jx-1) /= stacks(ic)%undef .and. &
                  & tmp(jx-2) /= stacks(ic)%undef ) then
                tmp(jx) = 2. * tmp(jx-1) - tmp(jx-2)
             end if
             do j = 1, jx
                stacks(ic)%val(i,j,k,t) = tmp(j)
             end do

          end do
       end do
    end do

    deallocate( tmp )

    RPN_DDLAT = RPN_NOERROR
    return
  end function RPN_DDLAT
