  integer function RPN_DDX( stacks, MaxStacks )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

    integer :: ic
    integer :: i, j, k, t

    integer :: ix, m
    real    :: dx2

    real, dimension(:), allocatable :: tmp

    ic      = stacks(1)%current
    ix      = stacks(ic)%ix
    RPN_DDX = RPN_STACK_ERROR
    if( ic < 2 ) return

    RPN_DDX = RPN_INVALID_DATA
    if( stacks(ic)%model == RPN_NO_MODEL_DATA ) return
    if( stacks(ic)%ix < 3 ) return

    m   = stacks(ic)%model
    dx2 = MODEL(m)%dx * 2.

    allocate( tmp(stacks(ic)%ix) )

    RPN_DDX = RPN_OPE_ERROR
    do t = 1, stacks(ic)%it
       do k = 1, stacks(ic)%kx
          do j = 1, stacks(ic)%jx

             tmp = stacks(ic)%undef
             do i = 2, ix-1
                if(    stacks(ic)%val(i-1,j,k,t) /= stacks(ic)%undef .and. &
                     & stacks(ic)%val(i  ,j,k,t) /= stacks(ic)%undef .and. &
                     & stacks(ic)%val(i+1,j,k,t) /= stacks(ic)%undef ) then
                   tmp(i) = &
                        & (   stacks(ic)%val(i+1,j,k,t)   &
                        &   - stacks(ic)%val(i-1,j,k,t) ) &
                        & / dx2
                end if
             end do
             if(    tmp(2) /= stacks(ic)%undef .and. &
                  & tmp(3) /= stacks(ic)%undef ) then
                tmp(1) = 2. * tmp(2) - tmp(3)
             end if
             if(    tmp(ix-1) /= stacks(ic)%undef .and. &
                  & tmp(ix-2) /= stacks(ic)%undef ) then
                tmp(ix) = 2. * tmp(ix-1) - tmp(ix-2)
             end if
             do i = 1, ix
                stacks(ic)%val(i,j,k,t) = tmp(i)
             end do

          end do
       end do
    end do

    deallocate( tmp )

    RPN_DDX = RPN_NOERROR
    return
  end function RPN_DDX
