  integer function RPN_DDX_S( stacks, MaxStacks )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

    integer :: ic
    integer :: i, j, k, t

    integer :: ix, jx, kx, it, m
    real    :: dx2

    real, dimension(:,:,:,:), allocatable :: tmp

    ic      = stacks(1)%current
    ix      = stacks(ic)%ix
    jx      = stacks(ic)%jx
    kx      = stacks(ic)%kx
    it      = stacks(ic)%it
    RPN_DDX_S = RPN_STACK_ERROR
    if( ic < 2 ) return
    if( .not. stacks(ic)%staggering ) return

    RPN_DDX_S = RPN_INVALID_DATA
    if( stacks(ic)%model == RPN_NO_MODEL_DATA ) return
    if( stacks(ic)%ix < 3 ) return

    m   = stacks(ic)%model
    dx2 = MODEL(m)%dx * 2.

    allocate( tmp(ix,jx,kx,it) )
    tmp = stacks(ic)%undef

    RPN_DDX_S = RPN_OPE_ERROR
    do t = 1, it
       do k = 1, kx
          do j = 1, jx-1
             do i = 1, ix-1
                if(    stacks(ic)%val(i  ,j  ,k,t) /= stacks(ic)%undef .and. &
                     & stacks(ic)%val(i+1,j  ,k,t) /= stacks(ic)%undef .and. &
                     & stacks(ic)%val(i  ,j+1,k,t) /= stacks(ic)%undef .and. &
                     & stacks(ic)%val(i+1,j+1,k,t) /= stacks(ic)%undef ) then
                   tmp(i,j,k,t) =  (   stacks(ic)%val(i+1,j  ,k,t) &
                        &            + stacks(ic)%val(i+1,j+1,k,t) &
                        &            - stacks(ic)%val(i  ,j  ,k,t) &
                        &            - stacks(ic)%val(i  ,j+1,k,t) ) / dx2
                end if
             end do
          end do
       end do
    end do

    stacks(ic)%val        = tmp
    stacks(ic)%staggering = .false.

    deallocate( tmp )

    RPN_DDX_S = RPN_NOERROR
    return
  end function RPN_DDX_S
