  integer function RPN_DDY( stacks, MaxStacks )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

    integer :: ic
    integer :: i, j, k, t

    integer :: jx, m
    real    :: dy2

    real, dimension(:), allocatable :: tmp

    ic      = stacks(1)%current
    jx      = stacks(ic)%jx
    RPN_DDY = RPN_STACK_ERROR
    if( ic < 2 ) return

    RPN_DDY = RPN_INVALID_DATA
    if( stacks(ic)%model == RPN_NO_MODEL_DATA ) return
    if( stacks(ic)%jx < 3 ) return

    m   = stacks(ic)%model
    dy2 = MODEL(m)%dy * 2.

    allocate( tmp(stacks(ic)%jx) )

    RPN_DDY = RPN_OPE_ERROR
    do t = 1, stacks(ic)%it
       do k = 1, stacks(ic)%kx
          do i = 1, stacks(ic)%ix

             tmp = stacks(ic)%undef
             do j = 2, jx-1
                if(    stacks(ic)%val(i,j-1,k,t) /= stacks(ic)%undef .and. &
                     & stacks(ic)%val(i,j  ,k,t) /= stacks(ic)%undef .and. &
                     & stacks(ic)%val(i,j+1,k,t) /= stacks(ic)%undef ) then
                   tmp(j) = &
                        & (   stacks(ic)%val(i,j+1,k,t)   &
                        &   - stacks(ic)%val(i,j-1,k,t) ) &
                        & / dy2
                end if
             end do
             if(    tmp(2) /= stacks(ic)%undef .and. &
                  & tmp(3) /= stacks(ic)%undef ) then
                tmp(1) = 2. * tmp(2) - tmp(3)
             end if
             if(    tmp(jx-1) /= stacks(ic)%undef .and. &
                  & tmp(jx-2) /= stacks(ic)%undef ) then
                tmp(jx) = 2. * tmp(jx-1) - tmp(jx-2)
             end if
             do j = 1, jx
                stacks(ic)%val(i,j,k,t) = tmp(j)
             end do

          end do
       end do
    end do

    deallocate( tmp )

    RPN_DDY = RPN_NOERROR
    return
  end function RPN_DDY
