  integer function RPN_DDZ( stacks, MaxStacks )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

    integer :: ic
    integer :: i, j, k, t
    integer :: ix, jx, kx, it, m
    real    :: dz

    real, dimension(:,:,:,:), allocatable :: tmp

    ic      = stacks(1)%current
    ix      = stacks(ic)%ix
    jx      = stacks(ic)%jx
    kx      = stacks(ic)%kx
    it      = stacks(ic)%it
    RPN_DDZ = RPN_STACK_ERROR
    if( ic < 2 ) return

    RPN_DDZ = RPN_INVALID_DATA
    if( stacks(ic)%model == RPN_NO_MODEL_DATA ) return
    if( kx < 3 ) return
    if( .not. associated( stacks(ic)%olev ) ) return

    m = stacks(ic)%model

    allocate( tmp(ix,jx,kx,it) )

    RPN_DDZ = RPN_OPE_ERROR
    do t = 1, it
       ! k = 1
       dz = stacks(ic)%olev(2) - stacks(ic)%olev(1)
       if( abs( dz ) > 1.e-7 ) then
          do j = 1, jx
             do i = 1, ix
                if(    stacks(ic)%val(i,j,1,t) /= stacks(ic)%undef .and. &
                     & stacks(ic)%val(i,j,2,t) /= stacks(ic)%undef ) then
                   tmp(i,j,1,t) = ( stacks(ic)%val(i,j,2,t)       &
                        &         - stacks(ic)%val(i,j,1,t) ) / dz
                else
                   tmp(i,j,1,t) = stacks(ic)%undef
                end if
             end do
          end do
       else
          do j = 1, jx
             do i = 1, ix
                tmp(i,j,1,t) = stacks(ic)%undef
             end do
          end do
       end if

       ! k = 2 to kx-1
       do k = 2, kx-1
          dz = stacks(ic)%olev(k+1) - stacks(ic)%olev(k-1)
          if( abs( dz ) > 1.e-7 ) then
             do j = 1, jx
                do i = 1, ix
                   if(    stacks(ic)%val(i,j,k+1,t) /= stacks(ic)%undef .and. &
                        & stacks(ic)%val(i,j,k-1,t) /= stacks(ic)%undef ) then
                      tmp(i,j,k,t) = ( stacks(ic)%val(i,j,k+1,t)       &
                           &         - stacks(ic)%val(i,j,k-1,t) ) / dz
                   else
                      tmp(i,j,k,t) = stacks(ic)%undef
                   end if
                end do
             end do
          else
             do j = 1, jx
                do i = 1, ix
                   tmp(i,j,k,t) = stacks(ic)%undef
                end do
             end do
          end if
       end do

       ! k = kx
       dz = stacks(ic)%olev(kx) - stacks(ic)%olev(kx-1)
       if( abs( dz ) > 1.e-7 ) then
          do j = 1, jx
             do i = 1, ix
                if(    stacks(ic)%val(i,j,kx  ,t) /= stacks(ic)%undef .and. &
                     & stacks(ic)%val(i,j,kx-1,t) /= stacks(ic)%undef ) then
                   tmp(i,j,kx,t) = ( stacks(ic)%val(i,j,kx  ,t)       &
                        &          - stacks(ic)%val(i,j,kx-1,t) ) / dz
                else
                   tmp(i,j,kx,t) = stacks(ic)%undef
                end if
             end do
          end do
       else
          do j = 1,jx
             do i = 1, ix
                tmp(i,j,kx,t) = stacks(ic)%undef
             end do
          end do
       end if
    end do

    do t = 1, it
       do k = 1, kx
          do j = 1, jx
             do i = 1, ix
                stacks(ic)%val(i,j,k,t) = tmp(i,j,k,t)
             end do
          end do
       end do
    end do

    deallocate( tmp )

    RPN_DDZ = RPN_NOERROR
    return
  end function RPN_DDZ
