  integer function RPN_DDZ_2( stacks, MaxStacks )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

    integer :: ic
    integer :: i, j, k, t, km, kp
    integer :: ix, jx, kx, it, m
    real    :: dz

    real, dimension(:,:,:,:), allocatable :: tmp

    ic      = stacks(1)%current
    ix      = stacks(ic)%ix
    jx      = stacks(ic)%jx
    kx      = stacks(ic)%kx
    it      = stacks(ic)%it
    RPN_DDZ_2 = RPN_STACK_ERROR
    if( ic < 3 ) return

    RPN_DDZ_2 = RPN_INVALID_DATA

    ! data check
    if( stacks(ic)%model == RPN_NO_MODEL_DATA ) return
    if( kx < 3 ) return
    if( .not. associated( stacks(ic)%olev ) ) return
    if(    stacks(ic-1)%ix /= ix .or. &
         & stacks(ic-1)%jx /= jx .or. &
         & stacks(ic-1)%kx /= kx .or. &
         & stacks(ic-1)%it /= it ) return

    m = stacks(ic)%model

    allocate( tmp(ix,jx,kx,it) )

    RPN_DDZ_2 = RPN_OPE_ERROR
    do t = 1, it
       do k = 1, kx
          km = max(  1, k-1 )
          kp = min( kx, k+1 )

          do j = 1, jx
             do i = 1, ix
                if(    stacks(ic  )%val(i,j,km,t) /= stacks(ic  )%undef .and. &
                     & stacks(ic  )%val(i,j,kp,t) /= stacks(ic  )%undef .and. &
                     & stacks(ic-1)%val(i,j,km,t) /= stacks(ic-1)%undef .and. &
                     & stacks(ic-1)%val(i,j,kp,t) /= stacks(ic-1)%undef ) then
                   dz = stacks(ic)%val(i,j,kp,t) - stacks(ic)%val(i,j,km,t)
                   if( abs( dz ) > 1.e-7 ) then
                      tmp(i,j,k,t) =                            &
                           & ( stacks(ic-1)%val(i,j,kp,t)       &
                           & - stacks(ic-1)%val(i,j,km,t) ) / dz
                   else
                      tmp(i,j,k,t) = stacks(ic-1)%undef
                   end if
                else
                   tmp(i,j,k,t) = stacks(ic-1)%undef
                end if
             end do
          end do
       end do
    end do

    do t = 1, it
       do k = 1, kx
          do j = 1, jx
             do i = 1, ix
                stacks(ic-1)%val(i,j,k,t) = tmp(i,j,k,t)
             end do
          end do
       end do
    end do

    deallocate( tmp )
    call ClearStacks( stacks, MaxStacks )

    RPN_DDZ_2 = RPN_NOERROR
    return
  end function RPN_DDZ_2
