integer function RPN_FFT( stacks, MaxStacks )
  use singleton

  integer                              , intent(IN)    :: MaxStacks
  type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

  integer :: ic
  integer :: ix
  integer :: jx
  integer :: kx
  integer :: it
  integer :: i
  integer :: j
  integer :: k
  integer :: t

  real            , dimension(:,:,:,:), allocatable :: rtmp
  complex(fftkind), dimension(:,:)    , allocatable :: ctmp
  complex(fftkind), dimension(:,:)    , allocatable :: ctmp2

  ic = stacks(1)%current

  RPN_FFT = RPN_STACK_ERROR
  if( ic < 2 ) return
  RPN_FFT = RPN_OPE_ERROR

  ix = stacks(ic)%ix
  jx = stacks(ic)%jx
  kx = stacks(ic)%kx
  it = stacks(ic)%it

  if( ix * jx == 1 ) return

  allocate( rtmp(ix,jx,kx,it) )
  allocate( ctmp(ix,jx)  )
  allocate( ctmp2(ix,jx) )

  do t = 1, it
     do k = 1, kx
        do j = 1, jx
           do i = 1, ix
              if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef ) then
                 ctmp(i,j) = cmplx( stacks(ic)%val(i,j,k,t) )
              else
                 ctmp(i,j) = cmplx( 0.0 )
              end if
           end do
        end do

        ctmp2 = fft( ctmp )

        do j = 1,jx
           do i = 1, ix
              stacks(ic)%val(i,j,k,t) = real( ctmp2(i,j) )
              rtmp(i,j,k,t) = imag( ctmp2(i,j) )
           end do
        end do

     end do
  end do

  RPN_FFT = RPN_PushStack( stacks,                                           &
       &                   MaxStacks,                                        &
       &                   rtmp,                                             &
       &                   stacks(ic)%ix,                                    &
       &                   stacks(ic)%jx,                                    &
       &                   stacks(ic)%kx,                                    &
       &                   stacks(ic)%it,                                    &
       &                   stacks(ic)%undef,                                 &
       &                   stacks(ic)%model,                                 &
       &                   stacks(ic)%omodel,                                &
       &                   stacks(ic)%olev,                                  &
       &                   stacks(ic)%cdate,                                 &
       &                   stacks(ic)%staggering )


  RPN_FFT = RPN_NOERROR

  deallocate( rtmp )
  deallocate( ctmp )
  deallocate( ctmp2 )

  return
end function RPN_FFT
