integer function RPN_FFTC( stacks, MaxStacks )
  use singleton

  integer                              , intent(IN)    :: MaxStacks
  type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

  integer :: ic
  integer :: ix
  integer :: jx
  integer :: kx
  integer :: it
  integer :: i
  integer :: j
  integer :: k
  integer :: t

  real :: rpart
  real :: cpart

  real            , dimension(:,:,:,:), allocatable :: rtmp
  complex(fftkind), dimension(:,:)    , allocatable :: ctmp
  complex(fftkind), dimension(:,:)    , allocatable :: ctmp2

  ic = stacks(1)%current

  RPN_FFTC = RPN_STACK_ERROR
  if( ic < 3 ) return
  RPN_FFTC = RPN_OPE_ERROR

  ix = stacks(ic)%ix
  jx = stacks(ic)%jx
  kx = stacks(ic)%kx
  it = stacks(ic)%it

  if( ix * jx == 1 ) return
  if(    stacks(ic-1)%ix /= ix .or.                                         &
       & stacks(ic-1)%jx /= jx .or.                                         &
       & stacks(ic-1)%kx /= kx .or.                                         &
       & stacks(ic-1)%it /= it ) return

  allocate( rtmp(ix,jx,kx,it) )
  allocate( ctmp(ix,jx)  )
  allocate( ctmp2(ix,jx) )

  do t = 1, it
     do k = 1, kx
        do j = 1, jx
           do i = 1, ix
              if( stacks(ic-1)%val(i,j,k,t) /= stacks(ic-1)%undef ) then
                 rpart = stacks(ic-1)%val(i,j,k,t)
              else
                 rpart = 0.0
              end if
              if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef ) then
                 cpart = stacks(ic)%val(i,j,k,t)
              else
                 cpart = 0.0
              end if

              ctmp(i,j) = cmplx( rpart, cpart )
           end do
        end do

        ctmp2 = fft( ctmp )

        do j = 1,jx
           do i = 1, ix
              stacks(ic-1)%val(i,j,k,t) = real( ctmp2(i,j) )
              stacks(ic)%val(i,j,k,t)   = imag( ctmp2(i,j) )
           end do
        end do

     end do
  end do

  RPN_FFTC = RPN_NOERROR

  deallocate( rtmp )
  deallocate( ctmp )
  deallocate( ctmp2 )

  return
end function RPN_FFTC
