  integer function RPN_FILLNAN( stacks, MaxStacks )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

    integer :: i, j, k, t, ic
    integer :: ixm, jxm, kxm, itm
    integer :: ixp, jxp, kxp, itp

    ic  = stacks(1)%current
    ixm = stacks(ic-1)%ix
    jxm = stacks(ic-1)%jx
    kxm = stacks(ic-1)%kx
    itm = stacks(ic-1)%it
    ixp = stacks(ic  )%ix
    jxp = stacks(ic  )%jx
    kxp = stacks(ic  )%kx
    itp = stacks(ic  )%it

    RPN_FILLNAN = RPN_STACK_ERROR
    if( ic < 3 ) return
    RPN_FILLNAN = RPN_OPE_ERROR

    ! 0D both ic and ic-1 stack
    if( stacks(ic)%dim == 0 .and. stacks(ic-1)%dim == 0 ) then
       if(    stacks(ic-1)%val(1,1,1,1) == stacks(ic-1)%undef .and.          &
            & stacks(ic)%val(1,1,1,1) /= stacks(ic)%undef ) then
          stacks(ic-1)%val(1,1,1,1) = stacks(ic)%val(1,1,1,1)
       end if

    ! 0D(ic) and nD (ic-1)
    else if( stacks(ic)%dim == 0 ) then
       do t = 1, itm
          do k = 1, kxm
             do j = 1, jxm
                do i = 1, ixm
                   if( stacks(ic-1)%val(i,j,k,t) == stacks(ic-1)%undef .and. &
                        & stacks(ic)%val(1,1,1,1) /= stacks(ic)%undef ) then
                      stacks(ic-1)%val(i,j,k,t) = stacks(ic)%val(1,1,1,1)
                   end if
                end do
             end do
          end do
       end do

    ! nD both ic and ic-1 stack
    else if( ixm == ixp .and. jxm == jxp .and. &
         &   kxm == kxp .and. itm == itp ) then
       do t = 1, itp
          do k = 1, kxp
             do j = 1, jxp
                do i = 1, ixp
                   if( stacks(ic-1)%val(i,j,k,t) == stacks(ic-1)%undef .and. &
                        & stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef ) then
                      stacks(ic-1)%val(i,j,k,t) = stacks(ic)%val(i,j,k,t)
                   end if
                end do
             end do
          end do
       end do

    else
       return
    end if

    call ClearStacks( stacks, MaxStacks )
    RPN_FILLNAN = RPN_NOERROR
    return
  end function RPN_FILLNAN

