  integer function RPN_HSTAT( stacks, MaxStacks )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

    integer :: ic
    integer :: ix
    integer :: jx
    integer :: kx
    integer :: it
    integer :: i
    integer :: j
    integer :: k
    integer :: t
    integer :: nc
    integer :: is

    real :: undef
    real :: min
    real :: max
    real :: ave
    real :: ave2
    real :: rdiff
    real :: adiff
    real :: sd
    real :: diff
    real :: diff2
    real, dimension(:,:,:,:), allocatable :: rtmp

    ic        = stacks(1)%current
    RPN_HSTAT = RPN_STACK_ERROR
    
    is = 10

    if( ic == 1 ) return

    ix = stacks(ic)%ix
    jx = stacks(ic)%jx
    kx = stacks(ic)%kx
    it = stacks(ic)%it
    undef = stacks(ic)%undef

    allocate( rtmp(1,is,kx,it) )

    do t = 1, it
       do k = 1, kx

          do j = 1, is
             rtmp(1,is,k,t) = 0.
          end do

          nc    = 0
          min   = 1.e+35
          max   = -1.e+35
          ave   = 0.
          ave2  = 0.
          rdiff = 0.
          adiff = 0.
          sd    = 0.

          ! average
          do j = 1, jx
             do i = 1, ix
                if( stacks(ic)%val(i,j,k,t) == undef ) cycle
                nc = nc + 1
                ave  = ave  + stacks(ic)%val(i,j,k,t)
                ave2 = ave2 + stacks(ic)%val(i,j,k,t)*stacks(ic)%val(i,j,k,t)
                if( stacks(ic)%val(i,j,k,t) > max )                       &
                     &         max = stacks(ic)%val(i,j,k,t)
                if( stacks(ic)%val(i,j,k,t) < min )                       &
                     &         min = stacks(ic)%val(i,j,k,t)
             end do
          end do

          if( nc == 0 ) then
             rtmp(1,1,k,t)  = nc
             rtmp(1,2,k,t)  = ix
             rtmp(1,3,k,t)  = jx
             rtmp(1,4,k,t)  = undef   ! ave
             rtmp(1,5,k,t)  = undef   ! ave2
             rtmp(1,6,k,t)  = undef   ! min
             rtmp(1,7,k,t)  = undef   ! max
             rtmp(1,8,k,t)  = undef   ! rdiff
             rtmp(1,9,k,t)  = undef   ! adiff
             rtmp(1,10,k,t) = undef   ! sd
             cycle
          end if

          ave  = ave  / nc
          ave2 = ave2 / nc

          do j = 1, jx
             do i = 1, ix
                if( stacks(ic)%val(i,j,k,t) == undef ) cycle
                diff  = stacks(ic)%val(i,j,k,t) - ave
                diff2 = diff  * diff
                rdiff = rdiff + diff
                adiff = adiff + abs( diff )
                sd    = sd    + diff2
             end do
          end do

          rdiff = rdiff / nc
          adiff = adiff / nc
          sd    = sd / nc

          rtmp(1,1,k,t)  = nc
          rtmp(1,2,k,t)  = ix
          rtmp(1,3,k,t)  = jx
          rtmp(1,4,k,t)  = ave   ! ave
          rtmp(1,5,k,t)  = ave2  ! ave2
          rtmp(1,6,k,t)  = min   ! min
          rtmp(1,7,k,t)  = max   ! max
          rtmp(1,8,k,t)  = rdiff ! rdiff
          rtmp(1,9,k,t)  = adiff ! adiff
          rtmp(1,10,k,t) = sd    ! sd

       end do
    end do

    stacks(ic)%ix = 1
    stacks(ic)%jx = is
    stacks(ic)%kx = kx
    stacks(ic)%it = it

    if( associated( stacks(ic)%val ) ) deallocate( stacks(ic)%val )
    allocate( stacks(ic)%val(1,is,kx,it) )

    do t = 1, it
       do k = 1, kx
          do j = 1, is
             stacks(ic)%val(1,j,k,t) = rtmp(1,j,k,t)
          end do
       end do
    end do

    deallocate( rtmp )

    RPN_HSTAT = RPN_NOERROR

    return
  end function RPN_HSTAT

