  integer function RPN_INFO( stacks, MaxStacks )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

    integer :: io
    integer :: ic
    integer :: iv
    integer :: ix
    integer :: jx
    integer :: kx
    integer :: it
    integer :: i
    integer :: j
    integer :: k
    integer :: t
    integer :: s
    integer :: min_i
    integer :: min_j
    integer :: min_k
    integer :: min_t
    integer :: max_i
    integer :: max_j
    integer :: max_k
    integer :: max_t

    real :: undef
    real :: min
    real :: max

    io = 6
    
    ic      = stacks(1)%current
    RPN_INFO = RPN_STACK_ERROR

    if( ic == 1 ) then
       write(io,*) 'EMPTY STACK'

    else
       do iv = ic, 2, -1
          s  = iv - 1
          ix = stacks(iv)%ix
          jx = stacks(iv)%jx
          kx = stacks(iv)%kx
          it = stacks(iv)%it
          undef = stacks(iv)%undef

          min   = 1e+35
          max   = -1e+35
          min_i = -1
          min_j = -1
          min_k = -1
          min_t = -1
          max_i = -1
          max_j = -1
          max_k = -1
          max_t = -1
          do t = 1, it
             do k = 1, kx
                do j = 1, jx
                   do i = 1, ix
                      if( stacks(iv)%val(i,j,k,t) == undef ) cycle

                      if( stacks(iv)%val(i,j,k,t) < min ) then
                         min   = stacks(iv)%val(i,j,k,t)
                         min_i = i
                         min_j = j
                         min_k = k
                         min_t = t
                      end if

                      if( stacks(iv)%val(i,j,k,t) > max ) then
                         max   = stacks(iv)%val(i,j,k,t)
                         max_i = i
                         max_j = j
                         max_k = k
                         max_t = t
                      end if

                   end do
                end do
             end do
          end do

          write(io,'(i3,$)') s
          write(io,'(4i6,$)') ix, jx, kx, it
          write(io,'(e,$)') undef
          write(io,'(e,4i6,$)') min, min_i, min_j, min_k, min_t
          write(io,'(e,4i6)') max, max_i, max_j, max_k, max_t

       end do
    end if

    RPN_INFO = RPN_NOERROR

    return
  end function RPN_INFO

