  integer function RPN_IPOW( stacks, MaxStacks )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

    integer :: ic
    integer :: ipow
    integer :: i, j, k, t

    ic      = stacks(1)%current
    RPN_IPOW = RPN_STACK_ERROR
    if( ic < 3 ) return
    RPN_IPOW = RPN_OPE_ERROR

    if( stacks(ic)%dim == 0 ) then
       if( stacks(ic)%val(1,1,1,1) /= stacks(ic)%undef ) then
          ipow = int( stacks(ic)%val(1,1,1,1) + 1e-5 )

          do t = 1, stacks(ic-1)%it
             do k = 1, stacks(ic-1)%kx
                do j = 1, stacks(ic-1)%jx
                   do i = 1, stacks(ic-1)%ix
                      if( stacks(ic-1)%val(i,j,k,t)                          &
                           & /= stacks(ic-1)%undef ) then
                         stacks(ic-1)%val(i,j,k,t) =                         &
                              & stacks(ic-1)%val(i,j,k,t)**ipow
                      end if
                   end do
                end do
             end do
          end do

       else
          stacks(ic-1)%val = stacks(ic-1)%undef
       end if
    else
       if( stacks(ic)%ix /= stacks(ic-1)%ix .or.                             &
            & stacks(ic)%jx /= stacks(ic-1)%jx .or.                          &
            & stacks(ic)%kx /= stacks(ic-1)%kx .or.                          &
            & stacks(ic)%it /= stacks(ic-1)%it ) return

       do t = 1, stacks(ic-1)%it
          do k = 1, stacks(ic-1)%kx
             do j = 1, stacks(ic-1)%jx
                do i = 1, stacks(ic-1)%ix
                   if( stacks(ic-1)%val(i,j,k,t) /= stacks(ic-1)%undef .and.  &
                        & stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef ) then
                      ipow = int( stacks(ic)%val(i,j,k,t) + 1e-5 )
                      stacks(ic-1)%val(i,j,k,t) =                         &
                           & stacks(ic-1)%val(i,j,k,t)**ipow
                   else
                      stacks(ic-1)%val(i,j,k,t) = stacks(ic-1)%undef
                   end if
                end do
             end do
          end do
       end do
       
    end if

    call ClearStacks( stacks, MaxStacks )

    RPN_IPOW = RPN_NOERROR
    return
  end function RPN_IPOW
