  integer function RPN_ROTUV( stacks, MaxStacks, mode )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks
    real                                 , intent(IN)    :: mode

    integer :: i, j, k, t, ic
    integer :: ixm, jxm, kxm, itm
    integer :: ixp, jxp, kxp, itp
    integer :: m

    real :: lon, lat, dlon, u, v
    real :: pi  = 3.14159265
    real :: d2r = 3.14159265 / 180.

    ic  = stacks(1)%current

    RPN_ROTUV = RPN_STACK_ERROR
    if( ic < 3 ) return

    ixm = stacks(ic-1)%ix
    jxm = stacks(ic-1)%jx
    kxm = stacks(ic-1)%kx
    itm = stacks(ic-1)%it
    ixp = stacks(ic  )%ix
    jxp = stacks(ic  )%jx
    kxp = stacks(ic  )%kx
    itp = stacks(ic  )%it
    m   = stacks(ic)%model

    RPN_ROTUV = RPN_OPE_ERROR

    if( ixm /= ixp .or. jxm /= jxp .or. kxm /= kxp .or. itm /= itp ) return
    if( stacks(ic-1)%model /= m ) return

    if( MODEL(m)%cproj == 'LAMCON' .or. MODEL(m)%cproj == 'PSTEREO' ) then
       do j = 1, jxm
          do i = 1, ixm
             call xy2ll( real(i),              &
                  &      real(j),              &
                  &      lon,                  &
                  &      lat,                  &
                  &      MODEL(m)%cproj,       &
                  &      MODEL(m)%dx,          &
                  &      MODEL(m)%dy,          &
                  &      MODEL(m)%clon,        &
                  &      MODEL(m)%clat,        &
                  &      MODEL(m)%xc,          &
                  &      MODEL(m)%yc,          &
                  &      tlat1=MODEL(m)%tlat1, &
                  &      tlat2=MODEL(m)%tlat2, &
                  &      earth=MODEL(m)%er     )
             dlon = mode * MODEL(m)%cone * ( MODEL(m)%clon - lon ) * d2r

             do t = 1, itm
                do k = 1, kxm
                   if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and. &
                        & stacks(ic-1)%val(i,j,k,t) /= stacks(ic-1)%undef ) then
                      u = stacks(ic-1)%val(i,j,k,t)
                      v = stacks(ic  )%val(i,j,k,t)
                      stacks(ic-1)%val(i,j,k,t) = u * cos( dlon ) - v * sin( dlon )
                      stacks(ic  )%val(i,j,k,t) = u * sin( dlon ) + v * cos( dlon )
                   end if
                end do
             end do
          end do
       end do
    end if

    
    RPN_ROTUV = RPN_NOERROR
    return
  end function RPN_ROTUV

