  integer function RPN_ROTUV2( stacks, MaxStacks, mode )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks
    real                                 , intent(IN)    :: mode

    integer :: i, j, k, t, ic
    integer :: ixm, jxm, kxm, itm
    integer :: ixu, jxu, kxu, itu
    integer :: ixv, jxv, kxv, itv
    integer :: m

    real :: lon, lat, dlon, u, v
    real :: pi  = 3.14159265
    real :: d2r = 3.14159265 / 180.

    ic  = stacks(1)%current

    RPN_ROTUV2 = RPN_STACK_ERROR
    if( ic < 4 ) return

    ixm = stacks(ic  )%ix
    jxm = stacks(ic  )%jx
    kxm = stacks(ic  )%kx
    itm = stacks(ic  )%it
    ixv = stacks(ic-1)%ix
    jxv = stacks(ic-1)%jx
    kxv = stacks(ic-1)%kx
    itv = stacks(ic-1)%it
    ixu = stacks(ic-2)%ix
    jxu = stacks(ic-2)%jx
    kxu = stacks(ic-2)%kx
    itu = stacks(ic-2)%it

    m   = stacks(ic)%model

    RPN_ROTUV2 = RPN_OPE_ERROR

    if( ixm /= ixu .or. jxm /= jxu  ) return
    if( ixm /= ixv .or. jxm /= jxv .or. kxu /= kxv .or. itu /= itv ) return

    if( MODEL(m)%cproj == 'LAMCON' .or. MODEL(m)%cproj == 'PSTEREO' ) then
       do j = 1, jxm
          do i = 1, ixm
             lon = stacks(ic)%val(i,j,1,1)
             dlon = mode * MODEL(m)%cone * ( MODEL(m)%clon - lon ) * d2r

             do t = 1, itm
                do k = 1, kxm
                   if( stacks(ic-1)%val(i,j,k,t) /= stacks(ic-1)%undef .and. &
                        & stacks(ic-2)%val(i,j,k,t) /= stacks(ic-2)%undef ) then
                      u = stacks(ic-2)%val(i,j,k,t)
                      v = stacks(ic-1)%val(i,j,k,t)
                      stacks(ic-2)%val(i,j,k,t) = u * cos( dlon ) - v * sin( dlon )
                      stacks(ic-1)%val(i,j,k,t) = u * sin( dlon ) + v * cos( dlon )
                   end if
                end do
             end do
          end do
       end do
    end if

    call ClearStacks( stacks, MaxStacks )
    
    RPN_ROTUV2 = RPN_NOERROR
    return
  end function RPN_ROTUV2

