  ! USAGE: [U] [V] [ANGLE] ROTVEC
  integer function RPN_ROTVEC( stacks, MaxStacks )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

    integer :: i, j, k, t, ic
    integer :: iu, iv
    integer :: ix , jx , kx , it
    integer :: ixm, jxm, kxm, itm
    integer :: ixp, jxp, kxp, itp
    integer :: m

    real :: angle

    real :: lon, lat, dlon, u, v
    real :: pi  = 3.14159265
    real :: d2r = 3.14159265 / 180.

    ic  = stacks(1)%current

    RPN_ROTVEC = RPN_STACK_ERROR
    if( ic < 4 ) return

    iu  = ic - 2
    iv  = ic - 1
    ix  = stacks(ic)%ix
    jx  = stacks(ic)%jx
    kx  = stacks(ic)%kx
    it  = stacks(ic)%it
    ixm = stacks(iu)%ix
    jxm = stacks(iu)%jx
    kxm = stacks(iu)%kx
    itm = stacks(iu)%it
    ixp = stacks(iv)%ix
    jxp = stacks(iv)%jx
    kxp = stacks(iv)%kx
    itp = stacks(iv)%it
    m   = stacks(iv)%model

    RPN_ROTVEC = RPN_OPE_ERROR

    if( ixm /= ixp .or. jxm /= jxp .or. kxm /= kxp .or. itm /= itp ) return
    if( stacks(ic-2)%model /= m ) return

    if( ix*jx*kx*it == 1 ) then
       if( stacks(ic)%val(1,1,1,1) == stacks(ic)%undef ) return
       angle = stacks(ic)%val(1,1,1,1)

       do t = 1, itm
          do k = 1, kxm
             do j = 1, jxm
                do i = 1, ixm
                   if( stacks(iu)%val(i,j,k,t) /= stacks(iu)%undef .and. &
                        & stacks(iv)%val(i,j,k,t) /= stacks(iv)%undef ) then
                      u = stacks(iu)%val(i,j,k,t)
                      v = stacks(iv)%val(i,j,k,t)

                      stacks(iu)%val(i,j,k,t) =   u * cos(angle) + v * sin(angle)
                      stacks(iv)%val(i,j,k,t) = - u * sin(angle) + v * cos(angle)

                   else
                      stacks(iu)%val(i,j,k,t) = stacks(iu)%undef
                      stacks(iv)%val(i,j,k,t) = stacks(iv)%undef
                   end if
                end do
             end do
          end do
       end do

    else
       do t = 1, itm
          do k = 1, kxm
             do j = 1, jxm
                do i = 1, ixm
                   if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef ) then
                      angle = stacks(ic)%val(i,j,k,t)
                   else
                      stacks(iu)%val(i,j,k,t) = stacks(iu)%undef
                      stacks(iv)%val(i,j,k,t) = stacks(iv)%undef
                      cycle
                   end if

                   if( stacks(iu)%val(i,j,k,t) /= stacks(iu)%undef .and. &
                        & stacks(iv)%val(i,j,k,t) /= stacks(iv)%undef ) then
                      u = stacks(iu)%val(i,j,k,t)
                      v = stacks(iv)%val(i,j,k,t)

                      stacks(iu)%val(i,j,k,t) =   u * cos(angle) + v * sin(angle)
                      stacks(iv)%val(i,j,k,t) = - u * sin(angle) + v * cos(angle)

                   else
                      stacks(iu)%val(i,j,k,t) = stacks(iu)%undef
                      stacks(iv)%val(i,j,k,t) = stacks(iv)%undef
                   end if
                end do
             end do
          end do
       end do

    end if

    call ClearStacks( stacks, MaxStacks )
    RPN_ROTVEC = RPN_NOERROR
    return
  end function RPN_ROTVEC

