  integer function RPN_SHIFT( stacks, MaxStacks )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

    integer :: ic, i, j, k, t, s, sm
    integer :: ix, jx, kx, it

    ic      = stacks(1)%current
    RPN_SHIFT = RPN_STACK_ERROR
    if( ic < 2 ) return
    RPN_SHIFT = RPN_OPE_ERROR

    if( ic > 2 ) then
       do s = 3, ic
          ix = stacks(s)%ix
          jx = stacks(s)%jx
          kx = stacks(s)%kx
          it = stacks(s)%it
          sm = s - 1

          stacks(sm)%dim        = stacks(s)%dim
          stacks(sm)%ix         = ix
          stacks(sm)%jx         = jx
          stacks(sm)%kx         = kx
          stacks(sm)%it         = it
          stacks(sm)%model      = stacks(s)%model
          stacks(sm)%omodel     = stacks(s)%omodel
          stacks(sm)%staggering = stacks(s)%staggering
          stacks(sm)%undef      = stacks(s)%undef

!          if( associated( stacks(sm)%olev ) ) nullify( stacks(sm)%olev )
          if( associated( stacks(sm)%olev ) ) deallocate( stacks(sm)%olev )
          if( associated( stacks(s)%olev ) ) then
             allocate( stacks(sm)%olev(kx) )
             stacks(sm)%olev(1:kx) = stacks(s)%olev(1:kx)
          end if

!          if( associated( stacks(sm)%val ) ) nullify( stacks(sm)%val )
          if( associated( stacks(sm)%val ) ) deallocate( stacks(sm)%val )
          allocate( stacks(sm)%val(ix,jx,kx,it) )

          do t = 1, it
             do k = 1, kx
                do j = 1, jx
                   do i = 1, ix
                      stacks(sm)%val(i,j,k,t) = stacks(s)%val(i,j,k,t)
                   end do
                end do
             end do
          end do
          
       end do
    end if

    call RPN_ClearStacks( stacks, MaxStacks )
    RPN_SHIFT = RPN_NOERROR

    return
  end function RPN_SHIFT

