  integer function RPN_SMT121( stacks, MaxStacks )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

    integer :: ic
    integer :: i, j, k, t

    integer :: ix, jx

    real, dimension(:,:), allocatable :: tmp

    ic      = stacks(1)%current
    ix      = stacks(ic)%ix
    jx      = stacks(ic)%jx
    RPN_SMT121 = RPN_STACK_ERROR
    if( ic < 2 ) return

    RPN_SMT121 = RPN_INVALID_DATA
    if( stacks(ic)%model == RPN_NO_MODEL_DATA ) return
    if( ix < 3 .or. jx < 3 ) return

    allocate( tmp(ix,jx) )

    RPN_SMT121 = RPN_OPE_ERROR
    do t = 1, stacks(ic)%it
       do k = 1, stacks(ic)%kx

          do j = 1, jx
             do i = 2, ix-1
                if(    stacks(ic)%val(i+1,j,k,t) /= stacks(ic)%undef .and. &
                     & stacks(ic)%val(i  ,j,k,t) /= stacks(ic)%undef .and. &
                     & stacks(ic)%val(i-1,j,k,t) /= stacks(ic)%undef ) then
                   tmp(i,j) = 0.25 *                                  &
                        &            ( 2. * stacks(ic)%val(i,j,k,t)   &
                        &                 + stacks(ic)%val(i+1,j,k,t) &
                        &                 + stacks(ic)%val(i-1,j,k,t) )
                else
                   tmp(i,j) = stacks(ic)%val(i,j,k,t)
                end if
             end do
             tmp(1 ,j) = stacks(ic)%val(1 ,j,k,t)
             tmp(ix,j) = stacks(ic)%val(ix,j,k,t)
          end do

          do i = 1, ix
             do j = 2, jx-1
                if(    tmp(i,j+1) /= stacks(ic)%undef .and. &
                     & tmp(i,j  ) /= stacks(ic)%undef .and. &
                     & tmp(i,j-1) /= stacks(ic)%undef ) then
                   stacks(ic)%val(i,j,k,t) =                                 &
                        &  0.25 * ( 2. * tmp(i,j) + tmp(i,j+1) + tmp(i,j-1) )
                else
                   stacks(ic)%val(i,j,k,t) = tmp(i,j)
                end if
             end do
             stacks(ic)%val(i,1 ,k,t) = tmp(i,1 )
             stacks(ic)%val(i,jx,k,t) = tmp(i,jx)
          end do

       end do
    end do

    deallocate( tmp )

    RPN_SMT121 = RPN_NOERROR
    return
  end function RPN_SMT121
