  integer function RPN_SUB( stacks, MaxStacks )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

    integer :: i, j, k, t, ic
    integer :: ixm, jxm, kxm, itm
    integer :: ixp, jxp, kxp, itp

    ic  = stacks(1)%current
    ixm = stacks(ic-1)%ix
    jxm = stacks(ic-1)%jx
    kxm = stacks(ic-1)%kx
    itm = stacks(ic-1)%it
    ixp = stacks(ic  )%ix
    jxp = stacks(ic  )%jx
    kxp = stacks(ic  )%kx
    itp = stacks(ic  )%it

    RPN_SUB = RPN_STACK_ERROR
    if( ic < 3 ) return
    RPN_SUB = RPN_OPE_ERROR

    ! 0D - 0D
    if( stacks(ic)%dim == 0 .and. stacks(ic-1)%dim == 0 ) then
       if( stacks(ic-1)%val(1,1,1,1) /= stacks(ic-1)%undef .and. &
            & stacks(ic)%val(1,1,1,1) /= stacks(ic)%undef ) then
          stacks(ic-1)%val(1,1,1,1) = &
               & stacks(ic-1)%val(1,1,1,1) - stacks(ic)%val(1,1,1,1)
       else
          stacks(ic-1)%val(1,1,1,1) = stacks(ic-1)%undef
       end if

    ! nD - 0D
    else if( stacks(ic)%dim == 0 ) then
       do t = 1, itm
          do k = 1, kxm
             do j = 1, jxm
                do i = 1, ixm
                   if( stacks(ic-1)%val(i,j,k,t) /= stacks(ic-1)%undef .and. &
                        & stacks(ic)%val(1,1,1,1) /= stacks(ic)%undef ) then
                      stacks(ic-1)%val(i,j,k,t) =        &
                           &   stacks(ic-1)%val(i,j,k,t) &
                           & - stacks(ic)%val(1,1,1,1)
                   else
                      stacks(ic-1)%val(i,j,k,t) = stacks(ic-1)%undef
                   end if
                end do
             end do
          end do
       end do

    ! 0D - nD
    else if( stacks(ic-1)%dim == 0 ) then
       do t = 1, itp
          do k = 1, kxp
             do j = 1, jxp
                do i = 1, ixp
                   if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef .and. &
                        & stacks(ic-1)%val(1,1,1,1) /= stacks(ic-1)%undef ) then
                      stacks(ic)%val(i,j,k,t) =           &
                           &    stacks(ic-1)%val(1,1,1,1) &
                           &  - stacks(ic)%val(i,j,k,t)
                   else
                      stacks(ic)%val(i,j,k,t) = stacks(ic)%undef
                   end if
                end do
             end do
          end do
       end do

       call ShurinStacks( stacks, MaxStacks )

    ! nD - nD
    else if( ixm == ixp .and. jxm == jxp .and. &
         &   kxm == kxp .and. itm == itp ) then
       do t = 1, itp
          do k = 1, kxp
             do j = 1, jxp
                do i = 1, ixp
                   if( stacks(ic-1)%val(i,j,k,t) /= stacks(ic-1)%undef .and. &
                        & stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef ) then
                      stacks(ic-1)%val(i,j,k,t) =        &
                           &   stacks(ic-1)%val(i,j,k,t) &
                           & - stacks(ic)%val(i,j,k,t)
                   else
                      stacks(ic-1)%val(i,j,k,t) = stacks(ic-1)%undef
                   end if
                end do
             end do
          end do
       end do

    else
       return
    end if

    call ClearStacks( stacks, MaxStacks )

    RPN_SUB = RPN_NOERROR
    return
  end function RPN_SUB
