  integer function RPN_SWAP( stacks, MaxStacks )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

    integer :: ic, i, j, k, t
    integer :: ix
    integer :: jx
    integer :: kx
    integer :: it
    integer :: is
    integer :: im

    ic      = stacks(1)%current
    RPN_SWAP = RPN_STACK_ERROR
    if( ic < 3 .or. ic == MaxStacks ) return
    RPN_SWAP = RPN_OPE_ERROR

    is = ic - 1
    im = ic + 1

    ! create temporary stack
    ix = stacks(is)%ix
    jx = stacks(is)%jx
    kx = stacks(is)%kx
    it = stacks(is)%it
    stacks(im)%dim        = stacks(is)%dim
    stacks(im)%ix         = stacks(is)%ix
    stacks(im)%jx         = stacks(is)%jx
    stacks(im)%kx         = stacks(is)%kx
    stacks(im)%it         = stacks(is)%it
    stacks(im)%model      = stacks(is)%model
    stacks(im)%omodel     = stacks(is)%omodel
    stacks(im)%staggering = stacks(is)%staggering
    stacks(im)%undef      = stacks(is)%undef
    if( associated( stacks(is)%olev ) ) then
       allocate( stacks(im)%olev(kx) )
       stacks(im)%olev(1:kx) = stacks(is)%olev(1:kx)
    end if

    allocate( stacks(im)%val(ix,jx,kx,it) )
    do t = 1, it
       do k = 1, kx
          do j = 1, jx
             do i = 1, ix
                stacks(im)%val(i,j,k,t) = stacks(is)%val(i,j,k,t)
             end do
          end do
       end do
    end do

    ! copy the latest stack
    ix = stacks(ic)%ix
    jx = stacks(ic)%jx
    kx = stacks(ic)%kx
    it = stacks(ic)%it
    stacks(is)%dim        = stacks(ic)%dim
    stacks(is)%ix         = stacks(ic)%ix
    stacks(is)%jx         = stacks(ic)%jx
    stacks(is)%kx         = stacks(ic)%kx
    stacks(is)%it         = stacks(ic)%it
    stacks(is)%model      = stacks(ic)%model
    stacks(is)%omodel     = stacks(ic)%omodel
    stacks(is)%staggering = stacks(ic)%staggering
    stacks(is)%undef      = stacks(ic)%undef
!    if( associated( stacks(is)%olev ) ) nullify( stacks(is)%olev )
!    if( associated( stacks(is)%val  ) ) nullify( stacks(is)%val )
    if( associated( stacks(is)%olev ) ) deallocate( stacks(is)%olev )
    if( associated( stacks(is)%val  ) ) deallocate( stacks(is)%val )

    if( associated( stacks(ic)%olev ) ) then
       allocate( stacks(is)%olev(kx) )
       stacks(is)%olev(1:kx) = stacks(ic)%olev(1:kx)
    end if

    allocate( stacks(is)%val(ix,jx,kx,it) )
    do t = 1, it
       do k = 1, kx
          do j = 1, jx
             do i = 1, ix
                stacks(is)%val(i,j,k,t) = stacks(ic)%val(i,j,k,t)
             end do
          end do
       end do
    end do

    ! restore the temporal stack
    ix = stacks(im)%ix
    jx = stacks(im)%jx
    kx = stacks(im)%kx
    it = stacks(im)%it
    stacks(ic)%dim        = stacks(im)%dim
    stacks(ic)%ix         = stacks(im)%ix
    stacks(ic)%jx         = stacks(im)%jx
    stacks(ic)%kx         = stacks(im)%kx
    stacks(ic)%it         = stacks(im)%it
    stacks(ic)%model      = stacks(im)%model
    stacks(ic)%omodel     = stacks(im)%omodel
    stacks(ic)%staggering = stacks(im)%staggering
    stacks(ic)%undef      = stacks(im)%undef
!    if( associated( stacks(ic)%olev ) ) nullify( stacks(ic)%olev )
!    if( associated( stacks(ic)%val  ) ) nullify( stacks(ic)%val  )
    if( associated( stacks(ic)%olev ) ) deallocate( stacks(ic)%olev )
    if( associated( stacks(ic)%val  ) ) deallocate( stacks(ic)%val  )

    if( associated( stacks(im)%olev ) ) then
       allocate( stacks(ic)%olev(kx) )
       stacks(ic)%olev(1:kx) = stacks(im)%olev(1:kx)
    end if

    allocate( stacks(ic)%val(ix,jx,kx,it) )
    do t = 1, it
       do k = 1, kx
          do j = 1, jx
             do i = 1, ix
                stacks(ic)%val(i,j,k,t) = stacks(im)%val(i,j,k,t)
             end do
          end do
       end do
    end do
    
    stacks(1)%current = stacks(1)%current + 1
    call RPN_ClearStacks( stacks, MaxStacks )
    RPN_SWAP = RPN_NOERROR

    return
  end function RPN_SWAP

