  integer function RPN_TAN( stacks, MaxStacks )
    integer                              , intent(IN)    :: MaxStacks
    type(RPN_STACK), dimension(MaxStacks), intent(INOUT) :: stacks

    integer :: ic, i, j, k, t

    real, parameter :: pi = 3.14159265358979
    real :: pir2

    pir2 = pi * 0.5

    ic      = stacks(1)%current
    RPN_TAN = RPN_STACK_ERROR
    if( ic < 2 ) return
    RPN_TAN = RPN_OPE_ERROR

    do t = 1, stacks(ic)%it
       do k = 1, stacks(ic)%kx
          do j = 1, stacks(ic)%jx
             do i = 1, stacks(ic)%ix
                if( stacks(ic)%val(i,j,k,t) /= stacks(ic)%undef ) then
                   if( mod( stacks(ic)%val(i,j,k,t), pi ) /= pir2 ) then
                      stacks(ic)%val(i,j,k,t) = tan( stacks(ic)%val(i,j,k,t) )
                   else
                      stacks(ic)%val(i,j,k,t) = stacks(ic)%undef
                   end if
                end if
             end do
          end do
       end do
    end do

    RPN_TAN = RPN_NOERROR
    return
  end function RPN_TAN

