program test
  use string
  use RPN
  use ModelInfo
  use namelist
  implicit none

!  type(MINFO) :: MODEL(MaxModelData)
  
  character(len=128) :: NamelistFile, OutFileIn
  character(len=50)  :: operation, average
  integer            :: ip, ie, Type, ierr, ipos, nstr
  real               :: var

  integer :: i, j, k, t, t1, t2, clen, int

  type(RPN_STACK), dimension(RPN_MaxStacks)    :: Stacks
  type(RPN_CONST), dimension(RPN_MaxConstants) :: Constants
  type(RPN_EQN)  , dimension(RPN_MaxEquations) :: Eqns

  ip       = 1

  NamelistFile = 'test.namelist'
  Model_ix = 20
  Model_jx = 20
  Model_kx =  1
  Model_it =  1
  Model_t  =  1
  Model_date = '2004-09-05_18:00:00.0000'
  OutFileIn = ''

  ! read namelist
  call ReadNamelist( 10, NamelistFile )
  RPN_ForceUndef = ForceUndef
  test_sum_skip = abs( test_sum_skip )

  ! open stastic file
  open( ios, file=MinMaxFile, form='formatted' )

  ! read definition files
  ierr = AnalyzeFuncComponent( str_test, '|', OutFileIn, ip, ipos )
  if( ipos == 0 ) then
     ie = len_trim( str_test )
     str_test = str_test(ip:ie) // ''
     ip = 1
     OutFile = OutFileIn
  end if

  write(6,*) trim( OutFile ), ip, ipos, trim( str_test )

  call ToUpper( str_test )
  call ToUpper( OutForm )

  ierr =  RPN_Initialize( Stacks        , RPN_MaxStacks,     &
       &                  Constants     , RPN_MaxConstants,  &
       &                  Eqns          , RPN_MaxEquations,  &
       &                  MaxDefineFiles, ModelInfoFile,     &
       &                  MaxDefineFiles, ConstantFile,      &
       &                  MaxDefineFiles,EquationFile,       &
       &                  CacheMax                           )
  if( ierr /= RPN_NOERROR ) then
     write(6,*) 'RPN INITIALIZE ERROR ( ', ierr, ')'
     stop
  end if

  if( print_env ) then
     call PrintAvailable( Constants, RPN_MaxConstants, &
          &               Eqns     , RPN_MaxEquations  )
     stop
  end if


  if( similarity > 2 ) similarity = 0

  if( similarity < 1 ) then
     if( RPNLog ) then
        open( 7, position='append', file=trim(rpn_log) )
        write(7,'(3a)') trim( str_test ) // ' ' // trim( OutForm )
        close( 7 )
     end if

     ! calculate variables according to RPN description
     if( modelno > MODEL(1)%TotalInfo ) modelno = 1
     Model_it = MODEL(modelno)%it
     if( stime < 1 .or. stime > Model_it ) stime = 1
     if( etime < 1 .or. etime > Model_it ) etime = 1
     if( stime > etime ) etime = stime
     if( tskip == 0 ) tskip = 1
     t1 = stime
     t2 = etime

     clen = len_trim( OutFile )
     if( test_sum == 0 ) then
        do Model_t = t1, t2, tskip
           Model_date = MODEL(modelno)%Tinfo(Model_t)%cdate
           write(6,*) trim( str_test )
           ierr = RPN_CALCULATION( Stacks   , RPN_MaxStacks,    &
                &                  Constants, RPN_MaxConstants, &
                &                  Eqns     , RPN_MaxEquations, &
                &                  str_test                     )
           
           ierr = RPN_CALCULATION( Stacks   , RPN_MaxStacks,    &
                &                  Constants, RPN_MaxConstants, &
                &                  Eqns     , RPN_MaxEquations, &
                &                  OutForm                      )
           
           call RPN_RestartStacks( Stacks, RPN_MaxStacks )
        end do

     else if( test_sum == 1 .or. test_sum == 2 ) then

        do t = t1, t2, tskip
           Model_date = MODEL(modelno)%Tinfo(t)%cdate
           write(6,*) trim( str_test )

           int = max( 1, t-test_sum_times*test_sum_skip+1 )
           do Model_t = t, int, -test_sum_skip
              ierr = RPN_CALCULATION( Stacks   , RPN_MaxStacks,    &
                   &                  Constants, RPN_MaxConstants, &
                   &                  Eqns     , RPN_MaxEquations, &
                   &                  str_test                     )

              if( ierr /= RPN_NOERROR ) stop 9990
              if( Model_t /= t ) then
                 ierr = RPN_CALCULATION( Stacks   , RPN_MaxStacks,    &
                      &                  Constants, RPN_MaxConstants, &
                      &                  Eqns     , RPN_MaxEquations, &
                      &                  'ADD ='                      )
              end if
              if( ierr /= RPN_NOERROR ) stop 9991
           end do

           if( test_sum == 2 ) then
              average = ''
              write(average,'(i,a)') (t-int+1)/test_sum_skip, ' DIV ='
              ierr = RPN_CALCULATION( Stacks   , RPN_MaxStacks,    &
                   &                  Constants, RPN_MaxConstants, &
                   &                  Eqns     , RPN_MaxEquations, &
                   &                  average                      )
              if( ierr /= RPN_NOERROR ) stop 9992
           end if

           ierr = RPN_CALCULATION( Stacks   , RPN_MaxStacks,    &
                &                  Constants, RPN_MaxConstants, &
                &                  Eqns     , RPN_MaxEquations, &
                &                  OutForm                      )
           
           call RPN_RestartStacks( Stacks, RPN_MaxStacks )
        end do

     else if( test_sum == 3 .or. test_sum == 4 ) then
        do Model_t = t1, t2, tskip
           Model_date = MODEL(modelno)%Tinfo(Model_t)%cdate
           write(6,*) trim( str_test )
           
           ierr = RPN_CALCULATION( Stacks   , RPN_MaxStacks,    &
                &                  Constants, RPN_MaxConstants, &
                &                  Eqns     , RPN_MaxEquations, &
                &                  str_test                     )
           if( ierr /= RPN_NOERROR ) stop 9993

           if( Model_t /= t1 ) then
              if( test_sum == 3 ) then
                 ierr = RPN_CALCULATION( Stacks   , RPN_MaxStacks,    &
                      &                  Constants, RPN_MaxConstants, &
                      &                  Eqns     , RPN_MaxEquations, &
                      &                  'COMPBIG ='                  )
              else if( test_sum == 4 ) then
                 ierr = RPN_CALCULATION( Stacks   , RPN_MaxStacks,    &
                      &                  Constants, RPN_MaxConstants, &
                      &                  Eqns     , RPN_MaxEquations, &
                      &                  'COMPSMALL ='                )
              end if
           else
              ierr = RPN_CALCULATION( Stacks   , RPN_MaxStacks,    &
                   &                  Constants, RPN_MaxConstants, &
                   &                  Eqns     , RPN_MaxEquations, &
                   &                  'COPY ='                     )
           end if
        end do

        ierr = RPN_CALCULATION( Stacks   , RPN_MaxStacks,    &
             &                  Constants, RPN_MaxConstants, &
             &                  Eqns     , RPN_MaxEquations, &
             &                  OutForm                      )

        call RPN_RestartStacks( Stacks, RPN_MaxStacks )

     end if

  else
     if(    input_model  > MODEL(1)%TotalInfo .or. &
          & output_model > MODEL(1)%TotalInfo ) then
        write(6,*) 'ERROR: input or output model number is wrong.'
        stop
     end if

     Model_t = -1
     modelno = output_model
     do t = 1, MODEL(output_model)%it
        if( MODEL(output_model)%Tinfo(t)%cdate == output_ctime ) then
           Model_t = t
           exit
        end if
     end do
     if( Model_t < 0 ) then
        write(6,*) 'ERROR: data not found in ', output_ctime
        stop
     end if

     call ToUpper( output_rpn )
     ierr = RPN_CALCULATION( Stacks   , RPN_MaxStacks,    &
          &                  Constants, RPN_MaxConstants, &
          &                  Eqns     , RPN_MaxEquations, &
          &                  output_rpn                    )

     Model_t = -1
     modelno = input_model 
     do t = 1, MODEL(input_model)%it
        if( MODEL(input_model)%Tinfo(t)%cdate == input_ctime ) then
           Model_t = t
           exit
        end if
     end do
     if( Model_t < 0 ) then
        write(6,*) 'ERROR: data not found in ', input_ctime
        stop
     end if

     call ToUpper( input_rpn )
     if( input_sum == 1 .or. input_sum == 2 ) then
        t1 = Model_t
        t2 = max( 1, t1 - input_sum_times + 1 )
        do Model_t = t1, t2, -1
           ierr = RPN_CALCULATION( Stacks   , RPN_MaxStacks,    &
                &                  Constants, RPN_MaxConstants, &
                &                  Eqns     , RPN_MaxEquations, &
                &                  input_rpn                    )
           if( ierr /= RPN_NOERROR ) stop 9990
           if( Model_t /= t ) then
              ierr = RPN_CALCULATION( Stacks   , RPN_MaxStacks,    &
                   &                  Constants, RPN_MaxConstants, &
                   &                  Eqns     , RPN_MaxEquations, &
                   &                  'ADD ='                      )
           end if
           if( ierr /= RPN_NOERROR ) stop 9991
        end do

        if( input_sum == 2 ) then
           average = ''
           write(average,'(i,a)') t2-t1+1, ' DIV ='
           ierr = RPN_CALCULATION( Stacks   , RPN_MaxStacks,    &
                &                  Constants, RPN_MaxConstants, &
                &                  Eqns     , RPN_MaxEquations, &
                &                  average                      )
           if( ierr /= RPN_NOERROR ) stop 9992
        end if
     else
        ierr = RPN_CALCULATION( Stacks   , RPN_MaxStacks,    &
             &                  Constants, RPN_MaxConstants, &
             &                  Eqns     , RPN_MaxEquations, &
             &                  input_rpn                    )
     end if

     if( ierr == RPN_NOERROR ) then
        call CrossSimilarity( Stacks, RPN_MaxStacks )

        ierr = RPN_CALCULATION( Stacks   , RPN_MaxStacks,    &
             &                  Constants, RPN_MaxConstants, &
             &                  Eqns     , RPN_MaxEquations, &
             &                  OutForm                      )
     end if

  end if

!  if( print_env ) then
!     call PrintAvailable( Constants, RPN_MaxConstants, &
!          &               Eqns     , RPN_MaxEquations  )
!  end if

  close( ios )

  stop
end program test
