#!/usr/bin/perl -w

use strict;

my $log = 'rpn_log.txt';
if( @ARGV ){
    $log = shift @ARGV;
}

my %log = ();
my %out = ();
my %unknown = ();
open( LOG, $log );

my $status = 0;  # 0: raw   1: RPN   2:  OUT   3: UNKNOWN
my $sr = 'R P N';
my $so = 'O U T';
my $su = 'U N K N O W N';
while( <LOG> ){
    chomp;

    if( /^\#/ ){
	if( /$sr/i ){
	    $status = 1;
	}elsif( /$so/i ){
	    $status = 2;
	}elsif( /$su/ ){
	    $status = 3;
	}else{
	    $status = 0;
	}
	next;
    }

    if( $status == 0 ){
	my @log = split( /\=/, $_ );
	my $nlog = @log;

	if( $nlog == 2 ){
	    $log{$log[0]}++;
	    $out{$log[1]}++;
	}else{
	    $unknown{$_}++;
	}

    }elsif( $status == 1 ){
	$log{$_}++;
    }elsif( $status == 2 ){
	$out{$_}++;
    }elsif( $status == 3 ){
	$unknown{$_}++;
    }
}
close( LOG );

open( LOG, ">$log" );
print LOG "################################### $sr ################################\n";
foreach my $log ( sort keys %log ){
    $log =~ s/^\s+//;
    print LOG "$log\n";
}

print LOG "################################### $so ################################\n";
foreach my $out ( sort keys %out ){
    $out =~ s/^\s+//;
    print LOG "$out\n";
}

print LOG "############################## $su #############################\n";
foreach my $unknown ( sort keys %unknown ){
    $unknown =~ s/^\s+//;
    print LOG "$unknown\n";
}

print LOG "##########################################################################\n";
close( LOG );

