#!/usr/bin/perl -w

use strict;

my $script = $0;

###############################################################################
my $dir = $script;
if( $script =~ /\// ){
    $script =~ s/(\S+)\/([^\/]+)$/$2/;
    $dir    =~ s/${script}//;
}else{
    my @path = split( /:/, $ENV{'PATH'} );
    my $npath = @path;
    for( my $i = 0 ; $i < $npath ; $i++ ){
	if( -e "$path[$i]/${script}" ){
	    $dir = $path[$i];
	}
    }
}

if( $dir =~ /util\/?$/ ){
    $dir =~ s/util\/?//;
}
if( $dir eq '' ){
    $dir = './';
}
###############################################################################

my $from = $dir;
my $to   = '.';

( @ARGV ) and ( $from = shift @ARGV );
( @ARGV ) and ( $to   = shift @ARGV );

###############################################################################

my $outdir  = "${to}/out";
my $psdir   = "${to}/ps";
unless( -d $outdir  ){ mkdir( $outdir,  0755 ); }
unless( -d $psdir   ){ mkdir( $psdir,   0755 ); }

# Doc directory
my $docdir  = "${to}/Doc";
unless( -d $docdir  ){ mkdir( $docdir,  0755 ); }
if( $from =~ /^\./ ){
    symlink( "../${from}/Doc/technical.pdf", "${docdir}/technical.pdf" );
    symlink( "../${from}/Doc/func.txt"     , "${docdir}/func.txt"      );
    symlink( "../${from}/Doc/rpn.txt"      , "${docdir}/rpn.txt"       );
}else{
    symlink( "${from}/Doc/technical.pdf", "${docdir}/technical.pdf" );
    symlink( "${from}/Doc/func.txt"     , "${docdir}/func.txt"      );
    symlink( "${from}/Doc/rpn.txt"      , "${docdir}/rpn.txt"       );
}

# cpt directory
my $cptdir  = "${to}/cpt";
unless( -d $cptdir  ){ mkdir( $cptdir,  0755 ); }
system( "cp ${from}/cpt/*.cpt ${cptdir}/" );

# def directory
my $defdir  = "${to}/def";
unless( -d $defdir  ){ mkdir( $defdir,  0755 ); }
foreach my $def_file ( qw( constant_math.def
			   constant_physics.def
			   equations_CReSS.def
			   equations_radar_amedas.def
			   level_pressure.def
			   model_geo_info_CReSS.def
			   model_info_CReSS.def
			   radar_amedas.def
			   ) ){
    system( "cp ${from}/def/${def_file} ${defdir}/${def_file}" );
}

# util directory
my $utildir = "${to}/util";
unless( -d $utildir ){ mkdir( $utildir, 0755 ); }
foreach my $util_file ( qw( compact_log.pl
			    make_CReSS_def2.pl
			    make_picture.pl
			    work_mg.pl
			    cress_setup.txt
			    worklist_mg.txt
			    worklist_draw.txt
			   ) ){
    if( $from =~ /^\./ ){
        symlink( "../${from}/util/${util_file}", "${utildir}/${util_file}" );
    }else{
        symlink( "${from}/util/${util_file}", "${utildir}/${util_file}" );
    }
}
foreach my $util_file ( qw( cress_setup.txt
			    worklist_mg.txt
			    worklist_draw.txt
			   ) ){
    system( "cp ${from}/util/${util_file} ${util_file}" );
}

symlink( "${from}/mg"  , "mg"   );
symlink( "${from}/calc", "calc" );

