#!/usr/bin/perl -w

use strict;

my $workdir = '/Area5/cress/FCST2/work/HRK/MG';
my $worklist      = 'worklist.txt';

my $namelist_file = 'test.namelist';
my $exec_file     = '/Area5/cress/FCST2/MG/test';
###############################################################################

if( @ARGV ){
    $workdir = shift @ARGV;
}else{
    print "$0 <workdir> <worklist>\n";
    exit;
}

if( @ARGV ){
    $worklist = shift @ARGV;
}else{
    print "$0 <workdir> <worklist>\n";
    exit;
}

my $namelist = {};
my $common   = {};
my %def      = ();
my @rpn      = ();
my @list     = ();
my $tscheck  = '';
my $techeck  = '';

chdir( $workdir );

###############################################################################
# set default values
&initialize_namelist( \$namelist );

# read work list file
&read_work_list( $worklist, \@list );

# check work list
&check_work_list( \@list, \$common, \@rpn );

###############################################################################
# end time check
if( $techeck ne '' ){
    foreach my $def ( keys %def ){
	if( $techeck =~ /\@${def}\@/ ){
	    $techeck =~ s/\@${def}\@/$def{$def}/g;
	}
    }

#    $common->{etime} = 0;
    my $xsep = 1;
    my $ysep = 1;
    my $etime = 0;
    if( -e $techeck ){
	open( TC, $techeck );
	my $estatus = 0;
	while( <TC> ){
	    chomp;
	    if( $estatus == 0 && /TotalFiles/i ){
		$estatus = 1;
		next;
	    }

	    if( $estatus == 1 && /\/TotalFiles/i ){
		$estatus = 0;
		last;
	    }

	    if( /xsep\s+(\d+)/ ){
		$xsep = $1;
	    }

	    if( /ysep\s+(\d+)/ ){
		$ysep = $1;
	    }

	    if( $estatus == 1 ){
		my @line = split( /\s+/, $_ );
		( shift @line ) if ( $line[0] eq '' );

		if( -e $line[1] ){
		    $etime += $line[0];
		}
	    }
	}
#	$common->{etime} = int( $etime / $xsep / $ysep );
	$etime = int( $etime / $xsep / $ysep );
    }

    if( defined( $common->{etime} ) ){
	foreach my $def ( keys %def ){
	    if( $common->{etime} =~ /\@${def}\@/ ){
		$common->{etime} =~ s/\@${def}\@/$def{$def}/g;
	    }
	}

	if( $common->{etime} > $etime ){
	    $common->{etime} = $etime;
	}
    }else{
	$common->{etime} = $etime;
    }
}

###############################################################################
# start time check
if( $tscheck ne '' ){
    foreach my $def ( keys %def ){
	if( $tscheck =~ /\@${def}\@/ ){
	    $tscheck =~ s/\@${def}\@/$def{$def}/g;
	}
    }

#    unless( defined( $common->{stime} ) ){ $common->{stime} = 1; }
    my $stime = 1;
    while( <${tscheck}*> ){
	$stime++;
#	$common->{stime}++;
    }
    if( defined( $common->{stime} ) ){
	foreach my $def ( keys %def ){
	    if( $common->{stime} =~ /\@${def}\@/ ){
		$common->{stime} =~ s/\@${def}\@/$def{$def}/g;
	    }
	}

	if( $common->{stime} > $common->{etime} ){
	    $common->{stime} = $stime;
	}
    }else{
	$common->{stime} = $stime;
    }
}

###############################################################################
# main loop

my $namelist_backup = $namelist_file . '_' . time;

my $status = 0;
my $key    = '';
my $rpn    = {};
foreach my $line ( @rpn ){
    if( $status == 0 && $line =~ /<RPN>/ ){
	$status = 1;
	$key    = '';
	next;

    }elsif( $status == 1 && $line =~ /<\/RPN>/ ){
	if( $rpn->{MAKE} == 1 ){
	    if( defined( $rpn->{_str_test} ) ){
		&get_str_test( \$rpn );
	    }


	    if( defined( $rpn->{stime} ) &&
		defined( $rpn->{etime} ) ){
		( $status = 0 ) if( $rpn->{stime} > $rpn->{etime} );
	    }elsif( defined( $common->{stime} ) &&
		    defined( $common->{etime} ) ){
		( $status = 0 ) if( $common->{stime} > $common->{etime} );
	    }elsif( defined( $namelist->{stime} ) &&
		    defined( $namelist->{etime} ) ){
		( $status = 0 ) if( $namelist->{stime} > $namelist->{etime} );
	    }
	    
	    if( $status == 1 ){
		if( -e $namelist_file ){
		    rename( $namelist_file, $namelist_backup );
		}

		&make_namelist( $namelist_file, \$namelist, \$common, \$rpn );
		system( $exec_file );
    
		if( -e $namelist_backup ){
		    rename( $namelist_backup, $namelist_file );
		}
	    }
	}

	$status = 0;
	$key    = '';
	$rpn    = {};

    }elsif( $status == 1 && $key eq '' && $line =~ /<([^>]+)>/ ){
	$key = $1;

    }elsif( $status == 1 && $key ne '' && $line =~ /<\/${key}>/ ){
	$key = '';

    }elsif( $status == 1 && $key ne '' ){
	if( $key =~ /^make$/i ){
	    foreach my $def ( keys %def ){
		if( $line =~ /\@${def}\@/ ){
		    $line =~ s/\@${def}\@/$def{$def}/g;
		}
	    }
	    $rpn->{MAKE} = $line;

	}else{
	    &set_work_list( $key, $line, \$rpn );
	}

    }
}

###############################################################################
sub make_namelist{
    my ( $file, $default, $common, $current ) = @_;

    my $out = '';

    open( NML, "> $file" );

    # &rpn_config
    print NML " &rpn_config\n";
    print NML &array_write( 'ConstantFile', 'char',
			    $default, $common, $current );
    print NML &array_write( 'EquationFile', 'char',
			    $default, $common, $current );
    print NML &array_write( 'ModelInfoFile', 'char',
			    $default, $common, $current );
    print NML &array_write( 'LevelInfoFile', 'char',
			    $default, $common, $current );
    print NML &variable_write( 'ForceUndef', 'logical',
			       $default, $common, $current );
    print NML " /\n\n";

    # &read_config
    print NML " &read_config\n";
    print NML &variable_write( 'NoData', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'CacheMax', 'num',
			       $default, $common, $current );
    print NML " /\n\n";

    # &output_config
    print NML " &output_config\n";
    print NML &variable_write( 'OutFile', 'char',
			       $default, $common, $current );
    print NML &variable_write( 'OutForm', 'char',
			       $default, $common, $current );
    print NML &array_write( 'OutKey', 'char',
			    $default, $common, $current );
    print NML &variable_write( 'MinMaxFile', 'char',
			       $default, $common, $current );
    print NML &variable_write( 'RPNLog', 'logical',
			       $default, $common, $current );
    print NML &array_write( 'xp', 'num',
			    $default, $common, $current );
    print NML &array_write( 'yp', 'num',
			    $default, $common, $current );
    print NML &array_write( 'lonp', 'num',
			    $default, $common, $current );
    print NML &array_write( 'latp', 'num',
			    $default, $common, $current );
    print NML &variable_write( 'OutRadius', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'OutSdeg', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'OutEdeg', 'num',
			       $default, $common, $current );
    print NML &array_write( 'OutMinVal', 'num',
			    $default, $common, $current );
    print NML &array_write( 'OutMaxVal', 'num',
			    $default, $common, $current );
    print NML &array_write( 'OutUndef', 'num',
			    $default, $common, $current );
    print NML &variable_write( 'DF3Swap', 'logical',
			       $default, $common, $current );
    print NML &variable_write( 'itpmethod', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'itparg1', 'num',
			       $default, $common, $current );
    print NML " /\n\n";

    # &test_str
    print NML " &test_str\n";
    print NML &array_write( 'order', 'num',
			    $default, $common, $current );
    print NML &variable_write( 'str_test', 'char',
			       $default, $common, $current );
    print NML &variable_write( 'str_test2', 'char',
			       $default, $common, $current );
    print NML &variable_write( 'olev', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'modelno', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'stime', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'etime', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'tskip', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'print_env', 'logical',
			       $default, $common, $current );
    print NML &variable_write( 'test_sum', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'test_sum_times', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'test_sum_skip', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'rpn_log', 'char',
			       $default, $common, $current );
    print NML &variable_write( 'similarity', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'count_ratio', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'input_sum', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'input_sum_times', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'input_model', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'input_ctime', 'char',
			       $default, $common, $current );
    print NML &variable_write( 'input_rpn', 'char',
			       $default, $common, $current );
    print NML &array_write( 'input_wind', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'wind_trans', 'num',
			       $default, $common, $current );
    print NML &array_write( 'wind_tmat', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'output_model', 'num',
			       $default, $common, $current );
    print NML &variable_write( 'output_ctime', 'char',
			       $default, $common, $current );
    print NML &variable_write( 'output_rpn', 'char',
			       $default, $common, $current );
    print NML " /\n";

    close( NML );

}

###############################################################################
sub variable_write{
    my ( $key, $type, $default, $common, $current ) = @_;

    my $out  = " $key = ";

    &extract_define( $current, $key );
    &extract_define( $common, $key );
    &extract_define( $default, $key );

    if( defined( $$current->{$key} ) ){
	if( $type =~ /num/i || $type =~ /log/i ){
	    $out .= "$$current->{$key}\n";
	}elsif( $type =~ /char/i ){
	    $out .= "\'$$current->{$key}\'\n";
	}
    }elsif( defined( $$common->{$key} ) ){
	if( $type =~ /num/i || $type =~ /log/i ){
	    $out .= "$$common->{$key}\n";
	}elsif( $type =~ /char/i ){
	    $out .= "\'$$common->{$key}\'\n";
	}
    }elsif( defined( $$default->{$key} ) ){
	if( $type =~ /num/i || $type =~ /log/i ){
	    $out .= "$$default->{$key}\n";
	}elsif( $type =~ /char/i ){
	    $out .= "\'$$default->{$key}\'\n";
	}
    }else{
	print STDERR "Variable element ( $key ) are not defined\n";
	exit;
    }

    return $out;
}

sub extract_define{
    my ( $list, $key ) = @_;

    return unless( defined( $$list->{$key} ) );

    if( $key eq 'OutForm' && $$list->{$key} =~ /\*/ ){
	unless( defined( $$list->{OutKey} ) ){
	    print STDERR "Please Set <OutKey> if * is set in <OutForm>\n";
	    exit;
	}
	my $nkey = @{$$list->{OutKey}};
	$$list->{$key} =~ s/\*/$nkey/;
    }

    foreach my $def ( keys %def ){
	if( $$list->{$key} =~ /\@${def}\@/ ){
	    $$list->{$key} =~ s/\@${def}\@/$def{$def}/g;
	}
    }
}

###############################################################################
sub array_write{
    my ( $key, $type, $default, $common, $current ) = @_;

    my $out  = " $key = ";
    my $clen = length( $key ) + 3;
    my $spc  = sprintf ( "%${clen}s", '' );

    &extract_define_array( $current, $key );
    &extract_define_array( $common, $key );
    &extract_define_array( $default, $key );

    if( defined( $$current->{$key} ) ){
	my $nlist = @{$$current->{$key}};

	if( $type =~ /char/i ){
	    $out .= "\'$$current->{$key}[0]\'\n";
	    for( my $i = 1 ; $i < $nlist ; $i++ ){
		$out .= "$spc \'$$current->{$key}[$i]\'\n";
	    }
	}elsif( $type =~ /num/i ){
	    $out .= "$$current->{$key}[0]\n";
	    for( my $i = 1 ; $i < $nlist ; $i++ ){
		$out .= "$spc $$current->{$key}[$i]\n";
	    }
	}

    }elsif( defined( $$common->{$key} ) ){
	my $nlist = @{$$common->{$key}};

	if( $type =~ /char/i ){
	    $out .= "\'$$common->{$key}[0]\'\n";
	    for( my $i = 1 ; $i < $nlist ; $i++ ){
		$out .= "$spc \'$$common->{$key}[$i]\'\n";
	    }
	}elsif( $type =~ /num/i ){
	    $out .= "$$common->{$key}[0]\n";
	    for( my $i = 1 ; $i < $nlist ; $i++ ){
		$out .= "$spc $$common->{$key}[$i]\n";
	    }
	}

    }elsif( defined( $$default->{$key} ) ){
	my $nlist = @{$$default->{$key}};

	if( $type =~ /char/i ){
	    $out .= "\'$$default->{$key}[0]\'\n";
	    for( my $i = 1 ; $i < $nlist ; $i++ ){
		$out .= "$spc \'$$default->{$key}[$i]\'\n";
	    }

	}elsif( $type =~ /num/i ){
	    $out .= "$$default->{$key}[0]\n";
	    for( my $i = 1 ; $i < $nlist ; $i++ ){
		$out .= "$spc $$default->{$key}[$i]\n";
	    }
	}

    }else{
	print STDERR "Array elements ( $key ) are not defined\n";
	exit;
    }

    return $out;
}

sub extract_define_array{
    my ( $list, $key ) = @_;

    return unless( defined( $$list->{$key} ) );

    foreach my $def ( keys %def ){
	my $nlist = @{$$list->{$key}};
	for( my $i = 0 ; $i < $nlist ; $i++ ){
	    if( $$list->{$key}[$i] =~ /\@${def}\@/ ){
		$$list->{$key}[$i] =~ s/\@${def}\@/$def{$def}/g;
	    }
	}
    }
}

###############################################################################
sub set_work_list{
    my ( $key, $value, $list ) = @_;

    foreach my $def ( keys %def ){
	if( $value =~ /\@${def}\@/ ){
	    $value =~ s/\@${def}\@/$def{$def}/g;
	}
    }

    if( $key eq 'ConstantFile'  ||
	$key eq 'EquationFile'  ||
	$key eq 'ModelInfoFile' ||
	$key eq 'LevelInfoFile'){

	unless( -e $value ){
	    print "$value not found\n";
	    exit;
	}
	push( @{$$list->{$key}}, $value );
	
    }elsif( $key eq 'OutKey'     ||
	    $key eq 'xp'         ||
	    $key eq 'yp'         ||
	    $key eq 'lonp'       ||
	    $key eq 'latp'       ||
	    $key eq 'order'      ||
	    $key eq 'input_wind' ||
	    $key eq 'wind_tmat'  ||
	    $key eq 'OutMinVal'  ||
	    $key eq 'OutMaxVal'  ||
	    $key eq 'OutUndef'   ){
#	push( @{$$list->{$key}}, $value );
	push( @{$$list->{$key}}, split( /\s+/, $value ) );

    }elsif( $key eq 'NoData'          ||
	    $key eq 'CacheMax'        ||
	    $key eq 'itpmethod'       ||
	    $key eq 'olev'            ||
	    $key eq 'modelno'         ||
	    $key eq 'stime'           ||
	    $key eq 'etime'           ||
	    $key eq 'tskip'           ||
	    $key eq 'test_sum'        ||
	    $key eq 'test_sum_times'  ||
	    $key eq 'test_sum_skip'   ||
	    $key eq 'similarity'      ||
	    $key eq 'input_sum'       ||
	    $key eq 'input_sum_times' ||
	    $key eq 'input_model'     ||
	    $key eq 'wind_trans'      ||
	    $key eq 'output_model'
	    ){
	$$list->{$key} = int( $value );

    }elsif( $key eq 'OutFile'      ||
	    $key eq 'OutForm'      ||
	    $key eq 'MinMaxFile'   ||
	    $key eq 'OutRadius'    ||
	    $key eq 'OutSdeg'      ||
	    $key eq 'OutEdeg'      ||
	    $key eq 'itparg1'      ||
	    $key eq 'rpn_log'      ||
	    $key eq 'count_ratio'  ||
	    $key eq 'input_ctime'  ||
	    $key eq 'input_rpn'    ||
	    $key eq 'output_ctime' ||
	    $key eq 'output_rpn'   ){
	$$list->{$key} = $value;

    }elsif( $key eq 'ForceUndef' ||
	    $key eq 'RPNLog'     ||
	    $key eq 'print_env'  ||
	    $key eq 'DF3Swap'    ){
	if( $value =~ /t/i ){
	    $$list->{$key} = '.true.';
	}elsif( $value =~ /f/i ){
	    $$list->{$key} = '.false.';
	}
	
    }elsif( $key eq 'str_test' ||
	    $key eq 'str_test2' ){
	if( defined( $$list->{_str_test} ) ){
	    $$list->{_str_test} .= " $value";
	}else{
	    $$list->{_str_test} = $value;
	}

    }elsif( $key eq 'exec_file' ){
	$value =~ /(\S+)/;
	my $check = $1;
	if( -e $check ){
	    $exec_file = $value;
	}else{
	    print "$exec_file is not found.\n";
	    exit;
	}
    }

}

###############################################################################
sub check_work_list{
    my ( $list, $common, $rpn ) = @_;

    my $nlist = @$list;
    my $key   = '';
    for( my $i = 0 ; $i < $nlist ; $i++ ){
	if( $key eq '' && $$list[$i] =~ /<([^>]+)>/ ){
	    $key = $1;

	    ( $key eq 'RPN' ) and ( push( @$rpn, $$list[$i] ) );
	    next;

	}elsif( $$list[$i] =~ /<\/${key}>/ ){
	    ( $key eq 'RPN' ) and ( push( @$rpn, $$list[$i] ) );
	    
	    $key = '';
	    next;

	}

	if( $key eq 'RPN' ){ 
	    push( @$rpn, $$list[$i] );

	}elsif( $key ne '' && $$list[$i] !~ /(<|>)/ ){
	    &set_work_list( $key, $$list[$i], $common );

	}
	
    }

    if( defined( $$common->{_str_test} ) ){
	&get_str_test( $common );
    }
}

###############################################################################
sub get_str_test{
    my ( $list ) = @_;

    my $value = $$list->{_str_test};

    foreach my $def ( keys %def ){
	if( $value =~ /\@${def}\@/ ){
	    $value =~ s/\@${def}\@/$def{$def}/g;
	}
    }

    my $clen = length( $value );
    if( $clen > 256 ){
	for( my $i = 255 ; $i > 128 ; $i-- ){
#	    print "HOGE : $i ", substr( $value, $i, 1 ), "\n";
	    next unless ( substr( $value, $i, 1 ) eq ']' );

	    $$list->{str_test2} = substr( $value, $i+1, $clen );
	    $$list->{str_test}  = substr( $value,    0, $i+1  );
	    last;
	}
    }else{
	$$list->{str_test} = $value;
    }
    
    undef $$list->{_str_test};
}

###############################################################################
sub read_work_list{
    my ( $worklist, $list, $lv ) = @_;
    my $MaxNestLevel = 5;

    no strict "refs";

    unless( defined( $lv ) ){ $lv = 0; }

    $lv++;
    return if( $lv > $MaxNestLevel );

    my $fh = 'LST' . $lv;
    open( $fh, $worklist ) || die "$worklist \n";
    while( <$fh> ){
	chomp;

	if( /^\#include\s+(\S+)/ ){
	    &read_work_list( $1, $list, $lv );
	    next;
	}elsif( /^\#def\s+(\S+)\s+(.*)$/ ){
	    $def{$1} = $2;
	}elsif( /^\#tscheck\s+(\S+)/ ){
	    $tscheck = $1;
	}elsif( /^\#techeck\s+(\S+)/ ){
	    $techeck = $1;
	}

	s/([^\#]*)\#.*$/$1/;
	next unless ( /\S/ );

	if( />/ ){
	    s/>/>\n/g;
	    s/</\n</g;
	    s/\n\n/\n/g;
	    foreach my $line ( split( /\n/, $_ ) ){
		next unless ( $line =~ /\S/ );
		push( @{$list}, $line );
	    }
	}else{
	    s/^\s+//;
	    s/\s+$//;
	    push( @{$list}, $_ );
	}
    }
    close( $fh );
}

###############################################################################
sub initialize_namelist{
    my ( $namelist ) = @_;

    ###########################################################################
    # &rpn_config
    # ConstantFile
    push( @{$$namelist->{ConstantFile}}, 'def/constant_math.def' );
    push( @{$$namelist->{ConstantFile}}, 'def/constant_physics.def' );

    # EquationFile
    push( @{$$namelist->{EquationFile}}, 'def/equations_CReSS.def' );
    push( @{$$namelist->{EquationFile}}, 'def/equations_radar_amedas.def' );

    # ModelInfoFile
    push( @{$$namelist->{ModelInfoFile}}, 'def/model_info_CReSS.def' );
    push( @{$$namelist->{ModelInfoFile}}, 'def/model_geo_info_CReSS_parallel.def' );
    push( @{$$namelist->{ModelInfoFile}}, 'def/radar_amedas.def' );

    # LevelInfoFile
    push( @{$$namelist->{LevelInfoFile}}, 'def/level_pressure.def' );

    # ForceUndef
    $$namelist->{ForceUndef} = '.true.';

    ###########################################################################
    # &read_config
    # NoData
    $$namelist->{NoData} = -1;

    # CacheMax
    $$namelist->{CacheMax} = 20;

    ###########################################################################
    # &output_config
    # OutFile
    $$namelist->{OutFile} = 'out/z_%d.txt';

    # OutForm
    $$namelist->{OutForm} = 'FUNC(OUTPUT,TEXT,H2D,1,1) =';

    # OutKey
    push( @{$$namelist->{OutKey}}, 'out' );

    # OutMinval
    push( @{$$namelist->{OutMinVal}}, 0. );

    # OutMaxval
    push( @{$$namelist->{OutMaxVal}}, 100. );

    # OutUndef
    push( @{$$namelist->{OutUndef}}, 255. );

    # DF3Swap
    $$namelist->{DF3Swap} = '.true.';

    # MinMaxFile
    $$namelist->{MinMaxFile} = 'mg_output_stat.txt';

    # RPNLog
    $$namelist->{RPNLog} = '.false.';

    # xp
    push( @{$$namelist->{xp}}, -999. );

    # yp
    push( @{$$namelist->{yp}}, -999. );

    # lonp
    push( @{$$namelist->{lonp}}, -999. );

    # latp
    push( @{$$namelist->{latp}}, -999. );

    # OutRadius
    $$namelist->{OutRadius} = 300000.;

    # OutSdeg
    $$namelist->{OutSdeg} = 0.;

    # OutEdeg
    $$namelist->{OutEdeg} = 360.;

    # itpmethod
    $$namelist->{itpmethod} = 1;

    # itparg1
    $$namelist->{itparg1} = 2.;

    ###########################################################################
    # &test_str
    # order
    push( @{$$namelist->{order}}, '1, 2, 3, 4, 5, 6, 7, 8, 9, 10' );
    push( @{$$namelist->{order}}, '1, 2, 3, 4, 5, 6, 7, 8, 9, 10' );
    push( @{$$namelist->{order}}, '1, 2, 3, 4, 5, 6, 7, 8, 9, 10' );
    push( @{$$namelist->{order}}, '1, 2, 3, 4, 5, 6, 7, 8, 9, 10' );
    push( @{$$namelist->{order}}, '1, 2, 3, 4, 5, 6, 7, 8, 9, 10' );

    # str_test
    $$namelist->{str_test} = '';

    # str_test2
    $$namelist->{str_test2} = '';

    # olev
    $$namelist->{olev} = 1;

    # modelno
    $$namelist->{modelno} = 1;

    # stime
    $$namelist->{stime} = 1;

    # etime
    $$namelist->{etime} = 1;

    # tskip
    $$namelist->{tskip} = 1;

    # print_env
    $$namelist->{print_env} = '.false.';

    # test_sum
    $$namelist->{test_sum} = 0;

    # test_sum_times
    $$namelist->{test_sum_times} = 3;

    # test_sum_skip
    $$namelist->{test_sum_skip} = 1;

    # rpm_log
    $$namelist->{rpn_log} = 'rpn_log.txt';

    # similarity
    $$namelist->{similarity} = 0;

    # count_ratio
    $$namelist->{count_ratio} = 0.75;

    # input_sum
    $$namelist->{input_sum} = 0;

    # input_sum_times
    $$namelist->{input_sum_times} = 1;

    # input_model
    $$namelist->{input_model} = 1;

    # input_ctime
    $$namelist->{input_ctime} = '2004-09-06_00:00:00.0000';

    # input_rpn
    $$namelist->{input_rpn} = '[PS] 0.01 MUL [TER] FUNC(MASK,12,0,undef,undef) =';

    # input_wind
    @{$$namelist->{input_wind}} = qw( 20 20 30 30 );

    # wind_trans
    $$namelist->{wind_trans} = 0;
    
    # wind_tmat
    @{$$namelist->{wind_tmat}} = qw( 0 );

    # output_model
    $$namelist->{output_model} = 1;

    # output_ctime
    $$namelist->{output_ctime} = '2004-09-05_18:00:00.0000';

    # output_rpn
    $$namelist->{output_rpn} = '[PS] 0.01 MUL [TER] FUNC(MASK,12,0,undef,undef) =';

}

exit;

my $out_dir = 'out_4km';
my $RPN_grd = "\'${out_dir}/%k_%d.grd | [QC] [V] [U] [QV] 1000 MUL [HGT] FUNC(GLEV2,500,4) FUNC(AGRID,2,10,4) [THE] [V] [U] [P] 0.01 MUL [HGT] FUNC(GLEV2,3000,4) FUNC(AGRID,2,10,4) [THE] [V] [U] [P] 0.01 MUL [HGT] FUNC(GLEV2,5000,4) FUNC(AGRID,2,10,4) [RI] [TER] [RI] FUNC(MASK,12,0,UNDEF,0,1) NEG ADD [PSLV] FUNC(AGRID,2,5,1) [US] [VS] = \'";

my $clen = length( $RPN_grd );

my $RPN2;
if( length( $RPN_grd ) > 256 ){
    for( my $i = 240 ; $i < 255 ; $i++ ){
	if( substr( $RPN_grd, $i, 1 ) eq ']' ){
	    $RPN2 = "\'" . substr( $RPN_grd, $i+1, length( $RPN_grd ) );
	    $RPN_grd  = substr( $RPN_grd, 0   , $i+1            ) . "\'";
	    last;
	}
    }
}


__END__

 &rpn_config
 ! CReSS test
 ConstantFile  = @ConstantFile@
 EquationFile  = @EquationFile@
 ModelInfoFile = @ModelInfoFile@
 ForceUndef    = @ForceUndef@
 LevelInfoFile = @LevelInfoFile@
 /

 &read_config
 NoData   = @NoData@
 CacheMax = @CacheMax@
 /

 &output_config
 OutFile    = @OutFile@
 OutForm    = @OutForm@
 OutKey     = @OutKey@
 MinMaxFile = @MinMaxFile@
 RPNLog     = @RPNLog@
 xp         = @xp@
 yp         = @yp@
 lonp       = @lonp@
 latp       = @latp@
 OutRadius  = @OutRadius@
 OutSdeg    = @OutSdeg@
 OutEdeg    = @OutEdeg@
 OutMinVal  = @OutMinVal@
 OutMaxVal  = @OutMaxVal@
 OutUndef   = @OutUndef@
 DF3Swap    = @DF3Swap@
 itpmethod  = @itpmethod@
 itparg1    = @itparg1@
 /

 &test_str
 order     = @order@
 str_test  = @str_test@
 str_test2 = @str_test2@
 olev      = @olev@
 modelno   = @modelno@
 stime     = @stime@
 etime     = @etime@
 tskip     = @tskip@
 print_env = @print_env@
 test_sum       = @test_sum@
 test_sum_times = @test_sum_times@
 test_sum_skip  = @test_sum_skip@
 rpn_log      = @rpn_log@
 similarity   = @similarity@
 count_ratio  = @count_ratio@
 input_sum    = @input_sum@
 input_sum_times = @input_sum_times@
 input_model  = @input_model@
 input_ctime  = @input_ctime@
 input_rpn    = @input_rpn@
 input_wind   = @input_wind@
 wind_trans   = @wind_trans@
 wind_tmat    = @wind_tmat@
 output_model = @output_model@
 output_ctime = @output_ctime@
 output_rpn   = @output_rpn@
 /

